package com.landray.kmss.sys.attachment.actions;

import com.landray.kmss.web.config.IActionConfig;
import com.landray.kmss.web.config.ForwardConfig;
import com.landray.kmss.util.IDGenerator;
import com.landray.kmss.sys.attachment.integrate.wps.interfaces.ISysAttachmentWpsCenterOfficeProvider;
import com.landray.kmss.sys.filestore.scheduler.third.wps.WpsUtil;
import com.landray.kmss.sys.attachment.util.SysAttPicUtils;
import com.landray.kmss.sys.language.utils.SysLangUtil;
import com.landray.kmss.common.forms.IExtendForm;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import com.landray.kmss.sys.attachment.plugin.wpsAddons.util.SysAttachmentWpsAddonsLockUtils;
import com.landray.kmss.sys.attachment.model.SysAttachmentWps;
import com.landray.kmss.sys.cache.redis.SerializeUtils;
import com.landray.kmss.sys.cache.redis.RedisCommands;
import com.landray.kmss.util.DbUtils;
import com.landray.kmss.sys.cache.redis.RedisConfig;
import org.apache.commons.lang3.ArrayUtils;
import com.landray.kmss.util.CriteriaUtil;
import com.landray.kmss.util.CriteriaValue;
import java.nio.charset.StandardCharsets;
import java.math.BigDecimal;
import com.sunbor.web.tag.Page;
import net.sf.json.JSONArray;
import com.landray.kmss.util.ModelUtil;
import com.landray.kmss.sys.authentication.user.KMSSUser;
import com.landray.kmss.sys.attachment.io.RandomAccessFileInputStream;
import java.io.RandomAccessFile;
import com.landray.kmss.sys.attachment.util.SysAttCryptUtil;
import java.sql.Blob;
import java.io.FileOutputStream;
import org.apache.commons.lang.RandomStringUtils;
import java.text.SimpleDateFormat;
import com.landray.kmss.util.FileTypeUtil;
import org.apache.commons.codec.binary.Base64;
import com.landray.kmss.common.test.TimeCounter;
import com.landray.kmss.sys.filestore.location.model.SysFileSignature;
import com.landray.kmss.sys.filestore.location.model.SysFileSignatureRequest;
import com.landray.kmss.sys.attachment.model.SysAttRtfData;
import com.landray.kmss.sys.filestore.location.interfaces.ISysFileLocationDirectService;
import com.landray.kmss.sys.attachment.integrate.suwell.util.SysAttSuwellUtil;
import edu.emory.mathcs.backport.java.util.Arrays;
import com.landray.kmss.sys.attachment.util.SysAttConstant;
import com.landray.kmss.sys.attachment.integrate.yozo.SysAttYozoUtil;
import com.landray.kmss.sys.attachment.thirdSfs.util.SysAttThirdProxyUtil;
import com.landray.kmss.sys.log.util.oper.UserOperContentHelper;
import com.landray.kmss.sys.log.util.UserOperHelper;
import java.util.Date;
import com.landray.kmss.web.upload.FormFile;
import java.util.Map;
import java.io.UnsupportedEncodingException;
import com.landray.kmss.common.model.BaseCoreInnerModel;
import com.landray.kmss.framework.plugin.core.config.IExtension;
import com.landray.kmss.framework.service.plugin.Plugin;
import com.landray.kmss.sys.attachment.interfaces.ISysAttachmentTransmissionProvider;
import com.landray.kmss.common.exception.UnexpectedRequestException;
import org.apache.tools.zip.ZipEntry;
import org.apache.tools.zip.ZipOutputStream;
import com.landray.kmss.util.MD5Util;
import java.net.URLEncoder;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsoaassistUtil;
import com.landray.kmss.sys.mobile.util.MobileUtil;
import com.landray.kmss.sys.attachment.ocx.SysAttOcxUtil;
import com.landray.kmss.sys.filestore.location.interfaces.ISysFileLocationProxyService;
import com.landray.kmss.sys.filestore.model.SysAttFile;
import com.landray.kmss.util.ResourceUtil;
import com.landray.kmss.sys.filestore.location.util.SysFileLocationUtil;
import com.landray.kmss.sys.filestore.model.SysFileConvertQueue;
import com.landray.kmss.common.dao.HQLInfo;
import com.landray.kmss.sys.attachment.io.BigFileInfo;
import java.nio.channels.FileChannel;
import com.landray.kmss.common.model.IBaseModel;
import com.landray.kmss.sys.filestore.model.SysFileViewerParam;
import com.landray.kmss.util.KmssReturnPage;
import java.io.Closeable;
import org.apache.commons.io.IOUtils;
import com.landray.kmss.sys.attachment.model.SysAttBase;
import com.landray.kmss.common.actions.RequestContext;
import org.apache.commons.beanutils.BeanUtils;
import com.landray.kmss.sys.attachment.forms.SysAttMainForm;
import com.landray.kmss.sys.attachment.io.DecryptionInputStream;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsCenterUtil;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsWebOfficeUtil;
import com.landray.kmss.util.UserUtil;
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.lang3.StringUtils;
import com.landray.kmss.sys.filestore.util.SysFileStoreUtil;
import com.landray.kmss.sys.attachment.util.JgWebOffice;
import com.landray.kmss.sys.attachment.plugin.customPage.util.SysAttCustomPageUtil;
import javax.servlet.http.Cookie;
import java.io.InputStream;
import com.landray.kmss.sys.attachment.io.IOUtil;
import java.io.FileInputStream;
import com.landray.kmss.sys.attachment.util.AttImageUtils;
import com.landray.kmss.util.FileMimeTypeUtil;
import java.io.File;
import com.landray.kmss.sys.config.loader.ConfigLocationsUtil;
import com.landray.kmss.util.KmssMessage;
import com.landray.kmss.util.KmssMessages;
import java.io.OutputStream;
import com.landray.kmss.sys.attachment.util.SysAttUtil;
import org.apache.commons.io.FilenameUtils;
import java.util.Iterator;
import com.landray.kmss.util.ArrayUtil;
import com.landray.kmss.sys.attachment.util.SysAttViewerUtil;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsCloudUtil;
import com.landray.kmss.sys.attachment.util.SysAttConfigUtil;
import java.util.Collection;
import java.util.List;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import com.landray.kmss.sys.attachment.dao.ISysAttMainCoreInnerDao;
import org.json.simple.JSONObject;
import java.util.ArrayList;
import com.landray.kmss.web.action.ActionForward;
import javax.servlet.http.HttpServletResponse;
import com.landray.kmss.web.action.ActionForm;
import com.landray.kmss.web.action.ActionMapping;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.common.service.IBaseService;
import javax.servlet.http.HttpServletRequest;
import org.slf4j.LoggerFactory;
import com.landray.kmss.sys.filestore.service.ISysFileConvertQueueService;
import com.landray.kmss.sys.filestore.service.ISysAttUploadService;
import com.landray.kmss.sys.attachment.integrate.wps.interfaces.ISysAttachmentWpsAddinProvider;
import com.landray.kmss.sys.attachment.integrate.foxit.ISysAttachmentFoxitProvider;
import com.landray.kmss.sys.attachment.service.ISysAttMainFoxitService;
import com.landray.kmss.sys.attachment.service.ISysAttachmentWpsService;
import com.landray.kmss.sys.attachment.service.ISysAttDownloadLogService;
import com.landray.kmss.sys.print.interfaces.ISysPrintLogCoreService;
import com.landray.kmss.sys.attachment.service.ISysAttToggleService;
import java.util.HashMap;
import org.slf4j.Logger;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import com.landray.kmss.common.actions.ExtendAction;

public class SysAttMainAction extends ExtendAction
{
    protected ISysAttMainCoreInnerService sysAttMainService;
    private static final Logger logger;
    private static HashMap providerMap;
    private static final String WPS_OASISST_REDIS_KEY = "wps_oasisst_redis_";
    private static final String WPS_OASISST_LPATOKEN = "wps_oasisst_token_";
    private static final String WPS_WEB_DOCUMENT_HEART = "480";
    private static final String WPS_DOCUMENT_LIFE = "600";
    protected ISysAttToggleService sysAttToggleService;
    protected ISysPrintLogCoreService sysPrintLogCoreService;
    protected ISysAttDownloadLogService sysAttDownloadLogService;
    private ISysAttachmentWpsService sysAttachmentWpsService;
    protected ISysAttMainFoxitService sysAttMainFoxitService;
    private ISysAttachmentFoxitProvider sysAttachmentFoxitProvider;
    private String fileLimitType;
    private String disabledFileType;
    private ISysAttachmentWpsAddinProvider sysAttachmentWpsAddinProvider;
    private ISysAttUploadService sysAttUploadService;
    private ISysFileConvertQueueService queueService;
    
    static {
        logger = LoggerFactory.getLogger(SysAttMainAction.class);
    }
    
    public SysAttMainAction() {
        this.sysAttachmentFoxitProvider = null;
        this.fileLimitType = "1";
        this.disabledFileType = ".js;.bat;.exe;.sh;.cmd;.jsp;.jspx";
        this.sysAttUploadService = null;
        this.queueService = null;
    }
    
    protected ISysAttMainCoreInnerService getServiceImp(final HttpServletRequest request) {
        if (this.sysAttMainService == null) {
            this.sysAttMainService = (ISysAttMainCoreInnerService)this.getBean("sysAttMainService");
        }
        return this.sysAttMainService;
    }
    
    protected ISysAttToggleService getSysAttToggleService() {
        if (this.sysAttToggleService == null) {
            this.sysAttToggleService = (ISysAttToggleService)this.getBean("sysAttToggleService");
        }
        return this.sysAttToggleService;
    }
    
    public ISysPrintLogCoreService getSysPrintLogCoreService() {
        if (this.sysPrintLogCoreService == null) {
            this.sysPrintLogCoreService = (ISysPrintLogCoreService)this.getBean("sysPrintLogCoreService");
        }
        return this.sysPrintLogCoreService;
    }
    
    public ISysAttDownloadLogService getSysAttDownloadLogService() {
        if (this.sysAttDownloadLogService == null) {
            this.sysAttDownloadLogService = (ISysAttDownloadLogService)this.getBean("sysAttDownloadLogService");
        }
        return this.sysAttDownloadLogService;
    }
    
    public IBaseService getSysAttachmentWpsServiceImp(final HttpServletRequest request) {
        if (this.sysAttachmentWpsService == null) {
            this.sysAttachmentWpsService = (ISysAttachmentWpsService)this.getBean("sysAttachmentWpsService");
        }
        return (IBaseService)this.sysAttachmentWpsService;
    }
    
    public ISysAttMainFoxitService getSysAttMainFoxitService() {
        if (this.sysAttMainFoxitService == null) {
            this.sysAttMainFoxitService = (ISysAttMainFoxitService)this.getBean("sysAttMainFoxitService");
        }
        return this.sysAttMainFoxitService;
    }
    
    private ISysAttachmentFoxitProvider getSysAttachmentFoxitProvider() {
        if (this.sysAttachmentFoxitProvider == null) {
            this.sysAttachmentFoxitProvider = (ISysAttachmentFoxitProvider)SpringBeanUtil.getBean("foxitProvider");
        }
        return this.sysAttachmentFoxitProvider;
    }
    
    private ISysAttachmentWpsAddinProvider getSysAttachmentWpsAddinProvider() {
        if (this.sysAttachmentWpsAddinProvider == null) {
            this.sysAttachmentWpsAddinProvider = (ISysAttachmentWpsAddinProvider)this.getBean("sysAttachmentWpsAddinProviderImp");
        }
        return this.sysAttachmentWpsAddinProvider;
    }
    
    public ActionForward buildHtmlComplete(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception, Throwable {
        List<String> rtnList = new ArrayList<String>();
        final List<String> fdFileIds = new ArrayList<String>();
        final List<String> fdAttMainIds = new ArrayList<String>();
        List<String> fileIds = new ArrayList<String>();
        List<String> mainIds = new ArrayList<String>();
        final String modelName = request.getParameter("fdModelName");
        final String modelId = request.getParameter("fdModelId");
        final JSONObject jsonObject = new JSONObject();
        final List<SysAttMain> attList = ((ISysAttMainCoreInnerDao)this.getServiceImp(request).getBaseDao()).findAttListByModel(modelName, modelId);
        for (final SysAttMain sysAttMain : attList) {
            if (StringUtil.isNotNull(sysAttMain.getFdFileId())) {
                fdFileIds.add(sysAttMain.getFdFileId());
            }
            else {
                fdAttMainIds.add(sysAttMain.getFdId());
            }
        }
        if (fdFileIds.size() > 0) {
            final String sql = "select DISTINCT fd_file_id from sys_file_viewer_param where fd_file_id in (:list)";
            fileIds = this.getServiceImp(request).getAttIds((List)fdFileIds, sql, (String)null);
        }
        if (fdAttMainIds.size() > 0) {
            final String sql = "select DISTINCT fd_attmain_id from sys_file_viewer_param where fd_file_id in (:list)";
            mainIds = this.getServiceImp(request).getAttIds((List)fdAttMainIds, sql, (String)null);
        }
        if (fileIds.size() > 0) {
            final String attSql = "select fd_id from sys_att_main where fd_model_name=:modelName and fd_file_id in (:fileIds)";
            rtnList = this.getServiceImp(request).getAttIds((List)fileIds, attSql, modelName);
        }
        if (mainIds.size() > 0) {
            if (rtnList.size() > 0) {
                mainIds.removeAll(rtnList);
            }
            rtnList.addAll(mainIds);
        }
        if (SysAttConfigUtil.thirdDianjuEnabled() || SysAttConfigUtil.thirdWpsCenterV6Enabled() || SysAttConfigUtil.isYozoPreviewEnabled() || SysAttConfigUtil.isSuWellPreviewEnabled() || SysAttConfigUtil.thirdFoxitEnabled() || SysAttConfigUtil.thirdWpsCenterEnabled() || SysAttWpsCloudUtil.isEnable() || SysAttWpsCloudUtil.checkWpsPreviewIsLinux() || SysAttWpsCloudUtil.checkWpsPreviewIsWindows()) {
            final List<String> wpsList = new ArrayList<String>();
            for (final SysAttMain sysAttMain2 : attList) {
                final String previewType = SysAttViewerUtil.getPreView(sysAttMain2, false);
                if (SysAttConfigUtil.thirdDianjuEnabled() || SysAttConfigUtil.thirdWpsCenterV6Enabled() || SysAttConfigUtil.isYozoPreviewEnabled() || SysAttConfigUtil.isSuWellPreviewEnabled() || SysAttConfigUtil.thirdFoxitEnabled() || SysAttConfigUtil.thirdWpsCenterEnabled() || "linux".equals(previewType) || "window".equals(previewType) || "cloud".equals(previewType) || rtnList.contains(sysAttMain2.getFdId())) {
                    wpsList.add(sysAttMain2.getFdId());
                }
            }
            if (!ArrayUtil.isEmpty((List)wpsList)) {
                rtnList = new ArrayList<String>();
                rtnList.addAll(wpsList);
            }
        }
        final StringBuffer buffer = new StringBuffer();
        for (final String id : rtnList) {
            buffer.append(String.valueOf(id) + ",");
        }
        final String ids = buffer.toString();
        jsonObject.put((Object)"fdAttHtmlIds", (Object)ids);
        response.getWriter().print(jsonObject);
        return null;
    }
    
    private List<SysAttMain> getAttMains(final HttpServletRequest request) throws Exception {
        final String fdId = request.getParameter("fdId");
        List<SysAttMain> sysAttMains = null;
        if (fdId != null && fdId.trim().length() > 0) {
            final String[] l_fdId = fdId.split(";");
            sysAttMains = this.getServiceImp(request).findModelsByIds(l_fdId);
        }
        if ((SysAttWpsCloudUtil.isEnable() || SysAttWpsCloudUtil.isEnable(this.isMobileRequest(request))) && !ArrayUtil.isEmpty((List)sysAttMains)) {
            for (final SysAttMain sysAttMain : sysAttMains) {
                if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(sysAttMain.getFdFileName()))) {
                    final Boolean isAutoSave = SysAttWpsCloudUtil.checkWpsCloueAutoSaveByModelName(sysAttMain.getFdModelName());
                    if (!isAutoSave) {
                        continue;
                    }
                    SysAttWpsCloudUtil.updateAttByMainId(sysAttMain.getFdId());
                }
            }
        }
        return sysAttMains;
    }
    
    private void printAttIsNull(final HttpServletRequest request, final HttpServletResponse response, final OutputStream out, final KmssMessages messages) throws Exception {
        String filename = "default_pic.jpg";
        String style = "default";
        String _style = request.getParameter("s_css");
        if (_style == null || _style.trim().length() == 0) {
            final Cookie[] cookies = request.getCookies();
            if (cookies != null) {
                for (int i = 0; i < cookies.length; ++i) {
                    final String cookieName = cookies[i].getName();
                    if ("KMSS_Style".equals(cookieName)) {
                        _style = cookies[i].getValue();
                        break;
                    }
                }
            }
        }
        if (_style != null && _style.trim().length() > 0) {
            style = _style;
        }
        long fileSize = 0L;
        String fileContentType = "";
        messages.addError(new KmssMessage("Key not found."));
        String defaultFile = request.getParameter("default");
        if (defaultFile == null || defaultFile.trim().length() == 0) {
            defaultFile = "default_pic.jpg";
        }
        final String filePath = String.valueOf(ConfigLocationsUtil.getWebContentPath()) + "/resource/style/" + style + "/attachment/" + filename;
        final File file = new File(filePath);
        fileSize = file.length();
        filename = this.encodeFileName(request, defaultFile);
        fileContentType = FileMimeTypeUtil.getContentType(file);
        response.reset();
        if (AttImageUtils.cacheConsulation(request, response, fileContentType, filename)) {
            return;
        }
        response.setContentLength((int)fileSize);
        response.setContentType(fileContentType);
        response.setHeader("Content-Disposition", "filename=\"" + filename + "\"");
        IOUtil.write((InputStream)new FileInputStream(file), out);
        response.flushBuffer();
    }
    
    private void streamClose(InputStream in, OutputStream out) {
        try {
            if (in != null) {
                in.close();
                in = null;
            }
            if (out != null) {
                out.close();
                out = null;
            }
        }
        catch (final Exception e) {
            SysAttMainAction.logger.debug("流关闭错误，错误信息", e);
        }
    }
    
    public ActionForward readDownload(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        OutputStream out = null;
        InputStream in = null;
        String open = null;
        boolean isDownload = false;
        boolean isImage = false;
        String useBrowserOpen = request.getParameter("useBrowserOpen");
        if (StringUtil.isNull(useBrowserOpen)) {
            useBrowserOpen = "false";
        }
        final List<SysAttMain> attMains = this.getAttMains(request);
        if (attMains == null || attMains.isEmpty()) {
            out = (OutputStream)response.getOutputStream();
            this.printAttIsNull(request, response, out, messages);
        }
        else {
            final SysAttMain sysAttMain = attMains.get(0);
            if (StringUtil.isNotNull(sysAttMain.getFdContentType()) && sysAttMain.getFdContentType().contains("image")) {
                isImage = true;
            }
            final boolean isMoblie = this.isMobileRequest(request);
            String previewType = SysAttViewerUtil.getPreView(sysAttMain, isMoblie);
            if (isImage) {
                previewType = "";
            }
            final String actionForwardUrl = SysAttCustomPageUtil.getCustomPage(request);
            if (StringUtil.isNotNull(actionForwardUrl) && !isMoblie && !isImage && !"download".equals(previewType)) {
                return new ActionForward(actionForwardUrl);
            }
            if (SysAttUtil.viewByBrowser(sysAttMain) && "true".equals(useBrowserOpen)) {
                SysAttUtil.outputFile(response, sysAttMain);
                return null;
            }
            if (SysAttConfigUtil.pdfReadByFoxitPC() && JgWebOffice.isPDF(sysAttMain.getFdFileName())) {
                this.getSysAttMainFoxitService().createRequestMateData(request, sysAttMain, Boolean.valueOf(false));
                return mapping.findForward("viewonline_foxit");
            }
            this.commonLogFind(request, sysAttMain, "readDownload");
            if ("0".equals(SysAttConfigUtil.getOnlineToolType()) && !JgWebOffice.isJGPDFEnabled() && !JgWebOffice.isJGPDF2018Enabled() && (JgWebOffice.isPDF(sysAttMain.getFdFileName()) || JgWebOffice.isOFD(sysAttMain.getFdFileName())) && "1".equals(SysAttConfigUtil.getReadOLConfig())) {
                final String convertPath = SysAttViewerUtil.getViewerPath(sysAttMain, SysAttViewerUtil.getConvertedParams(sysAttMain), SysFileStoreUtil.getFileConverters(SysAttViewerUtil.getExtName(sysAttMain.getFdFileName()), sysAttMain.getFdModelName(), SysFileStoreUtil.isOldConvertSuccessUseHTML()), request);
                if (StringUtils.isEmpty(convertPath)) {
                    if ("0".equals(SysAttConfigUtil.isReadPdf())) {
                        return mapping.findForward("viewonline_nopdf");
                    }
                    if ("1".equals(SysAttConfigUtil.isReadPdf())) {
                        isDownload = true;
                        previewType = "download";
                    }
                }
            }
            final ActionForward routeView = this.routeView(mapping, request, response, sysAttMain, out, in);
            if (!isDownload && !isImage && ("true".equals(request.getAttribute("printStream")) || routeView != null)) {
                return routeView;
            }
            if ("download".equals(previewType)) {
                isDownload = true;
            }
            if (!isDownload && (JgWebOffice.isPDF(sysAttMain.getFdFileName()) || JgWebOffice.isOFD(sysAttMain.getFdFileName()))) {
                final boolean attConvertEnable = SysFileStoreUtil.isAttConvertEnable();
                final boolean oldConvertSuccessUseHTMLView = SysFileStoreUtil.isOldConvertSuccessUseHTML();
                String viewerPath = "";
                final String fdAttMainId = request.getParameter("fdId");
                request.setAttribute("fdId", (Object)fdAttMainId);
                String viewType = StringUtil.isNull(request.getParameter("viewType")) ? "html" : request.getParameter("viewType");
                if (attConvertEnable) {
                    SysAttViewerUtil.addQueue(sysAttMain);
                }
                if (JgWebOffice.isOFD(sysAttMain.getFdFileName())) {
                    viewType = "jg";
                }
                if ("jg".equals(viewType)) {
                    return this.viewByJG(mapping, form, request, response, sysAttMain);
                }
                final List<SysFileViewerParam> convertedParamsList = SysAttViewerUtil.getConvertedParams(sysAttMain);
                List<SysFileStoreUtil.FileConverter> fileConverters = null;
                fileConverters = SysFileStoreUtil.getFileConverters(SysAttViewerUtil.getExtName(sysAttMain.getFdFileName()), sysAttMain.getFdModelName(), oldConvertSuccessUseHTMLView);
                if (attConvertEnable && fileConverters.size() == 0) {
                    return new ActionForward("/sys/attachment/viewer/attconvertconfig_not_ok.jsp");
                }
                viewerPath = SysAttViewerUtil.getViewerPath(sysAttMain, (List)convertedParamsList, (List)fileConverters, request);
                if (StringUtil.isNotNull(viewerPath)) {
                    request.setAttribute("fdModelName", (Object)sysAttMain.getFdModelName());
                    final IBaseModel model = this.getServiceImp(request).findByPrimaryKey(sysAttMain.getFdModelId(), (Object)sysAttMain.getFdModelName(), true);
                    if (model != null && PropertyUtils.isReadable((Object)model, "docStatus")) {
                        final String docStatus = (String)PropertyUtils.getProperty((Object)model, "docStatus");
                        if (StringUtil.isNotNull(docStatus)) {
                            request.setAttribute("docStatus", (Object)docStatus);
                        }
                    }
                    final boolean canCopy = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + fdAttMainId, "GET");
                    request.setAttribute("canCopy", (Object)canCopy);
                    final boolean canPrint = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + fdAttMainId, "GET");
                    request.setAttribute("canPrint", (Object)canPrint);
                    return new ActionForward(viewerPath);
                }
                if (JgWebOffice.isJGPDFEnabled() || JgWebOffice.isJGPDF2018Enabled() || SysAttWpsWebOfficeUtil.isEnable() || SysAttWpsCloudUtil.isEnable() || SysAttWpsCenterUtil.isEnable()) {
                    return this.viewByJG(mapping, form, request, response, sysAttMain);
                }
                if ("0".equals(SysAttConfigUtil.isReadPdf())) {
                    return mapping.findForward("viewonline_nopdf");
                }
            }
            if ("linux".equals(previewType)) {
                request.setAttribute("requestUrl", (Object)SysAttWpsCloudUtil.getWpsLinuxPreviewUrl(sysAttMain.getFdId()));
                return mapping.findForward("viewonline_wps_preview");
            }
            if ("window".equals(previewType)) {
                request.setAttribute("requestUrl", (Object)SysAttWpsCloudUtil.getWpsWindowPreviewUrl(sysAttMain.getFdId()));
                return mapping.findForward("viewonline_wps_preview");
            }
            if ("cloud".equals(previewType)) {
                if (!SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMain.getFdId())) {
                    SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMain.getFdId());
                }
                return mapping.findForward("viewonline_wps_cloud");
            }
            if ("converting".equals(previewType)) {
                return mapping.findForward("viewonline_converting");
            }
            if ("0".equals(SysAttConfigUtil.isReadPdf()) && !isDownload && (JgWebOffice.isPDF(sysAttMain.getFdFileName()) || JgWebOffice.isOFD(sysAttMain.getFdFileName()))) {
                return mapping.findForward("viewonline_nopdf");
            }
            FileChannel fileChannel = null;
            try {
                out = (OutputStream)response.getOutputStream();
                in = sysAttMain.getInputStream();
                long fileSize = sysAttMain.getFdSize().longValue();
                long tmpSize = 0L;
                if (in instanceof DecryptionInputStream) {
                    final BigFileInfo bigFileInfo = ((DecryptionInputStream)in).getFileInfo();
                    fileChannel = bigFileInfo.getFileChannel();
                    tmpSize = bigFileInfo.getFileSize();
                }
                else {
                    fileChannel = ((FileInputStream)in).getChannel();
                    tmpSize = fileChannel.size();
                }
                if (tmpSize != fileSize && tmpSize > 0L) {
                    fileSize = tmpSize;
                }
                final String filename = this.encodeFileName(request, sysAttMain.getFdFileName());
                String fileContentType = sysAttMain.getFdContentType();
                response.reset();
                if (fileSize > 0L) {
                    if (fileSize <= 2147483647L) {
                        response.setContentLength((int)fileSize);
                    }
                    else {
                        response.setHeader("Content-Length", String.valueOf(fileSize));
                    }
                }
                response.setContentType(fileContentType);
                final String extName = FilenameUtils.getExtension(filename);
                if ("txt".equals(extName.toLowerCase()) || "html".equals(extName.toLowerCase())) {
                    final String charCode = SysAttUtil.getCharset(in);
                    if (StringUtil.isNotNull(charCode)) {
                        response.setCharacterEncoding(charCode);
                    }
                }
                response.setHeader("Pragma", "public");
                open = request.getParameter("open");
                if (StringUtil.isNotNull(open) && fileContentType.indexOf("pdf") > -1) {
                    final SysAttMainForm sysAttMainForm = new SysAttMainForm();
                    BeanUtils.copyProperties((Object)sysAttMainForm, (Object)sysAttMain);
                    request.setAttribute("sysAttMainForm", (Object)sysAttMainForm);
                    final boolean isJGPDFEnabled = JgWebOffice.isJGPDFEnabled();
                    final String fdFileName = sysAttMain.getFdFileName();
                    if (JgWebOffice.isPDF(fdFileName)) {
                        if (isJGPDFEnabled) {
                            return mapping.findForward("viewonline_pdf");
                        }
                        out = (OutputStream)response.getOutputStream();
                        fileContentType = FileMimeTypeUtil.getContentType(filename);
                        if (StringUtil.isNull(fileContentType)) {
                            fileContentType = sysAttMain.getFdContentType();
                        }
                        if (AttImageUtils.cacheConsulation(request, response, fileContentType, filename)) {
                            return null;
                        }
                        response.setContentType(fileContentType);
                        response.setHeader("Pragma", "public");
                        if (filename.indexOf(".swf") == -1) {
                            response.setHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
                        }
                        IOUtil.write(in, out);
                        return null;
                    }
                }
                if (StringUtil.isNotNull(open) || fileContentType.indexOf("image") > -1) {
                    response.setHeader("Content-Disposition", "filename=\"" + filename + "\"");
                }
                else {
                    response.setHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
                }
                this.getServiceImp(request).findData(sysAttMain.getFdId(), out);
                if (fileContentType.indexOf("image") == -1 && fileContentType.indexOf("html") == -1) {
                    final RequestContext context = new RequestContext(request);
                    context.setParameter("downloadType", "manual");
                    this.getSysAttDownloadLogService().addDownloadLogByAtt((SysAttBase)sysAttMain, context);
                }
                return null;
            }
            catch (final Exception e) {
                this.streamClose(null, out);
                IOUtils.closeQuietly((Closeable)fileChannel);
                messages.addError((Throwable)e);
                SysAttMainAction.logger.error("readDownload错误", e);
            }
            finally {
                this.streamClose(null, out);
                IOUtils.closeQuietly((Closeable)fileChannel);
            }
        }
        if (messages.hasError() && StringUtil.isNotNull(open)) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        return null;
    }
    
    public ActionForward downloadFile(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final String sign = request.getParameter("Signature");
        final String expires = request.getParameter("Expires");
        final String reqType = request.getParameter("reqType");
        final String fdId = request.getParameter("fdId");
        final String downloadFileType = request.getParameter("downloadFileType");
        if ("rest".equals(reqType)) {
            if (!this.getServiceImp(request).validateDownloadSignatureRest(expires, fdId, sign)) {
                messages.addError((Throwable)new Exception("Signature is invailid."));
                KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
                return mapping.findForward("failure");
            }
        }
        else if (!this.getServiceImp(request).validateDownloadSignature(expires, fdId, sign)) {
            messages.addError((Throwable)new Exception("Signature is invailid."));
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        request.setAttribute("reliable", (Object)"true");
        if ("pdf".equals(downloadFileType)) {
            return this.downloadPdf(mapping, form, request, response);
        }
        if ("ofd".equals(downloadFileType)) {
            return this.downloadOfd(mapping, form, request, response);
        }
        return this.download(mapping, form, request, response);
    }
    
    public ActionForward downloadPdf(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final String fdId = request.getParameter("fdId");
        final String convertType = request.getParameter("convertType");
        String converterKey = "toHTML";
        final SysAttMain sysAttMain = (SysAttMain)((ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService")).findByPrimaryKey(fdId);
        if (sysAttMain != null && JgWebOffice.isPDF(sysAttMain.getFdFileName())) {
            this.downloadConvertFile(request, response, sysAttMain, ".pdf");
            return null;
        }
        InputStream in = null;
        String open = null;
        final OutputStream out = (OutputStream)response.getOutputStream();
        try {
            HQLInfo hql = new HQLInfo();
            String strWhere = "sysFileConvertQueue.fdFileId=:fdFileId and sysFileConvertQueue.fdConverterKey=:fdConverterKey";
            if (StringUtil.isNotNull(convertType)) {
                strWhere = String.valueOf(strWhere) + " and sysFileConvertQueue.fdConverterType=:convertType ";
                hql.setParameter("convertType", (Object)convertType);
                converterKey = "toPDF";
            }
            hql.setWhereBlock(strWhere);
            hql.setParameter("fdFileId", (Object)sysAttMain.getFdFileId());
            hql.setParameter("fdConverterKey", (Object)converterKey);
            Object convertQueue = ((ISysFileConvertQueueService)SpringBeanUtil.getBean("sysFileConvertQueueService")).findFirstOne(hql);
            if (convertQueue == null) {
                hql = new HQLInfo();
                String where = "sysFileConvertQueue.fdAttMainId=:fdAttMainId and sysFileConvertQueue.fdConverterKey=:fdConverterKey";
                if (StringUtil.isNotNull(convertType)) {
                    where = String.valueOf(where) + " and sysFileConvertQueue.fdConverterType=:convertType ";
                    hql.setParameter("convertType", (Object)convertType);
                    converterKey = "toPDF";
                }
                hql.setWhereBlock(where);
                hql.setParameter("fdAttMainId", (Object)sysAttMain.getFdId());
                hql.setParameter("fdConverterKey", (Object)converterKey);
                convertQueue = ((ISysFileConvertQueueService)SpringBeanUtil.getBean("sysFileConvertQueueService")).findList(hql);
            }
            if (convertQueue != null) {
                final SysFileConvertQueue sysFileConvertQueue = (SysFileConvertQueue)convertQueue;
                final int convertStatus = sysFileConvertQueue.getFdConvertStatus();
                if (convertStatus == 4) {
                    final String viewerKey = SysAttViewerUtil.getFileViewerKey(sysAttMain);
                    final String convertFileName = this.convertPDFFileName(convertType, viewerKey, "toPDF", "pdf");
                    final SysAttFile sysAsttFile = ((ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService")).getFile(sysAttMain.getFdId());
                    boolean exist = false;
                    String fdPath = "";
                    String pathPrefix = "";
                    final ISysFileLocationProxyService sysFileLocationProxyService = SysFileLocationUtil.getProxyService(sysAsttFile.getFdAttLocation());
                    if (sysAsttFile != null) {
                        pathPrefix = ((sysAsttFile.getFdCata() == null) ? null : sysAsttFile.getFdCata().getFdPath());
                        fdPath = String.valueOf(sysAsttFile.getFdFilePath()) + "_convert" + File.separator + convertFileName;
                        exist = sysFileLocationProxyService.doesFileExist(fdPath, pathPrefix);
                    }
                    if (exist) {
                        String filename = "";
                        final String fdFileName = request.getParameter("fdFileName");
                        if (StringUtil.isNotNull(fdFileName)) {
                            filename = String.valueOf(fdFileName) + ".pdf";
                        }
                        else {
                            filename = String.valueOf(sysAttMain.getFdFileName().substring(0, sysAttMain.getFdFileName().lastIndexOf("."))) + ".pdf";
                        }
                        if (StringUtil.isNotNull(request.getHeader("User-Agent"))) {
                            filename = this.encodeFileName(request, filename, false);
                        }
                        String fileContentType = FileMimeTypeUtil.getContentType(filename);
                        if (StringUtil.isNull(fileContentType)) {
                            fileContentType = "application/x-download";
                        }
                        response.reset();
                        response.setContentType(fileContentType);
                        response.setHeader("Pragma", "public");
                        open = request.getParameter("open");
                        if (StringUtil.isNotNull(open)) {
                            response.setHeader("Content-Disposition", "filename=\"" + filename + "\"");
                        }
                        else {
                            response.setHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
                        }
                        in = sysFileLocationProxyService.readFile(fdPath, pathPrefix);
                        response.setContentLength(in.available());
                        if (!"server".equals(ResourceUtil.getKmssConfigString("sys.att.location")) || !"1".equals(ResourceUtil.getKmssConfigString("sys.att.encryption.mode"))) {
                            in = (InputStream)new DecryptionInputStream(in);
                        }
                        IOUtil.write(in, out);
                        return null;
                    }
                }
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            SysAttMainAction.logger.error("download错误", e);
        }
        if (messages.hasError() && StringUtil.isNotNull(open)) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        return null;
    }
    
    public ActionForward downloadOfd(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final String fdId = request.getParameter("fdId");
        final String convertType = request.getParameter("convertType");
        final SysAttMain sysAttMain = (SysAttMain)((ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService")).findByPrimaryKey(fdId);
        if (sysAttMain != null && JgWebOffice.isOFD(sysAttMain.getFdFileName())) {
            this.downloadConvertFile(request, response, sysAttMain, ".ofd");
            return null;
        }
        InputStream in = null;
        String open = null;
        final OutputStream out = (OutputStream)response.getOutputStream();
        try {
            HQLInfo hql = new HQLInfo();
            String strWhere = "sysFileConvertQueue.fdFileId=:fdFileId and sysFileConvertQueue.fdConverterKey=:fdConverterKey";
            if (StringUtil.isNotNull(convertType)) {
                strWhere = String.valueOf(strWhere) + " and sysFileConvertQueue.fdConverterType=:convertType ";
                hql.setParameter("convertType", (Object)convertType);
            }
            hql.setParameter("fdFileId", (Object)sysAttMain.getFdFileId());
            hql.setParameter("fdConverterKey", (Object)"toOFD");
            hql.setWhereBlock(strWhere);
            Object convertQueue = ((ISysFileConvertQueueService)SpringBeanUtil.getBean("sysFileConvertQueueService")).findFirstOne(hql);
            if (convertQueue == null) {
                hql = new HQLInfo();
                String where = "sysFileConvertQueue.fdAttMainId=:fdAttMainId and sysFileConvertQueue.fdConverterKey=:fdConverterKey";
                if (StringUtil.isNotNull(convertType)) {
                    where = String.valueOf(where) + " and sysFileConvertQueue.fdConverterType=:convertType ";
                    hql.setParameter("convertType", (Object)convertType);
                }
                hql.setWhereBlock(where);
                hql.setParameter("fdAttMainId", (Object)sysAttMain.getFdId());
                hql.setParameter("fdConverterKey", (Object)"toOFD");
                convertQueue = ((ISysFileConvertQueueService)SpringBeanUtil.getBean("sysFileConvertQueueService")).findFirstOne(hql);
            }
            if (convertQueue != null) {
                final SysFileConvertQueue sysFileConvertQueue = (SysFileConvertQueue)convertQueue;
                final int convertStatus = sysFileConvertQueue.getFdConvertStatus();
                if (convertStatus == 4) {
                    final String convertFileName = this.convertOFDFileName(convertType, "toOFD", "ofd");
                    final SysAttFile sysAsttFile = ((ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService")).getFile(sysAttMain.getFdId());
                    boolean exist = false;
                    String fdPath = "";
                    String pathPrefix = "";
                    final ISysFileLocationProxyService sysFileLocationProxyService = SysFileLocationUtil.getProxyService(sysAsttFile.getFdAttLocation());
                    if (sysAsttFile != null) {
                        pathPrefix = ((sysAsttFile.getFdCata() == null) ? null : sysAsttFile.getFdCata().getFdPath());
                        fdPath = String.valueOf(sysAsttFile.getFdFilePath()) + "_convert" + File.separator + convertFileName;
                        exist = sysFileLocationProxyService.doesFileExist(fdPath, pathPrefix);
                        SysAttMainAction.logger.info("pathPrefix:" + pathPrefix);
                        SysAttMainAction.logger.info("downloadOfd_fdPath:" + fdPath);
                        SysAttMainAction.logger.info("downloadOfd_exist:" + exist);
                    }
                    SysAttMainAction.logger.info("downloadOfd_convertType:" + convertType);
                    SysAttMainAction.logger.info("downloadOfd_convertFileName:" + convertFileName);
                    if (exist) {
                        String filename = "";
                        final String fdFileName = request.getParameter("fdFileName");
                        if (StringUtil.isNotNull(fdFileName)) {
                            filename = String.valueOf(fdFileName) + ".ofd";
                        }
                        else {
                            filename = String.valueOf(sysAttMain.getFdFileName().substring(0, sysAttMain.getFdFileName().lastIndexOf("."))) + ".ofd";
                        }
                        if (StringUtil.isNotNull(request.getHeader("User-Agent"))) {
                            filename = this.encodeFileName(request, filename, false);
                        }
                        String fileContentType = FileMimeTypeUtil.getContentType(filename);
                        if (StringUtil.isNull(fileContentType)) {
                            fileContentType = "application/x-download";
                        }
                        response.reset();
                        response.setContentType(fileContentType);
                        response.setHeader("Pragma", "public");
                        open = request.getParameter("open");
                        if (StringUtil.isNotNull(open)) {
                            response.setHeader("Content-Disposition", "filename=\"" + filename + "\"");
                        }
                        else {
                            response.setHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
                        }
                        in = sysFileLocationProxyService.readFile(fdPath, pathPrefix);
                        response.setContentLength(in.available());
                        in = (InputStream)new DecryptionInputStream(in);
                        IOUtil.write(in, out);
                        return null;
                    }
                }
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            SysAttMainAction.logger.error("download错误", e);
        }
        if (messages.hasError() && StringUtil.isNotNull(open)) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        return null;
    }
    
    public void downloadConvertFile(final HttpServletRequest request, final HttpServletResponse response, final SysAttMain sysAttMain, final String suffix) {
        InputStream in = null;
        String open = null;
        OutputStream out = null;
        try {
            out = (OutputStream)response.getOutputStream();
            final SysAttFile sysAsttFile = ((ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService")).getFile(sysAttMain.getFdId());
            final ISysFileLocationProxyService sysFileLocationProxyService = SysFileLocationUtil.getProxyService(sysAsttFile.getFdAttLocation());
            String fdPath = "";
            String pathPrefix = "";
            Boolean exist = false;
            if (sysAsttFile != null) {
                pathPrefix = ((sysAsttFile.getFdCata() == null) ? null : sysAsttFile.getFdCata().getFdPath());
                fdPath = sysAsttFile.getFdFilePath();
                exist = sysFileLocationProxyService.doesFileExist(fdPath, pathPrefix);
            }
            if (exist) {
                String filename = "";
                final String fdFileName = request.getParameter("fdFileName");
                if (StringUtil.isNotNull(fdFileName)) {
                    filename = String.valueOf(fdFileName) + suffix;
                }
                else {
                    filename = String.valueOf(sysAttMain.getFdFileName().substring(0, sysAttMain.getFdFileName().lastIndexOf("."))) + suffix;
                }
                if (StringUtil.isNotNull(request.getHeader("User-Agent"))) {
                    filename = this.encodeFileName(request, filename, false);
                }
                String fileContentType = FileMimeTypeUtil.getContentType(filename);
                if (StringUtil.isNull(fileContentType)) {
                    fileContentType = "application/x-download";
                }
                response.reset();
                response.setContentType(fileContentType);
                response.setHeader("Pragma", "public");
                open = request.getParameter("open");
                if (StringUtil.isNotNull(open)) {
                    response.setHeader("Content-Disposition", "filename=\"" + filename + "\"");
                }
                else {
                    response.setHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
                }
                in = sysFileLocationProxyService.readFile(fdPath, pathPrefix);
                response.setContentLength(in.available());
                in = (InputStream)new DecryptionInputStream(in);
                IOUtil.write(in, out);
            }
        }
        catch (final Exception e) {
            SysAttMainAction.logger.error("下载" + suffix + "文件失败：", e);
            try {
                if (out != null) {
                    out.close();
                }
                if (in != null) {
                    in.close();
                }
            }
            catch (final Exception e2) {
                SysAttMainAction.logger.error("下载" + suffix + "文件关闭流失败：", e2);
            }
            return;
        }
        finally {
            try {
                if (out != null) {
                    out.close();
                }
                if (in != null) {
                    in.close();
                }
            }
            catch (final Exception e2) {
                SysAttMainAction.logger.error("下载" + suffix + "文件关闭流失败：", e2);
            }
        }
        try {
            if (out != null) {
                out.close();
            }
            if (in != null) {
                in.close();
            }
        }
        catch (final Exception e2) {
            SysAttMainAction.logger.error("下载" + suffix + "文件关闭流失败：", e2);
        }
    }
    
    public String convertOFDFileName(final String convertType, final String pre, final String end) {
        String fileName = "";
        if (StringUtil.isNotNull(convertType)) {
            if ("wpsCenter".equals(convertType) || "wpsCenterV6".equals(convertType)) {
                fileName = String.valueOf(pre) + "-WPSCenter_" + end;
            }
            else if ("wps".equals(convertType)) {
                fileName = String.valueOf(pre) + "-WPS_" + end;
            }
            else if ("skofd".equals(convertType)) {
                fileName = String.valueOf(pre) + "-Suwell_" + end;
            }
            else if ("dianju".equals(convertType)) {
                fileName = String.valueOf(pre) + "-Dianju_" + end;
            }
            else if ("foxit".equals(convertType)) {
                fileName = String.valueOf(pre) + "-Foxit_" + end;
            }
            else if ("yozodcs".equals(convertType)) {
                fileName = String.valueOf(pre) + "-Yozodcs_" + end;
            }
            else if ("suwell".equals(convertType)) {
                fileName = String.valueOf(pre) + "-Suwell_" + end;
            }
        }
        return fileName;
    }
    
    public String convertPDFFileName(final String convertType, final String viewerKey, final String pre, final String end) {
        String fileName = "toHTML-Aspose_pdf";
        if (StringUtil.isNotNull(viewerKey)) {
            fileName = String.valueOf(viewerKey) + "_pdf";
        }
        if (StringUtil.isNotNull(convertType)) {
            if ("wpsCenter".equals(convertType) || "wpsCenterV6".equals(convertType)) {
                fileName = String.valueOf(pre) + "-WPSCenter_" + end;
            }
            else if ("wps".equals(convertType)) {
                fileName = String.valueOf(pre) + "-WPS_" + end;
            }
            else if ("dianju".equals(convertType)) {
                fileName = String.valueOf(pre) + "-Dianju_" + end;
            }
            else if ("foxit".equals(convertType)) {
                fileName = String.valueOf(pre) + "-Foxit_" + end;
            }
            else if ("yozodcs".equals(convertType)) {
                fileName = String.valueOf(pre) + "-Yozodcs_" + end;
            }
            else if ("suwell".equals(convertType)) {
                fileName = String.valueOf(pre) + "-Suwell_" + end;
            }
        }
        return fileName;
    }
    
    public ActionForward download(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        OutputStream out = null;
        InputStream in = null;
        String open = null;
        String wpsOaassistfilename = "";
        String ocxType = "";
        final String from = request.getParameter("from");
        if (!SysAttConfigUtil.isDianJuOLEnabled() && this.downloadDirect(request, response)) {
            return null;
        }
        FileChannel fileChannel = null;
        Label_1944: {
            try {
                final String fdDefaultName = request.getParameter("fdDefaultName");
                final String wpsExtAppModel = request.getParameter("wpsExtAppModel");
                final List<SysAttMain> sysAttMains = this.getAttMains(request);
                out = (OutputStream)response.getOutputStream();
                if (SysAttMainAction.logger.isDebugEnabled()) {
                    SysAttMainAction.logger.debug("SysAttMainAction:download:sysAttMains:" + sysAttMains);
                }
                if (sysAttMains == null || sysAttMains.isEmpty()) {
                    this.printAttIsNull(request, response, out, messages);
                }
                else {
                    out = (OutputStream)response.getOutputStream();
                    String filename = "";
                    String fileContentType = null;
                    long fileSize = 0L;
                    if (SysAttMainAction.logger.isDebugEnabled()) {
                        SysAttMainAction.logger.debug("SysAttMainAction:download:sysAttMains.size:" + sysAttMains.size());
                    }
                    if (sysAttMains.size() == 1) {
                        final SysAttMain sysAttMain = sysAttMains.get(0);
                        this.commonLogFind(request, sysAttMain, "download");
                        if (StringUtil.isNotNull(request.getHeader("User-Agent"))) {
                            filename = this.encodeFileName(request, sysAttMain.getFdFileName(), false);
                        }
                        wpsOaassistfilename = sysAttMain.getFdFileName();
                        ocxType = SysAttOcxUtil.getOcxType(sysAttMain.getFdKey(), sysAttMain.getFdModelName());
                        fileContentType = FileMimeTypeUtil.getContentType(filename);
                        if (StringUtil.isNull(fileContentType)) {
                            fileContentType = sysAttMain.getFdContentType();
                        }
                        if (SysAttMainAction.logger.isDebugEnabled()) {
                            SysAttMainAction.logger.debug("SysAttMainAction:download:sysAttMain.getInputStream:" + sysAttMain.getInputStream());
                        }
                        in = sysAttMain.getInputStream();
                        fileSize = sysAttMain.getFdSize().longValue();
                        if (SysAttMainAction.logger.isDebugEnabled()) {
                            SysAttMainAction.logger.debug("SysAttMainAction:download:sysAttMain.in:" + in);
                        }
                        long tmpSize = 0L;
                        if (in != null) {
                            if (in instanceof DecryptionInputStream) {
                                final BigFileInfo bigFileInfo = ((DecryptionInputStream)in).getFileInfo();
                                fileChannel = bigFileInfo.getFileChannel();
                                tmpSize = bigFileInfo.getFileSize();
                            }
                            else {
                                fileChannel = ((FileInputStream)in).getChannel();
                                tmpSize = fileChannel.size();
                            }
                        }
                        if (tmpSize != fileSize && tmpSize > 0L) {
                            fileSize = tmpSize;
                        }
                    }
                    else {
                        filename = (StringUtil.isNotNull(fdDefaultName) ? this.encodeFileName(request, String.valueOf(fdDefaultName) + ".zip") : this.encodeFileName(request, String.valueOf(this.fetchMainModelSubject(request, sysAttMains.get(0))) + ".zip"));
                        if (".zip".equals(filename)) {
                            String fileName = sysAttMains.get(0).getFdFileName();
                            fileName = String.valueOf(fileName.substring(0, fileName.lastIndexOf("."))) + ".zip";
                            filename = this.encodeFileName(request, fileName);
                        }
                        fileContentType = FileMimeTypeUtil.getContentType(filename);
                        for (final SysAttMain sysAttMain : sysAttMains) {
                            this.commonLogFind(request, sysAttMain, "download");
                        }
                    }
                    response.reset();
                    if (fileSize > 0L) {
                        if (fileSize <= 2147483647L) {
                            response.setContentLength((int)fileSize);
                        }
                        else {
                            response.setHeader("Content-Length", String.valueOf(fileSize));
                        }
                    }
                    if (AttImageUtils.cacheConsulation(request, response, fileContentType, filename)) {
                        this.getSysAttDownloadLogService().addDownloadLogByAttList((List)sysAttMains, new RequestContext(request));
                        return null;
                    }
                    if (SysAttWpsCloudUtil.isEnableMobile(this.isMobileRequest(request))) {
                        SysAttMainAction.logger.info("政务微信下载文件。");
                        response.setContentType("application/octet-stream");
                    }
                    else {
                        response.setContentType(fileContentType);
                    }
                    String getExtensionFileName = filename;
                    if (getExtensionFileName.contains(":")) {
                        getExtensionFileName = getExtensionFileName.replaceAll(":", "");
                    }
                    final String extName = FilenameUtils.getExtension(getExtensionFileName);
                    if ("txt".equals(extName)) {
                        final String charCode = SysAttUtil.getCharset(in);
                        if (StringUtil.isNotNull(charCode)) {
                            response.setCharacterEncoding(charCode);
                        }
                    }
                    response.setHeader("Pragma", "public");
                    open = request.getParameter("open");
                    if (StringUtil.isNotNull(open)) {
                        response.setHeader("Content-Disposition", "filename=\"" + filename + "\"");
                    }
                    else if (11 == MobileUtil.getClientType(request) || 22 == MobileUtil.getClientType(request)) {
                        response.setHeader("Content-Disposition", "attachment;filename*=utf-8''" + filename);
                    }
                    else if (SysAttWpsoaassistUtil.isEnable() || "06".equals(ocxType) || "kmImissive".equals(wpsExtAppModel)) {
                        if (SysAttWpsCloudUtil.isEnableMobile(this.isMobileRequest(request))) {
                            response.setHeader("Content-Disposition", "attachment; filename=" + URLEncoder.encode(wpsOaassistfilename, "UTF-8") + "; md5=" + MD5Util.getMD5String(in));
                        }
                        else if ("kmImissive".equals(wpsExtAppModel)) {
                            response.setHeader("Content-Disposition", "attachment; filename=" + URLEncoder.encode(wpsOaassistfilename, "UTF-8"));
                        }
                        else if ("wpsOAasisst".equals(from)) {
                            response.setHeader("Content-Disposition", "attachment; filename=" + URLEncoder.encode(wpsOaassistfilename, "UTF-8"));
                        }
                        else {
                            response.setHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
                        }
                    }
                    else if (SysAttConfigUtil.isWritingByWps() && "kmsCowritting".equals(from)) {
                        if (SysAttWpsCloudUtil.isEnableMobile(this.isMobileRequest(request))) {
                            response.setHeader("Content-Disposition", "attachment; filename=" + URLEncoder.encode(wpsOaassistfilename, "UTF-8") + "; md5=" + MD5Util.getMD5String(in));
                        }
                        else {
                            response.setHeader("Content-Disposition", "attachment; filename=" + URLEncoder.encode(wpsOaassistfilename, "UTF-8"));
                        }
                    }
                    else if (SysAttWpsCloudUtil.isEnableMobile(this.isMobileRequest(request))) {
                        response.setHeader("Content-Disposition", "attachment; filename=" + URLEncoder.encode(wpsOaassistfilename, "UTF-8") + "; md5=" + MD5Util.getMD5String(in));
                    }
                    else {
                        response.setHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
                    }
                    if (SysAttConfigUtil.pdfReadByFoxitPC() || SysAttConfigUtil.pdfReadByFoxitMobile() || "true".equals(request.getAttribute("reliable"))) {
                        response.setHeader("Access-Control-Allow-Origin", "*");
                        response.setHeader("Access-Control-Allow-Credentials", "true");
                        response.setHeader("Access-Control-Allow-Methods", "*");
                        response.setHeader("Access-Control-Allow-Headers", "Content-Type,Access-Token");
                        response.setHeader("Access-Control-Expose-Headers", "*");
                    }
                    Label_1816: {
                        if (sysAttMains.size() == 1) {
                            if (SysAttUtil.viewByBrowser((SysAttMain)sysAttMains.get(0))) {
                                response.setHeader("Access-Control-Allow-Origin", "*");
                            }
                            this.getServiceImp(request).findData(sysAttMains.get(0).getFdId(), out);
                        }
                        else {
                            ZipOutputStream zipOut = null;
                            try {
                                zipOut = new ZipOutputStream(out);
                                zipOut.setEncoding("GBK");
                                for (final SysAttMain tmpSysAttMain : sysAttMains) {
                                    in = tmpSysAttMain.getInputStream();
                                    if (in != null) {
                                        zipOut.putNextEntry(new ZipEntry(tmpSysAttMain.getFdFileName()));
                                        IOUtils.copy(in, (OutputStream)zipOut);
                                        in.close();
                                        in = null;
                                    }
                                }
                            }
                            catch (final Exception ex) {
                                if (zipOut != null) {
                                    IOUtils.closeQuietly((OutputStream)zipOut);
                                }
                                break Label_1816;
                            }
                            finally {
                                if (zipOut != null) {
                                    IOUtils.closeQuietly((OutputStream)zipOut);
                                }
                            }
                            if (zipOut != null) {
                                IOUtils.closeQuietly((OutputStream)zipOut);
                            }
                        }
                    }
                    if (!"kmImissive".equals(wpsExtAppModel)) {
                        this.getSysAttDownloadLogService().addDownloadLogByAttList((List)sysAttMains, new RequestContext(request));
                    }
                    return null;
                }
            }
            catch (final Exception e) {
                this.streamClose(in, out);
                IOUtils.closeQuietly((Closeable)fileChannel);
                messages.addError((Throwable)e);
                SysAttMainAction.logger.error("download错误", e);
                break Label_1944;
            }
            finally {
                this.streamClose(in, out);
                IOUtils.closeQuietly((Closeable)fileChannel);
            }
            this.streamClose(in, out);
            IOUtils.closeQuietly((Closeable)fileChannel);
        }
        if (messages.hasError() && StringUtil.isNotNull(open)) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        return null;
    }
    
    public ActionForward downloadToOther(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        if (!"POST".equals(request.getMethod())) {
            throw new UnexpectedRequestException();
        }
        final String key = request.getParameter("key");
        final String fdId = request.getParameter("fdId");
        final String t = request.getParameter("t");
        Long time = null;
        if (StringUtil.isNotNull(t)) {
            time = Long.valueOf(t);
        }
        if (StringUtil.isNotNull(key) && StringUtil.isNotNull(fdId) && this.getProviderMap().containsKey(key)) {
            final ISysAttachmentTransmissionProvider provider = this.getProviderMap().get(key);
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().print(provider.downloadToOther(fdId, time));
            return null;
        }
        return null;
    }
    
    public ActionForward isSuccess(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String key = request.getParameter("key");
        final String fdId = request.getParameter("fdId");
        final String t = request.getParameter("t");
        final String type = request.getParameter("type");
        Long time = null;
        if (StringUtil.isNotNull(t)) {
            time = Long.valueOf(t);
        }
        if (StringUtil.isNotNull(key) && StringUtil.isNotNull(fdId) && this.getProviderMap().containsKey(key)) {
            final ISysAttachmentTransmissionProvider provider = this.getProviderMap().get(key);
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().print(provider.isSuccess(fdId, type, time));
            return null;
        }
        return null;
    }
    
    public ActionForward isShow(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String key = request.getParameter("key");
        if (StringUtil.isNotNull(key) && this.getProviderMap().containsKey(key)) {
            final ISysAttachmentTransmissionProvider provider = this.getProviderMap().get(key);
            response.setCharacterEncoding("UTF-8");
            response.getWriter().print(provider.isShow());
            return null;
        }
        return null;
    }
    
    public HashMap getProviderMap() {
        if (SysAttMainAction.providerMap == null || SysAttMainAction.providerMap.isEmpty()) {
            SysAttMainAction.providerMap = new HashMap();
            final IExtension[] extensions = Plugin.getExtensions("com.landray.kmss.sys.attachment.transmission", "*", "transmission");
            if (extensions == null || extensions.length == 0) {
                return SysAttMainAction.providerMap;
            }
            for (int i = 0; i < extensions.length; ++i) {
                final String key = (String)Plugin.getParamValue(extensions[i], "key");
                SysAttMainAction.providerMap.put(key, Plugin.getParamValue(extensions[i], "provider"));
            }
        }
        return SysAttMainAction.providerMap;
    }
    
    private String fetchMainModelSubject(final HttpServletRequest request, final SysAttMain sysAttMain) {
        final String filename = "download";
        if (sysAttMain != null) {
            Object mainModel = null;
            try {
                mainModel = this.getServiceImp(request).getMainModel((BaseCoreInnerModel)sysAttMain);
            }
            catch (final Exception e1) {
                SysAttMainAction.logger.error("压缩过程获取主文档出错,错误信息:", e1);
            }
            return SysAttUtil.getSubjectByModel(mainModel, filename);
        }
        return filename;
    }
    
    private String encodeFileName(final HttpServletRequest request, final String oldFileName) throws UnsupportedEncodingException {
        return this.encodeFileName(request, oldFileName, true);
    }
    
    private String encodeFileName(final HttpServletRequest request, String oldFileName, final boolean isEncode) throws UnsupportedEncodingException {
        final String userAgent = request.getHeader("User-Agent").toUpperCase();
        if (userAgent.indexOf("MSIE") > -1 || userAgent.indexOf("TRIDENT") > -1 || userAgent.indexOf("EDGE") > -1 || 11 == MobileUtil.getClientType(request) || 22 == MobileUtil.getClientType(request)) {
            oldFileName = URLEncoder.encode(oldFileName, "UTF-8");
            oldFileName = oldFileName.replace("+", "%20");
        }
        else {
            oldFileName = new String(oldFileName.getBytes("UTF-8"), "ISO8859-1");
        }
        if (isEncode) {
            oldFileName = oldFileName.replace("+", "%20");
        }
        oldFileName = oldFileName.replaceAll("\r|\n", "");
        return oldFileName;
    }
    
    public ActionForward downloadPic(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        OutputStream out = null;
        String open = null;
        Label_0405: {
            try {
                final List<SysAttMain> sysAttMains = this.getAttMains(request);
                out = (OutputStream)response.getOutputStream();
                if (sysAttMains == null || sysAttMains.isEmpty()) {
                    this.printAttIsNull(request, response, out, messages);
                }
                else {
                    final SysAttMain sysAttMain = sysAttMains.get(0);
                    this.commonLogFind(request, sysAttMain, "downloadPic");
                    if (!"pic".equals(sysAttMain.getFdAttType())) {
                        messages.addError(new KmssMessage("sys-attachment:sysAttMain.error.downloadPic"));
                    }
                    else {
                        final int fileSize = sysAttMain.getFdSize().intValue();
                        final String filename = this.encodeFileName(request, sysAttMain.getFdFileName(), false);
                        String fileContentType = FileMimeTypeUtil.getContentType(filename);
                        if (StringUtil.isNull(fileContentType)) {
                            fileContentType = sysAttMain.getFdContentType();
                        }
                        response.reset();
                        if (AttImageUtils.cacheConsulation(request, response, fileContentType, filename)) {
                            return null;
                        }
                        response.setContentLength(fileSize);
                        response.setContentType(fileContentType);
                        response.setHeader("Pragma", "public");
                        open = request.getParameter("open");
                        if (StringUtil.isNotNull(open)) {
                            response.setHeader("Content-Disposition", "filename=\"" + filename + "\"");
                        }
                        else {
                            response.setHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
                        }
                        out = (OutputStream)response.getOutputStream();
                        this.getServiceImp(request).findData(sysAttMain.getFdId(), out);
                        return null;
                    }
                }
            }
            catch (final Exception e) {
                this.streamClose(null, out);
                messages.addError((Throwable)e);
                SysAttMainAction.logger.error("downloadPic错误", e);
                break Label_0405;
            }
            finally {
                this.streamClose(null, out);
            }
            this.streamClose(null, out);
        }
        if (messages.hasError() && StringUtil.isNotNull(open)) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        return null;
    }
    
    public ActionForward delete(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final String fdId = request.getParameter("fdId");
        final String format = request.getParameter("format");
        String forward = "upload_result";
        try {
            if (fdId == null || fdId.trim().length() == 0) {
                messages.addError(new KmssMessage("Key not found."));
            }
            else {
                this.getServiceImp(request).deleteAtt(fdId);
            }
            if (StringUtil.isNotNull(format)) {
                final Map rtnMap = new HashMap();
                rtnMap.put("status", "1");
                request.setAttribute("resultMap", (Object)rtnMap);
                request.setAttribute("format", (Object)format);
                forward = "upload_result";
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        return mapping.findForward(forward);
    }
    
    public ActionForward save(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        try {
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.debug("添加文档附件。。。。。" + request.getMethod());
            }
            if (!"POST".equals(request.getMethod())) {
                throw new UnexpectedRequestException();
            }
            final String fdId = request.getParameter("fdId");
            if (StringUtil.isNotNull(fdId)) {
                return this.update(mapping, form, request, response);
            }
            List sysAttMains = new ArrayList();
            final SysAttMainForm attMainForm = (SysAttMainForm)form;
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.debug("files:" + attMainForm.getFormFiles());
            }
            for (final Object ofile : attMainForm.getFormFiles()) {
                if (ofile != null) {
                    final SysAttMain sysAttMain = new SysAttMain();
                    final String id = sysAttMain.getFdId();
                    BeanUtils.copyProperties((Object)sysAttMain, (Object)attMainForm);
                    sysAttMain.setFdId(id);
                    final FormFile formFile = (FormFile)ofile;
                    if (formFile.getFileName() == null) {
                        continue;
                    }
                    if (formFile.getFileName().trim().length() == 0) {
                        continue;
                    }
                    final String fileName = formFile.getFileName();
                    if (SysAttMainAction.logger.isDebugEnabled()) {
                        SysAttMainAction.logger.debug("save files:" + fileName);
                    }
                    sysAttMain.setFdFileName(fileName);
                    sysAttMain.setDocCreateTime(new Date());
                    sysAttMain.setFdSize(new Double((double)formFile.getFileSize()));
                    String contentType = FileMimeTypeUtil.getContentType(fileName);
                    if (StringUtil.isNull(contentType)) {
                        contentType = formFile.getContentType();
                    }
                    sysAttMain.setFdContentType(contentType);
                    sysAttMain.setInputStream(formFile.getInputStream());
                    final boolean allowLogOper = UserOperHelper.allowLogOper("Service_Add", SysAttMain.class.getName());
                    if (allowLogOper) {
                        UserOperContentHelper.putAdd(sysAttMain.getFdId(), sysAttMain.getFdFileName(), SysAttMain.class.getName()).putSimple("fdContentType", (Object)contentType);
                    }
                    sysAttMains.add(sysAttMain);
                    if (!SysAttMainAction.logger.isDebugEnabled()) {
                        continue;
                    }
                    SysAttMainAction.logger.debug("save files:" + fileName + " complete!");
                }
            }
            sysAttMains = this.getServiceImp(request).add(sysAttMains);
            String sysAttMainIds = "";
            final Iterator it2 = sysAttMains.iterator();
            while (it2.hasNext()) {
                final SysAttMain sysAttMain = it2.next();
                sysAttMainIds = String.valueOf(sysAttMainIds) + sysAttMain.getFdId();
                if (it2.hasNext()) {
                    sysAttMainIds = String.valueOf(sysAttMainIds) + ";";
                }
                if (SysAttMainAction.logger.isDebugEnabled()) {
                    SysAttMainAction.logger.debug("sysAttMainIds：" + sysAttMainIds);
                }
            }
            request.setAttribute("sysAttMains", (Object)sysAttMains);
            request.setAttribute("sysAttMainIds", (Object)sysAttMainIds);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.debug("save fail!");
            }
            return mapping.findForward("failure");
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
        SysAttMainAction.logger.debug("save success!");
        return mapping.findForward("upload_success");
    }
    
    public ActionForward update(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        try {
            if (!"POST".equals(request.getMethod())) {
                throw new UnexpectedRequestException();
            }
            final String fdId = request.getParameter("fdId");
            if (StringUtil.isNull(fdId)) {
                return this.save(mapping, form, request, response);
            }
            SysAttMain sysAttMain = null;
            if (fdId != null && fdId.trim().length() > 0) {
                final String l_fdId = fdId;
                sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(l_fdId);
            }
            if (sysAttMain != null) {
                List sysAttMains = new ArrayList();
                final SysAttMainForm attMainForm = (SysAttMainForm)form;
                for (final Object ofile : attMainForm.getFormFiles()) {
                    if (ofile != null) {
                        final FormFile formFile = (FormFile)ofile;
                        if (formFile.getFileName() == null) {
                            continue;
                        }
                        if (formFile.getFileName().trim().length() == 0) {
                            continue;
                        }
                        String fileName = formFile.getFileName();
                        final String fdAttType = request.getParameter("fdAttType");
                        final String extName = FilenameUtils.getExtension(fileName);
                        if ("office".equalsIgnoreCase(fdAttType) && StringUtil.isNotNull(fileName)) {
                            if ("docx".equalsIgnoreCase(extName)) {
                                fileName = fileName.substring(0, fileName.length() - 1);
                            }
                            else if ("xlsx".equalsIgnoreCase(extName)) {
                                fileName = fileName.substring(0, fileName.length() - 1);
                            }
                            else if ("pptx".equalsIgnoreCase(extName)) {
                                fileName = fileName.substring(0, fileName.length() - 1);
                            }
                        }
                        final boolean allowLogOper = UserOperHelper.allowLogOper("Service_Update", SysAttMain.class.getName());
                        if (allowLogOper) {
                            UserOperContentHelper.putUpdate(sysAttMain.getFdId(), sysAttMain.getFdFileName(), SysAttMain.class.getName()).putSimple("fdFileName", (Object)sysAttMain.getFdFileName(), (Object)fileName);
                        }
                        sysAttMain.setFdFileName(fileName);
                        sysAttMain.setFdSize(new Double((double)formFile.getFileSize()));
                        String contentType = FileMimeTypeUtil.getContentType(fileName);
                        if (StringUtil.isNull(contentType)) {
                            contentType = formFile.getContentType();
                        }
                        if (allowLogOper) {
                            UserOperContentHelper.putUpdate(sysAttMain.getFdId(), sysAttMain.getFdFileName(), SysAttMain.class.getName()).putSimple("fdContentType", (Object)sysAttMain.getFdContentType(), (Object)contentType);
                        }
                        sysAttMain.setFdContentType(contentType);
                        sysAttMain.setInputStream(formFile.getInputStream());
                        sysAttMains.add(sysAttMain);
                    }
                }
                sysAttMains = this.getServiceImp(request).update(sysAttMains);
                request.setAttribute("sysAttMains", (Object)sysAttMains);
                request.setAttribute("sysAttMainIds", (Object)fdId);
            }
            else {
                messages.addError(new KmssMessage("Key not found."));
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            return mapping.findForward("failure");
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
        return mapping.findForward("upload_success");
    }
    
    public ActionForward edit(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        SysAttMain sysAttMain = null;
        final String fdForceUseJG = request.getParameter("fdForceUseJG");
        final String isJGSignaturePDF = request.getParameter("isJGSignaturePDF");
        final String fdJGPrint = request.getParameter("fdJGPrint");
        final String signType = request.getParameter("signType");
        final boolean isMobile = this.isMobileRequest(request);
        try {
            final String fdId = request.getParameter("fdId");
            if (fdId != null && fdId.trim().length() > 0) {
                final String l_fdId = fdId;
                sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(l_fdId);
            }
            if (sysAttMain != null) {
                final String forward = SysAttOcxUtil.getOcxPageForward(sysAttMain.getFdKey(), sysAttMain.getFdModelName(), "edit");
                if (StringUtil.isNotNull(forward) && !isMobile) {
                    if ("editonline_wps_cloud".equals(forward) && !SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMain.getFdId())) {
                        SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMain.getFdId());
                    }
                    final SysAttMainForm sysAttMainForm = new SysAttMainForm();
                    BeanUtils.copyProperties((Object)sysAttMainForm, (Object)sysAttMain);
                    request.setAttribute("sysAttMainForm", (Object)sysAttMainForm);
                    request.setAttribute("fdModelName", (Object)sysAttMain.getFdModelName());
                    if ("sysAttOnLineThirdSfs".equals(forward)) {
                        final String ocxType = SysAttOcxUtil.getOcxType(sysAttMain.getFdKey(), sysAttMain.getFdModelName());
                        String busiEditType = "";
                        if ("08".equals(ocxType)) {
                            busiEditType = "5";
                        }
                        else if ("09".equals(ocxType)) {
                            busiEditType = "6";
                        }
                        request.setAttribute("moduleSfsMode", (Object)"edit");
                        request.setAttribute("busiEditType", (Object)busiEditType);
                    }
                    return mapping.findForward(forward);
                }
                if (SysAttConfigUtil.isEnableAttachmentSignature() && (JgWebOffice.isOFD(sysAttMain.getFdFileName()) || JgWebOffice.isPDF(sysAttMain.getFdFileName()))) {
                    if (sysAttMain.getFdModelName().contains("imissive")) {
                        if (StringUtil.isNotNull(signType) && ("dianjuyunPdfSign".equals(signType) || "dianjuLocalPdfSign".equals(signType) || "dianjuyunOfdSign".equals(signType) || "dianjuLocalOfdSign".equals(signType))) {
                            if ("2".equals(SysAttConfigUtil.getAttachmentSignatureType())) {
                                this.dianjuFormat(request, sysAttMain);
                                return mapping.findForward("viewonline_dianju_format");
                            }
                            if ("3".equals(SysAttConfigUtil.getAttachmentSignatureType())) {
                                final com.alibaba.fastjson.JSONObject params = new com.alibaba.fastjson.JSONObject();
                                params.put("fdAttMainId", (Object)sysAttMain.getFdId());
                                params.put("waterMarkText", (Object)UserUtil.getKMSSUser().getUserName());
                                final String previewUrl = SysAttThirdProxyUtil.getViewUrl("dianju", params).getData().getString("url");
                                request.setAttribute("previewUrl", (Object)previewUrl);
                                request.setAttribute("attMain", (Object)sysAttMain);
                                request.setAttribute("showSeal", (Object)"true");
                                request.setAttribute("moduleSfsMode", (Object)"view");
                                return mapping.findForward("sysAttOnLineThirdSfs");
                            }
                        }
                    }
                    else {
                        if ("2".equals(SysAttConfigUtil.getAttachmentSignatureType())) {
                            this.dianjuFormat(request, sysAttMain);
                            return mapping.findForward("viewonline_dianju_format");
                        }
                        if ("3".equals(SysAttConfigUtil.getAttachmentSignatureType())) {
                            final com.alibaba.fastjson.JSONObject params = new com.alibaba.fastjson.JSONObject();
                            params.put("fdAttMainId", (Object)sysAttMain.getFdId());
                            params.put("waterMarkText", (Object)UserUtil.getKMSSUser().getUserName());
                            final String previewUrl = SysAttThirdProxyUtil.getViewUrl("dianju", params).getData().getString("url");
                            request.setAttribute("previewUrl", (Object)previewUrl);
                            request.setAttribute("attMain", (Object)sysAttMain);
                            request.setAttribute("showSeal", (Object)"true");
                            request.setAttribute("moduleSfsMode", (Object)"view");
                            return mapping.findForward("sysAttOnLineThirdSfs");
                        }
                    }
                }
                if ("historyVersionAttachment".equals(sysAttMain.getFdKey())) {
                    messages.addError(new KmssMessage(ResourceUtil.getString("sysAttMain.view.history.deny", "sys-attachment")));
                    KmssReturnPage.getInstance(request).addMessages(messages).save(request);
                    return mapping.findForward("failure");
                }
                final SysAttMainForm sysAttMainForm = new SysAttMainForm();
                BeanUtils.copyProperties((Object)sysAttMainForm, (Object)sysAttMain);
                if (UserOperHelper.allowLogOper("Action_Find", SysAttMain.class.getName())) {
                    UserOperContentHelper.putAdd(sysAttMain.getFdId(), sysAttMain.getFdFileName(), SysAttMain.class.getName());
                }
                request.setAttribute("sysAttMainForm", (Object)sysAttMainForm);
                request.setAttribute("canPrint", (Object)"1");
                request.setAttribute("fdModelName", (Object)sysAttMain.getFdModelName());
            }
            else {
                messages.addError(new KmssMessage("Key not found."));
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            return mapping.findForward("failure");
        }
        final boolean isWpsoaassist = SysAttWpsoaassistUtil.isEnable();
        final boolean isWpsoaassistEmbed = SysAttWpsoaassistUtil.isWPSOAassistEmbed();
        if (SysAttMainAction.logger.isDebugEnabled()) {
            SysAttMainAction.logger.debug("isWpsoaassist={},isWpsoaassistEmbed={},fdForceUseJG={},isJGSignaturePDF={},wpscenter={},wpscloud={},WpsWebOffice={}", isWpsoaassist, isWpsoaassistEmbed, fdForceUseJG, isJGSignaturePDF, SysAttWpsCenterUtil.isEnable(), SysAttWpsCloudUtil.isEnable(), SysAttWpsWebOfficeUtil.isEnable());
        }
        if (!isMobile && isWpsoaassist && isWpsoaassistEmbed && (this.isWord(sysAttMain.getFdFileName()) || this.isExcel(sysAttMain.getFdFileName()) || this.isPpt(sysAttMain.getFdFileName()))) {
            final String userAgent = request.getHeader("user-agent");
            final boolean winFlag = userAgent.toLowerCase().contains("win");
            if (!winFlag) {
                return mapping.findForward("editonline_wps_oaassist_linux");
            }
        }
        if ("true".equals(fdJGPrint)) {
            return mapping.findForward("editonline_jgPrint");
        }
        if ("true".equals(fdForceUseJG)) {
            return mapping.findForward("editonline_jg");
        }
        if ("true".equals(isJGSignaturePDF)) {
            final String pdfJgSignKey = request.getParameter("pdfJgSignKey");
            if ("true".equals(pdfJgSignKey)) {
                request.setAttribute("pdfSaveGw", (Object)"true");
            }
            return mapping.findForward("editonline_jgPdfSignature");
        }
        if (SysAttWpsWebOfficeUtil.isEnable()) {
            return mapping.findForward("editonline_wps");
        }
        if (SysAttWpsCenterUtil.isEnable() || SysAttWpsCenterUtil.isV6Edit() || (isMobile && SysAttWpsCenterUtil.isWPSCenterEnableMobile(isMobile))) {
            if (SysAttWpsCenterUtil.isWpsCenterSfs() || SysAttConfigUtil.isWpsCenterV6Enabled()) {
                request.setAttribute("moduleSfsMode", (Object)"edit");
                return mapping.findForward("sysAttOnLineThirdSfs");
            }
            return mapping.findForward("editonline_wps_center");
        }
        else {
            if (SysAttYozoUtil.isEnable() || SysAttYozoUtil.isYozowoEnableMobile(isMobile)) {
                request.setAttribute("moduleSfsMode", (Object)"edit");
                return mapping.findForward("sysAttOnLineThirdSfs");
            }
            if ((!isMobile && SysAttWpsCloudUtil.isEnable()) || (isMobile && SysAttWpsCloudUtil.isEnable(isMobile))) {
                if (sysAttMain != null && !SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMain.getFdId())) {
                    SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMain.getFdId());
                    return mapping.findForward("editonline_wps_cloud");
                }
                return mapping.findForward("editonline_wps_cloud");
            }
            else {
                final boolean isJGEnabled = JgWebOffice.isJGEnabled();
                if (isJGEnabled) {
                    return mapping.findForward("editonline_jg");
                }
                return mapping.findForward("editonline");
            }
        }
    }
    
    public ActionForward editDownload(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        try {
            final String head = request.getHeader("User-Agent");
            if ("LKS Software".equals(head)) {
                return this.download(mapping, form, request, response);
            }
            messages.addMsg(new KmssMessage("Illegal access error!"));
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            return mapping.findForward("failure");
        }
        final boolean isJGEnabled = JgWebOffice.isJGEnabled();
        if (isJGEnabled) {
            return mapping.findForward("editonline_jg");
        }
        return mapping.findForward("editonline");
    }
    
    private ActionForward routeView(final ActionMapping mapping, final HttpServletRequest request, final HttpServletResponse response, final SysAttMain sysAttMain, final OutputStream out, final InputStream in) throws Exception {
        final SysAttMainForm sysAttMainForm = new SysAttMainForm();
        BeanUtils.copyProperties((Object)sysAttMainForm, (Object)sysAttMain);
        request.setAttribute("sysAttMainForm", (Object)sysAttMainForm);
        final String viewType = request.getParameter("viewType");
        final Boolean isWindows = SysAttWpsCloudUtil.checkWpsPreviewIsWindows();
        final Boolean isLinux = SysAttWpsCloudUtil.checkWpsPreviewIsLinux();
        final String directPreview = request.getParameter("directPreview");
        final String extName = SysAttViewerUtil.getExtName(sysAttMain.getFdFileName()).toLowerCase();
        if (StringUtil.isNotNull(directPreview)) {
            request.setAttribute("directPreview", (Object)directPreview);
        }
        if (SysAttMainAction.logger.isDebugEnabled()) {
            SysAttMainAction.logger.debug("文件阅读模式路由开始, viewType = {}, onlineToolType = {}, readOLConfig = {}, isWindows = {}, isLinux = {}, attMainId = {}, fileName = {}", viewType, SysAttConfigUtil.getOnlineToolType(), SysAttConfigUtil.getReadOLConfig(), isWindows, isLinux, sysAttMain.getFdId(), sysAttMain.getFdFileName());
        }
        if (StringUtils.isNotEmpty(viewType) && ("0".equals(SysAttConfigUtil.getOnlineToolType()) || "jg".equals(viewType))) {
            final String fdFileName = sysAttMain.getFdFileName();
            if (!JgWebOffice.isPDF(fdFileName) && !JgWebOffice.isOFD(fdFileName)) {
                return mapping.findForward("viewonline_jg");
            }
            if (JgWebOffice.isOfficePDFJudge() && ((JgWebOffice.isOFD(fdFileName) && JgWebOffice.isJGPDF2018Enabled()) || JgWebOffice.isPDF(fdFileName))) {
                return mapping.findForward("viewonline_pdf");
            }
        }
        final String pdfJgSignKey = request.getParameter("pdfJgSignKey");
        if (StringUtil.isNotNull(pdfJgSignKey)) {
            return this.viewByAspose(mapping, request, response, out, in, sysAttMain);
        }
        final String readOLConfig;
        switch (readOLConfig = SysAttConfigUtil.getReadOLConfig()) {
            case "1": {
                return this.viewByAspose(mapping, request, response, out, in, sysAttMain);
            }
            case "2": {
                if (isLinux) {
                    request.setAttribute("requestUrl", (Object)SysAttWpsCloudUtil.getWpsLinuxPreviewUrl(sysAttMain.getFdId()));
                    return mapping.findForward("viewonline_wps_preview");
                }
                if (isWindows) {
                    request.setAttribute("requestUrl", (Object)SysAttWpsCloudUtil.getWpsWindowPreviewUrl(sysAttMain.getFdId()));
                    return mapping.findForward("viewonline_wps_preview");
                }
                break;
            }
            case "3": {
                if (!SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMain.getFdId())) {
                    SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMain.getFdId());
                }
                return mapping.findForward("viewonline_wps_cloud");
            }
            case "4": {
                if (SysAttViewerUtil.isPicAtt(sysAttMain)) {
                    break;
                }
                final List typeLs = Arrays.asList((Object[])SysAttConstant.DIANJU_VIEW_TYPE);
                if (!typeLs.contains(extName)) {
                    return null;
                }
                request.setAttribute("attMain", (Object)sysAttMain);
                final com.alibaba.fastjson.JSONObject params = new com.alibaba.fastjson.JSONObject();
                params.put("fdAttMainId", (Object)sysAttMain.getFdId());
                params.put("waterMarkText", (Object)UserUtil.getKMSSUser().getUserName());
                final String previewUrl = SysAttThirdProxyUtil.getViewUrl("dianju", params).getData().getString("url");
                request.setAttribute("previewUrl", (Object)previewUrl);
                request.setAttribute("moduleSfsMode", (Object)"view");
                return mapping.findForward("sysAttOnLineThirdSfs");
            }
            case "5": {
                if (SysAttViewerUtil.isPicAtt(sysAttMain)) {
                    break;
                }
                final List typeLs = Arrays.asList((Object[])SysAttConstant.CENTER_VIEW_TYPE);
                if (!typeLs.contains(extName)) {
                    return null;
                }
                if (SysAttWpsCenterUtil.isWpsCenterSfs()) {
                    request.setAttribute("moduleSfsMode", (Object)"view");
                    return mapping.findForward("sysAttOnLineThirdSfs");
                }
                return mapping.findForward("viewonline_wps_center");
            }
            case "6": {
                if (SysAttViewerUtil.isPicAtt(sysAttMain)) {
                    break;
                }
                final List typeLs = Arrays.asList((Object[])SysAttConstant.FOXIT_VIEW_TYPE);
                if (!typeLs.contains(extName)) {
                    return null;
                }
                final com.alibaba.fastjson.JSONObject params = new com.alibaba.fastjson.JSONObject();
                params.put("sysAttMain", (Object)sysAttMain);
                final String previewUrl = SysAttThirdProxyUtil.getViewUrl("foxit", params).getData().getString("url");
                request.setAttribute("attMain", (Object)sysAttMain);
                request.setAttribute("previewUrl", (Object)previewUrl);
                request.setAttribute("moduleSfsMode", (Object)"view");
                return mapping.findForward("sysAttOnLineThirdSfs");
            }
            case "7": {
                SysAttYozoUtil.checkEditCache(sysAttMain.getFdId());
                if (SysAttViewerUtil.isPicAtt(sysAttMain)) {
                    break;
                }
                final List typeLs = Arrays.asList((Object[])SysAttConstant.YOZO_VIEW_TYPE);
                if (!typeLs.contains(extName)) {
                    return null;
                }
                final boolean isMobile = MobileUtil.isMobile(request);
                request.setAttribute("isMobile", (Object)isMobile);
                request.setAttribute("attMain", (Object)sysAttMain);
                SysAttYozoUtil.setIsAtt(request, sysAttMain);
                if (isMobile) {
                    request.setAttribute("previewUrl", (Object)SysAttYozoUtil.getYozoPreviewUrl(request, sysAttMain.getFdId()));
                }
                request.setAttribute("moduleSfsMode", (Object)"view");
                return mapping.findForward("sysAttOnLineThirdSfs");
            }
            case "8": {
                if (SysAttViewerUtil.isPicAtt(sysAttMain)) {
                    break;
                }
                final List typeLs = Arrays.asList((Object[])SysAttConstant.CENTER_VIEW_TYPE);
                if (!typeLs.contains(extName)) {
                    return null;
                }
                request.setAttribute("moduleSfsMode", (Object)"view");
                return mapping.findForward("sysAttOnLineThirdSfs");
            }
            case "9": {
                if (SysAttViewerUtil.isPicAtt(sysAttMain)) {
                    break;
                }
                final List typeLs = Arrays.asList((Object[])SysAttConstant.SUWELL_VIEW_TYPE);
                if (!typeLs.contains(extName)) {
                    return null;
                }
                if (MobileUtil.isMobile(request)) {
                    request.setAttribute("previewUrl", (Object)SysAttSuwellUtil.getSuwellPreviewUrl(sysAttMain.getFdId()));
                }
                request.setAttribute("moduleSfsMode", (Object)"view");
                return mapping.findForward("sysAttOnLineThirdSfs");
            }
            default:
                break;
        }
        return null;
    }
    
    private ActionForward viewByAspose(final ActionMapping mapping, final HttpServletRequest request, final HttpServletResponse response, final OutputStream out, final InputStream in, final SysAttMain sysAttMain) throws Exception {
        final List<SysFileStoreUtil.FileConverter> fileConverters = SysFileStoreUtil.getFileConverters(SysAttViewerUtil.getExtName(sysAttMain.getFdFileName()), sysAttMain.getFdModelName(), SysFileStoreUtil.isOldConvertSuccessUseHTML());
        request.setAttribute("fdId", (Object)sysAttMain.getFdId());
        final List<SysFileViewerParam> convertedParamsList = SysAttViewerUtil.getConvertedParams(sysAttMain);
        final String fdAttMainId = sysAttMain.getFdId();
        final String contentType = sysAttMain.getFdContentType();
        if (this.needPrintStream(request)) {
            request.setAttribute("printStream", (Object)"true");
            return this.printStream(request, response, out, in, sysAttMain, convertedParamsList, fileConverters);
        }
        if (SysFileStoreUtil.isAttConvertEnable()) {
            SysAttViewerUtil.addQueue(sysAttMain);
        }
        if ((!SysAttViewerUtil.isPicAtt(sysAttMain) && (convertedParamsList == null || convertedParamsList.size() == 0) && !contentType.contains("video")) || (fileConverters.size() == 0 && !contentType.contains("video"))) {
            final ActionForward forward = this.handleAspose(mapping, request, sysAttMain);
            if (forward != null) {
                return forward;
            }
        }
        String viewerPath = SysAttViewerUtil.getViewerPath(sysAttMain, (List)convertedParamsList, (List)fileConverters, request);
        final IBaseModel model = this.getServiceImp(request).findByPrimaryKey(sysAttMain.getFdModelId(), (Object)sysAttMain.getFdModelName(), true);
        if (model != null && PropertyUtils.isReadable((Object)model, "docStatus")) {
            final Object docStatus = PropertyUtils.getProperty((Object)model, "docStatus");
            if (docStatus != null) {
                request.setAttribute("docStatus", (Object)docStatus.toString());
            }
        }
        final String forwardModule = request.getParameter("forwardModule");
        if (StringUtil.isNotNull(forwardModule) && StringUtil.isNotNull(viewerPath)) {
            final String[] moduleStrArr = forwardModule.split("\\.");
            if (moduleStrArr.length > 4) {
                final String key1 = moduleStrArr[3];
                final String key2 = moduleStrArr[4];
                viewerPath = "/" + key1 + "/" + key2 + "/" + viewerPath.replaceAll("^(?:[^/]*/){3}(.*)$", "$1");
            }
            if (forwardModule.indexOf("kms.train") > -1) {
                final String type = request.getParameter("type");
                if (StringUtil.isNotNull(type)) {
                    viewerPath = StringUtil.linkString(viewerPath, "?type=", type);
                }
                final String editAuth = request.getParameter("editAuth");
                if (StringUtil.isNotNull(editAuth)) {
                    if (viewerPath.indexOf("?") > -1) {
                        viewerPath = StringUtil.linkString(viewerPath, "&editAuth=", editAuth);
                    }
                    else {
                        viewerPath = StringUtil.linkString(viewerPath, "?editAuth=", editAuth);
                    }
                }
                final String isConfirmAttend = request.getParameter("isConfirmAttend");
                if (StringUtil.isNotNull(isConfirmAttend)) {
                    if (viewerPath.indexOf("?") > -1) {
                        viewerPath = StringUtil.linkString(viewerPath, "&isConfirmAttend=", isConfirmAttend);
                    }
                    else {
                        viewerPath = StringUtil.linkString(viewerPath, "?isConfirmAttend=", isConfirmAttend);
                    }
                }
                final String fdModelId = request.getParameter("fdModelId");
                if (StringUtil.isNotNull(fdModelId)) {
                    if (viewerPath.indexOf("?") > -1) {
                        viewerPath = StringUtil.linkString(viewerPath, "&fdModelId=", fdModelId);
                    }
                    else {
                        viewerPath = StringUtil.linkString(viewerPath, "?fdModelId=", fdModelId);
                    }
                }
            }
        }
        if (StringUtil.isNotNull(viewerPath) && (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(sysAttMain.getFdFileName())) || contentType.contains("video") || SysAttUtil.isCADType(FilenameUtils.getExtension(sysAttMain.getFdFileName())))) {
            if ("com.landray.kmss.km.agreement.model.KmAgreementApply".equals(sysAttMain.getFdModelName()) || "com.landray.kmss.km.agreement.model.KmAgreementModel".equals(sysAttMain.getFdModelName())) {
                final String viewer = request.getParameter("viewer");
                if ("htmlviewer".equals(viewer)) {
                    final boolean canCopy = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + fdAttMainId, "GET");
                    request.setAttribute("canCopy", (Object)canCopy);
                    final boolean canPrint = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + fdAttMainId, "GET");
                    request.setAttribute("canPrint", (Object)canPrint);
                    request.setAttribute("fdKey", (Object)sysAttMain.getFdKey().toLowerCase());
                    request.setAttribute("fdModelName", (Object)sysAttMain.getFdModelName());
                    return new ActionForward(viewerPath);
                }
            }
            final boolean canCopy2 = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + fdAttMainId, "GET");
            request.setAttribute("canCopy", (Object)canCopy2);
            final boolean canPrint2 = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + fdAttMainId, "GET");
            request.setAttribute("canPrint", (Object)canPrint2);
            request.setAttribute("fdKey", (Object)sysAttMain.getFdKey().toLowerCase());
            request.setAttribute("fdModelName", (Object)sysAttMain.getFdModelName());
            request.setAttribute("fdAttMainId", (Object)sysAttMain.getFdId());
            return new ActionForward(viewerPath);
        }
        if (SysAttUtil.isOfficeType(FilenameUtils.getExtension(sysAttMain.getFdFileName()))) {
            if ("0".equals(SysAttConfigUtil.getOnlineToolType())) {
                return mapping.findForward("viewonline_jg");
            }
            if ("3".equals(SysAttConfigUtil.getOnlineToolType())) {
                return mapping.findForward("viewonline_wps_jiazaix");
            }
            return null;
        }
        else {
            if (contentType.contains("video")) {
                return mapping.findForward("viewonline_video_converting");
            }
            return null;
        }
    }
    
    private ActionForward handleAspose(final ActionMapping mapping, final HttpServletRequest request, final SysAttMain attMain) throws Exception {
        final boolean isMoblie = this.isMobileRequest(request);
        final String fdFileName = attMain.getFdFileName();
        final String previewType = SysAttViewerUtil.getPreView(attMain, isMoblie);
        if (JgWebOffice.isPDF(fdFileName) || JgWebOffice.isOFD(fdFileName)) {
            if (!JgWebOffice.isOfficePDFJudge()) {
                return mapping.findForward("viewonline_nopdf");
            }
            if ((JgWebOffice.isOFD(fdFileName) && JgWebOffice.isJGPDF2018Enabled()) || JgWebOffice.isPDF(fdFileName)) {
                return mapping.findForward("viewonline_pdf");
            }
        }
        if ("converting".equals(previewType)) {
            return mapping.findForward("viewonline_converting");
        }
        if (SysAttUtil.isOfficeType(FilenameUtils.getExtension(attMain.getFdFileName()))) {
            if ("0".equals(SysAttConfigUtil.getOnlineToolType())) {
                return mapping.findForward("viewonline_jg");
            }
            if ("3".equals(SysAttConfigUtil.getOnlineToolType())) {
                if (SysAttWpsoaassistUtil.isWPSOAassistEmbed(request)) {
                    final SysAttMainForm sysAttMainForm = new SysAttMainForm();
                    BeanUtils.copyProperties((Object)sysAttMainForm, (Object)attMain);
                    request.setAttribute("sysAttMainForm", (Object)sysAttMainForm);
                    return mapping.findForward("viewonline_wps_oaassist_linux");
                }
                return mapping.findForward("viewonline_wps_jiazaix");
            }
        }
        return null;
    }
    
    private ActionForward printStream(final HttpServletRequest request, final HttpServletResponse response, OutputStream out, InputStream in, final SysAttMain sysAttMain, final List<SysFileViewerParam> convertedParamsList, final List<SysFileStoreUtil.FileConverter> fileConverters) throws Exception {
        final String fileThumb = request.getParameter("filethumb");
        final String picThumb = request.getParameter("picthumb");
        final String fileKey = request.getParameter("filekey");
        final String converterKey = (request.getAttribute("converterKey") != null) ? request.getAttribute("converterKey").toString() : "";
        final String referer = request.getHeader("referer");
        if (StringUtil.isNull(referer)) {
            final StringBuffer newUrl = new StringBuffer(request.getRequestURL());
            newUrl.append("?method=view&fdId=").append(request.getParameter("fdId"));
            response.sendRedirect(newUrl.toString());
        }
        else {
            if (StringUtil.isNotNull(picThumb)) {
                final String mime = FileMimeTypeUtil.getContentType(sysAttMain.getFdFileName());
                response.setContentType(mime);
            }
            else if (StringUtil.isNotNull(fileKey) && fileKey.toLowerCase().contains("cad")) {
                response.setContentType("image/png;charset=UTF-8");
            }
            else if (!converterKey.toLowerCase().contains("swf")) {
                response.setHeader("Content-type", "text/html;charset=UTF-8");
                response.setContentType("text/html;charset=UTF-8");
                response.setCharacterEncoding("UTF-8");
            }
            SysAttFile attFile = null;
            final String fdType = request.getParameter("fdType");
            boolean isRtf = false;
            if (fdType != null && "rtf".equals(fdType)) {
                isRtf = true;
            }
            if (isRtf) {
                attFile = this.getAttUploadService().getFileById(sysAttMain.getFdFileId());
            }
            else {
                attFile = this.getServiceImp(request).getFile(sysAttMain.getFdId());
            }
            final ISysFileLocationDirectService directService = SysFileLocationUtil.getDirectService(attFile.getFdAttLocation());
            if (StringUtil.isNotNull(picThumb)) {
                if (directService.isSupportDirect(request.getHeader("User-Agent"))) {
                    final String fdPath = SysAttViewerUtil.getPicThumbPath((SysAttBase)sysAttMain, picThumb);
                    final String fileName = String.valueOf(sysAttMain.getFdFileName()) + ".jpeg";
                    this.viewDirect(request, response, fdPath, fileName, sysAttMain.getFdId());
                    return null;
                }
                in = SysAttViewerUtil.getPicThumbStream(sysAttMain, request);
            }
            else if (StringUtil.isNotNull(fileThumb) && "yes".equals(fileThumb)) {
                if (directService.isSupportDirect("")) {
                    final String fdPath = SysAttViewerUtil.getFileThumbPath(sysAttMain, (List)convertedParamsList, (List)fileConverters, request);
                    final String fileName = String.valueOf(sysAttMain.getFdFileName()) + ".jpeg";
                    this.viewDirect(request, response, fdPath, fileName, sysAttMain.getFdId());
                    return null;
                }
                in = SysAttViewerUtil.getFileThumbInputStream(sysAttMain, (List)convertedParamsList, (List)fileConverters, request);
            }
            else if (StringUtil.isNotNull(fileKey)) {
                in = SysAttViewerUtil.getConvertFileInputStream(sysAttMain, fileKey);
            }
            out = (OutputStream)response.getOutputStream();
            if (in != null) {
                IOUtil.write(in, out);
            }
        }
        return null;
    }
    
    public ActionForward view(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final boolean attConvertEnable = SysFileStoreUtil.isAttConvertEnable();
        final boolean oldConvertSuccessUseHTMLView = SysFileStoreUtil.isOldConvertSuccessUseHTML();
        InputStream in = null;
        OutputStream out = null;
        final boolean isMobile = this.isMobileRequest(request);
        try {
            String viewerPath = "";
            final String fdAttMainId = request.getParameter("fdId");
            final String fdType = request.getParameter("fdType");
            request.setAttribute("fdId", (Object)fdAttMainId);
            final String showBar = request.getParameter("showBar");
            if ("false".equals(showBar)) {
                request.setAttribute("showBar", (Object)"false");
            }
            final String isCowriting = request.getParameter("isCowriting");
            if ("false".equals(isCowriting)) {
                request.setAttribute("isCowriting", (Object)"false");
            }
            final String requestViewType = request.getParameter("viewType");
            final String viewType = StringUtil.isNull(requestViewType) ? "html" : requestViewType;
            final String fKey = request.getParameter("filekey");
            Boolean viewImg = false;
            boolean isRtf = false;
            if (fdType != null && "rtf".equals(fdType)) {
                isRtf = true;
            }
            SysAttMain sysAttMain = null;
            if (isRtf) {
                final SysAttRtfData sysAttRtfData = this.getServiceImp(request).findRtfDataByPrimaryKey(fdAttMainId);
                sysAttMain = new SysAttMain();
                sysAttMain.setFdId(fdAttMainId);
                sysAttMain.setFdSize(sysAttRtfData.getFdSize());
                sysAttMain.setFdModelId(sysAttRtfData.getFdModelId());
                sysAttMain.setFdModelName(sysAttRtfData.getFdModelName());
                sysAttMain.setFdFileName(sysAttRtfData.getFdFileName());
                sysAttMain.setFdFileId(sysAttRtfData.getFdFileId());
                sysAttMain.setFdContentType(sysAttRtfData.getFdContentType());
            }
            else {
                sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdAttMainId);
                if (sysAttMain != null && StringUtil.isNotNull(sysAttMain.getFdFileName())) {
                    String _fdFileName = "";
                    _fdFileName = sysAttMain.getFdFileName().replaceAll("[/\\\\:*?|]", "-");
                    _fdFileName = _fdFileName.replaceAll("[\"<>]", "'");
                    sysAttMain.setFdFileName(_fdFileName);
                }
            }
            if ((StringUtil.isNotNull(fKey) && "image2thumbnail_s1".equals(fKey)) || SysAttViewerUtil.isPicAtt(sysAttMain) || "yes".equals(request.getParameter("filethumb"))) {
                viewImg = true;
            }
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.debug("view the parameter of viewImg:" + viewImg);
            }
            if (UserOperHelper.allowLogOper("Action_Find", SysAttMain.class.getName())) {
                UserOperContentHelper.putAdd(sysAttMain.getFdId(), sysAttMain.getFdFileName(), SysAttMain.class.getName());
            }
            final String actionForwardUrl = SysAttCustomPageUtil.getCustomPage(request);
            if (StringUtil.isNotNull(actionForwardUrl) && !isMobile && !viewImg) {
                return new ActionForward(actionForwardUrl);
            }
            final String forward = SysAttOcxUtil.getOcxPageForward(sysAttMain.getFdKey(), sysAttMain.getFdModelName(), "view");
            if (StringUtil.isNotNull(forward) && !isMobile) {
                if ("viewonline_wps_cloud".equals(forward) && !SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMain.getFdId())) {
                    SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMain.getFdId());
                }
                final String viewer = request.getParameter("viewer");
                if (!"htmlviewer".equals(viewer) && !StringUtil.isNull(viewer)) {
                    final SysAttMainForm sysAttMainForm = new SysAttMainForm();
                    BeanUtils.copyProperties((Object)sysAttMainForm, (Object)sysAttMain);
                    request.setAttribute("sysAttMainForm", (Object)sysAttMainForm);
                    request.setAttribute("moduleSfsMode", (Object)"view");
                    if ("sysAttOnLineThirdSfs".equals(forward)) {
                        final String ocxType = SysAttOcxUtil.getOcxType(sysAttMain.getFdKey(), sysAttMain.getFdModelName());
                        String busiViewType = "";
                        if ("08".equals(ocxType)) {
                            busiViewType = "7";
                        }
                        else if ("09".equals(ocxType)) {
                            busiViewType = "8";
                        }
                        request.setAttribute("busiViewType", (Object)busiViewType);
                    }
                    return mapping.findForward(forward);
                }
            }
            final String contentType = sysAttMain.getFdContentType();
            if (contentType.contains("video")) {
                return this.viewByAspose(mapping, request, response, out, in, sysAttMain);
            }
            if (isMobile && SysAttUtil.viewByBrowser(sysAttMain)) {
                request.setAttribute("downUrl", (Object)SysAttViewerUtil.getDownloadUrl(sysAttMain));
                request.setAttribute("fileName", (Object)sysAttMain.getFdFileName());
                return mapping.findForward("view_online_pdfh5");
            }
            if (isMobile && SysAttConfigUtil.pdfReadByFoxitMobile() && JgWebOffice.isPDF(sysAttMain.getFdFileName())) {
                this.getSysAttMainFoxitService().createRequestMateData(request, sysAttMain, Boolean.valueOf(false));
                return mapping.findForward("viewonline_foxit");
            }
            if (!viewImg && AttImageUtils.cacheConsulation(request, response, contentType, sysAttMain.getFdFileName())) {
                return null;
            }
            request.setAttribute("fdModelName", (Object)sysAttMain.getFdModelName());
            if ("audio_mp3".equals(viewType)) {
                return this.viewByaudiomp3(mapping, form, request, response);
            }
            final ActionForward routeView = this.routeView(mapping, request, response, sysAttMain, out, in);
            if (!viewImg && ("true".equals(request.getAttribute("printStream")) || routeView != null)) {
                return routeView;
            }
            if ("jg".equals(viewType) || (SysAttWpsCloudUtil.getUseWpsLinuxView() && !viewImg)) {
                return this.viewByJG(mapping, form, request, response, sysAttMain);
            }
            if ("audio_mp3".equals(viewType)) {
                return this.viewByaudiomp3(mapping, form, request, response);
            }
            final List<SysFileStoreUtil.FileConverter> fileConverters = SysFileStoreUtil.getFileConverters(SysAttViewerUtil.getExtName(sysAttMain.getFdFileName()), sysAttMain.getFdModelName(), oldConvertSuccessUseHTMLView);
            final List<SysFileViewerParam> convertedParamsList = SysAttViewerUtil.getConvertedParams(sysAttMain);
            if (convertedParamsList == null || convertedParamsList.size() == 0) {}
            if (this.needPrintStream(request)) {
                final String fileThumb = request.getParameter("filethumb");
                final String picThumb = request.getParameter("picthumb");
                final String fileKey = request.getParameter("filekey");
                final String converterKey = (request.getAttribute("converterKey") != null) ? request.getAttribute("converterKey").toString() : "";
                out = (OutputStream)response.getOutputStream();
                final String referer = request.getHeader("referer");
                if (StringUtil.isNull(referer)) {
                    final StringBuffer newUrl = new StringBuffer(request.getRequestURL());
                    newUrl.append("?method=view&fdId=").append(request.getParameter("fdId"));
                    response.sendRedirect(newUrl.toString());
                }
                else {
                    if (StringUtil.isNotNull(picThumb)) {
                        final String mime = FileMimeTypeUtil.getContentType(sysAttMain.getFdFileName());
                        response.setContentType(mime);
                    }
                    else if (StringUtil.isNotNull(fileKey) && fileKey.toLowerCase().contains("cad")) {
                        response.setContentType("image/png;charset=UTF-8");
                    }
                    else if (!converterKey.toLowerCase().contains("swf")) {
                        response.setHeader("Content-type", "text/html;charset=UTF-8");
                        response.setContentType("text/html;charset=UTF-8");
                        response.setCharacterEncoding("UTF-8");
                    }
                    SysAttFile attFile = null;
                    if (isRtf) {
                        attFile = this.getAttUploadService().getFileById(sysAttMain.getFdFileId());
                    }
                    else {
                        attFile = this.getServiceImp(request).getFile(fdAttMainId);
                    }
                    final ISysFileLocationDirectService directService = SysFileLocationUtil.getDirectService(attFile.getFdAttLocation());
                    if (StringUtil.isNotNull(picThumb)) {
                        if (directService.isSupportDirect(request.getHeader("User-Agent"))) {
                            final String fdPath = SysAttViewerUtil.getPicThumbPath((SysAttBase)sysAttMain, picThumb);
                            final String fileName = String.valueOf(sysAttMain.getFdFileName()) + ".jpeg";
                            this.viewDirect(request, response, fdPath, fileName, sysAttMain.getFdId());
                            return null;
                        }
                        in = SysAttViewerUtil.getPicThumbStream(sysAttMain, request);
                    }
                    else if (StringUtil.isNotNull(fileThumb) && "yes".equals(fileThumb)) {
                        if (directService.isSupportDirect("")) {
                            final String fdPath = SysAttViewerUtil.getFileThumbPath(sysAttMain, (List)convertedParamsList, (List)fileConverters, request);
                            final String fileName = String.valueOf(sysAttMain.getFdFileName()) + ".jpeg";
                            this.viewDirect(request, response, fdPath, fileName, sysAttMain.getFdId());
                            return null;
                        }
                        in = SysAttViewerUtil.getFileThumbInputStream(sysAttMain, (List)convertedParamsList, (List)fileConverters, request);
                    }
                    else if (StringUtil.isNotNull(fileKey)) {
                        in = SysAttViewerUtil.getConvertFileInputStream(sysAttMain, fileKey);
                    }
                    out = (OutputStream)response.getOutputStream();
                    if (in != null) {
                        IOUtil.write(in, out);
                    }
                }
                return null;
            }
            if (attConvertEnable) {
                SysAttViewerUtil.addQueue(sysAttMain);
            }
            if (!SysAttViewerUtil.isPicAtt(sysAttMain) && (convertedParamsList == null || convertedParamsList.size() == 0) && !contentType.contains("video")) {
                return this.viewByJG(mapping, form, request, response, sysAttMain);
            }
            if (fileConverters.size() == 0 && !contentType.contains("video")) {
                return this.viewByJG(mapping, form, request, response, sysAttMain);
            }
            viewerPath = SysAttViewerUtil.getViewerPath(sysAttMain, (List)convertedParamsList, (List)fileConverters, request);
            final IBaseModel model = this.getServiceImp(request).findByPrimaryKey(sysAttMain.getFdModelId(), (Object)sysAttMain.getFdModelName(), true);
            if (model != null && PropertyUtils.isReadable((Object)model, "docStatus")) {
                final String docStatus = (String)PropertyUtils.getProperty((Object)model, "docStatus");
                if (StringUtil.isNotNull(docStatus)) {
                    request.setAttribute("docStatus", (Object)docStatus);
                }
            }
            final String forwardModule = request.getParameter("forwardModule");
            if (StringUtil.isNotNull(forwardModule) && StringUtil.isNotNull(viewerPath)) {
                final String[] moduleStrArr = forwardModule.split("\\.");
                if (moduleStrArr.length > 4) {
                    final String key1 = moduleStrArr[3];
                    final String key2 = moduleStrArr[4];
                    viewerPath = "/" + key1 + "/" + key2 + "/" + viewerPath.replaceAll("^(?:[^/]*/){3}(.*)$", "$1");
                }
                if (forwardModule.indexOf("kms.train") > -1) {
                    final String type = request.getParameter("type");
                    if (StringUtil.isNotNull(type)) {
                        viewerPath = StringUtil.linkString(viewerPath, "?type=", type);
                    }
                    final String editAuth = request.getParameter("editAuth");
                    if (StringUtil.isNotNull(editAuth)) {
                        if (viewerPath.indexOf("?") > -1) {
                            viewerPath = StringUtil.linkString(viewerPath, "&editAuth=", editAuth);
                        }
                        else {
                            viewerPath = StringUtil.linkString(viewerPath, "?editAuth=", editAuth);
                        }
                    }
                    final String isConfirmAttend = request.getParameter("isConfirmAttend");
                    if (StringUtil.isNotNull(isConfirmAttend)) {
                        if (viewerPath.indexOf("?") > -1) {
                            viewerPath = StringUtil.linkString(viewerPath, "&isConfirmAttend=", isConfirmAttend);
                        }
                        else {
                            viewerPath = StringUtil.linkString(viewerPath, "?isConfirmAttend=", isConfirmAttend);
                        }
                    }
                    final String fdModelId = request.getParameter("fdModelId");
                    if (StringUtil.isNotNull(fdModelId)) {
                        if (viewerPath.indexOf("?") > -1) {
                            viewerPath = StringUtil.linkString(viewerPath, "&fdModelId=", fdModelId);
                        }
                        else {
                            viewerPath = StringUtil.linkString(viewerPath, "?fdModelId=", fdModelId);
                        }
                    }
                }
            }
            if (StringUtil.isNotNull(viewerPath)) {
                if ("com.landray.kmss.km.agreement.model.KmAgreementApply".equals(sysAttMain.getFdModelName()) || "com.landray.kmss.km.agreement.model.KmAgreementModel".equals(sysAttMain.getFdModelName())) {
                    final String viewer2 = request.getParameter("viewer");
                    if ("htmlviewer".equals(viewer2)) {
                        final boolean canCopy = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + fdAttMainId, "GET");
                        request.setAttribute("canCopy", (Object)canCopy);
                        final boolean canPrint = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + fdAttMainId, "GET");
                        request.setAttribute("canPrint", (Object)canPrint);
                        request.setAttribute("fdKey", (Object)sysAttMain.getFdKey().toLowerCase());
                        request.setAttribute("fdModelName", (Object)sysAttMain.getFdModelName());
                        return new ActionForward(viewerPath);
                    }
                }
                final boolean canCopy2 = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + fdAttMainId, "GET");
                request.setAttribute("canCopy", (Object)canCopy2);
                final boolean canPrint2 = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + fdAttMainId, "GET");
                request.setAttribute("canPrint", (Object)canPrint2);
                request.setAttribute("fdKey", (Object)sysAttMain.getFdKey().toLowerCase());
                request.setAttribute("fdModelName", (Object)sysAttMain.getFdModelName());
                request.setAttribute("fdAttMainId", (Object)sysAttMain.getFdId());
                return new ActionForward(viewerPath);
            }
            if (SysAttUtil.isOfficeType(FilenameUtils.getExtension(sysAttMain.getFdFileName()))) {
                return this.viewByJG(mapping, form, request, response, sysAttMain);
            }
            if (contentType.contains("video")) {
                return mapping.findForward("viewonline_video_converting");
            }
            return null;
        }
        catch (final Exception e) {
            SysAttMainAction.logger.error("error", e);
            this.streamClose(in, out);
            return null;
        }
        finally {
            this.streamClose(in, out);
        }
    }
    
    private Boolean downloadDirect(final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdId = request.getParameter("fdId");
        if ("false".equals(request.getParameter("isSupportDirect"))) {
            return false;
        }
        if (StringUtil.isNull(fdId) || fdId.indexOf(";") >= 0) {
            return false;
        }
        final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
        if (sysAttMain == null || SysAttBase.ATTACHMENT_LOCATION_DB.equals(sysAttMain.getFdAttLocation()) || SysAttMain.ATTACHMENT_LOCATION_FILE.equalsIgnoreCase(sysAttMain.getFdAttLocation())) {
            return false;
        }
        final SysAttFile attFile = this.getServiceImp(request).getFile(fdId);
        final ISysFileLocationDirectService directService = SysFileLocationUtil.getDirectService(attFile.getFdAttLocation());
        if (directService.isSupportDirect("")) {
            final String path = this.getServiceImp(request).getFilePath(fdId);
            final String url = directService.getDownloadUrl(path, sysAttMain.getFdFileName());
            if (StringUtil.isNotNull(url)) {
                response.sendRedirect(SysAttViewerUtil.formatUrl(request, url));
                final String[] fids = fdId.split(";");
                final List<SysAttMain> sysAttMains = this.getServiceImp(request).getSysAttMainDao().findByPrimaryKeys(fids);
                this.getSysAttDownloadLogService().addDownloadLogByAttList((List)sysAttMains, new RequestContext(request));
                return true;
            }
        }
        return false;
    }
    
    private void viewDirect(final HttpServletRequest request, final HttpServletResponse response, final String fdPath, final String fileName, final String fdMainId) throws Exception {
        if (StringUtil.isNull(fdPath)) {
            response.sendRedirect(String.valueOf(request.getContextPath()) + "/sys/attachment/viewer/resource/common/images/unConverted.png");
            return;
        }
        final SysAttFile attFile = this.getServiceImp(request).getFile(fdMainId);
        final ISysFileLocationDirectService directService = SysFileLocationUtil.getDirectService(attFile.getFdAttLocation());
        final String url = directService.getDownloadUrl(fdPath, fileName);
        if (StringUtil.isNotNull(url)) {
            response.sendRedirect(SysAttViewerUtil.formatUrl(request, url));
        }
    }
    
    private void viewDirectByRtf(final HttpServletRequest request, final HttpServletResponse response, final String fdPath, final String fileName, final String fdFileId) throws Exception {
        if (StringUtil.isNull(fdPath)) {
            response.sendRedirect(String.valueOf(request.getContextPath()) + "/sys/attachment/viewer/resource/common/images/unConverted.png");
            return;
        }
        final SysAttFile attFile = this.getAttUploadService().getFileById(fdFileId);
        final ISysFileLocationDirectService directService = SysFileLocationUtil.getDirectService(attFile.getFdAttLocation());
        final String url = directService.getDownloadUrl(fdPath, fileName);
        if (StringUtil.isNotNull(url)) {
            response.sendRedirect(SysAttViewerUtil.formatUrl(request, url));
        }
    }
    
    private ActionForward viewByJG(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response, final SysAttMain attMain) throws Exception {
        final SysAttMainForm sysAttMainForm = new SysAttMainForm();
        BeanUtils.copyProperties((Object)sysAttMainForm, (Object)attMain);
        request.setAttribute("sysAttMainForm", (Object)sysAttMainForm);
        final String fdFileName = attMain.getFdFileName();
        final String inner = request.getParameter("inner");
        final String fdForceUseJG = request.getParameter("fdForceUseJG");
        final String attMainId = attMain.getFdId();
        final boolean isMoblie = this.isMobileRequest(request);
        if ("yes".equals(inner)) {
            request.setAttribute("inner", (Object)"true");
        }
        if (SysAttWpsCenterUtil.isEnable()) {
            request.setAttribute("directPreview", (Object)request.getParameter("directPreview"));
            return mapping.findForward("viewonline_wps_center");
        }
        final boolean isWpsoaassist = SysAttWpsoaassistUtil.isEnable();
        final boolean isWpsoaassistEmbed = SysAttWpsoaassistUtil.isWPSOAassistEmbed();
        if (!"yes".equals(inner) && !isMoblie && isWpsoaassist && isWpsoaassistEmbed && (this.isWord(attMain.getFdFileName()) || this.isExcel(attMain.getFdFileName()) || this.isPpt(attMain.getFdFileName()))) {
            final String userAgent = request.getHeader("user-agent");
            final boolean winFlag = userAgent.toLowerCase().contains("win");
            if (!winFlag) {
                return mapping.findForward("viewonline_wps_oaassist_linux");
            }
        }
        final String previewType = SysAttViewerUtil.getPreView(attMain, isMoblie);
        if (SysAttWpsCloudUtil.getUseWpsLinuxView() && !JgWebOffice.isJGPDF2018Enabled()) {
            request.setAttribute("requestUrl", (Object)SysAttWpsCloudUtil.getWpsLinuxPreviewUrl(attMainId));
            return mapping.findForward("viewonline_wps_preview");
        }
        if (JgWebOffice.isPDF(fdFileName) && SysAttConfigUtil.pdfReadByFoxitPC()) {
            final String downLoadUrl = SysAttViewerUtil.getDownloadUrl(attMain);
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.info("下载地址:" + downLoadUrl);
            }
            request.setAttribute("downLoadUrl", (Object)downLoadUrl);
            return mapping.findForward("viewonline_foxit");
        }
        if (JgWebOffice.isPDF(fdFileName) || JgWebOffice.isOFD(fdFileName)) {
            if (SysAttWpsWebOfficeUtil.isEnable()) {
                return mapping.findForward("viewonline_wps");
            }
            if ("linux".equals(previewType)) {
                request.setAttribute("requestUrl", (Object)SysAttWpsCloudUtil.getWpsLinuxPreviewUrl(attMainId));
                return mapping.findForward("viewonline_wps_preview");
            }
            if ("window".equals(previewType)) {
                request.setAttribute("requestUrl", (Object)SysAttWpsCloudUtil.getWpsWindowPreviewUrl(attMainId));
                return mapping.findForward("viewonline_wps_preview");
            }
            if ("cloud".equals(previewType)) {
                if (!SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMainForm.getFdId())) {
                    SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMainForm.getFdId());
                    return mapping.findForward("viewonline_wps_cloud");
                }
            }
            else {
                if (!JgWebOffice.isOfficePDFJudge()) {
                    return mapping.findForward("viewonline_nopdf");
                }
                if ((JgWebOffice.isOFD(fdFileName) && JgWebOffice.isJGPDF2018Enabled()) || JgWebOffice.isPDF(fdFileName)) {
                    return mapping.findForward("viewonline_pdf");
                }
            }
        }
        if ("linux".equals(previewType)) {
            request.setAttribute("requestUrl", (Object)SysAttWpsCloudUtil.getWpsLinuxPreviewUrl(attMainId));
            return mapping.findForward("viewonline_wps_preview");
        }
        if ("window".equals(previewType)) {
            request.setAttribute("requestUrl", (Object)SysAttWpsCloudUtil.getWpsWindowPreviewUrl(attMainId));
            return mapping.findForward("viewonline_wps_preview");
        }
        if ("cloud".equals(previewType)) {
            if (!SysAttWpsCloudUtil.isAttHadSyncByAttMainId(attMainId)) {
                SysAttWpsCloudUtil.syncAttToAddByMainId(attMainId);
            }
            return mapping.findForward("viewonline_wps_cloud");
        }
        if ("converting".equals(previewType)) {
            return mapping.findForward("viewonline_converting");
        }
        if (StringUtil.isNotNull(attMain.getFdModelId()) && StringUtil.isNotNull(attMain.getFdModelName())) {
            final IBaseModel model = this.getServiceImp(request).findByPrimaryKey(attMain.getFdModelId(), (Object)attMain.getFdModelName(), true);
            if (model != null && PropertyUtils.isReadable((Object)model, "docStatus")) {
                final String docStatus = (String)PropertyUtils.getProperty((Object)model, "docStatus");
                if (StringUtil.isNotNull(docStatus)) {
                    request.setAttribute("docStatus", (Object)docStatus);
                }
            }
        }
        if ("true".equals(fdForceUseJG)) {
            return mapping.findForward("editonline_jg");
        }
        if (SysAttWpsWebOfficeUtil.isEnable()) {
            return mapping.findForward("viewonline_wps");
        }
        if ("cloud".equals(previewType)) {
            if (!SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMainForm.getFdId())) {
                SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMainForm.getFdId());
                return mapping.findForward("viewonline_wps_cloud");
            }
            if ("1".equals(SysAttConfigUtil.getOnlineToolType()) && "1".equals(SysAttConfigUtil.isReadWPSCloudForMobile())) {
                SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMainForm.getFdId());
                return mapping.findForward("viewonline_wps_cloud");
            }
            return mapping.findForward("viewonline_wps_cloud");
        }
        else {
            if (!isMoblie || !SysAttWpsCloudUtil.isEnable(isMoblie)) {
                return mapping.findForward("viewonline_jg");
            }
            if (!SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMainForm.getFdId())) {
                SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMainForm.getFdId());
                return mapping.findForward("viewonline_wps_cloud");
            }
            return mapping.findForward("viewonline_wps_cloud");
        }
    }
    
    private ActionForward viewByaudiomp3(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        return this.download(mapping, form, request, response);
    }
    
    private boolean needPrintStream(final HttpServletRequest request) {
        return request.getParameterMap().containsKey("filekey") || request.getParameterMap().containsKey("picthumb") || request.getParameterMap().containsKey("filethumb");
    }
    
    public ActionForward handleAttUpload(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        Map<String, Object> rtnMap = null;
        String format = request.getParameter("format");
        if (StringUtil.isNull(format)) {
            format = "xml";
        }
        final String reqType = request.getParameter("gettype");
        if ("getuserkey".equalsIgnoreCase(reqType)) {
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.debug("与客户端服务器握手中。。");
            }
            rtnMap = this.getUserKey(request, form);
        }
        else if ("submit".equalsIgnoreCase(reqType)) {
            rtnMap = this.saveAttInfo(request, form);
        }
        else if ("checkMd5".equals(reqType)) {
            this.checkMd5(request, response);
            return null;
        }
        request.setAttribute("resultMap", (Object)rtnMap);
        request.setAttribute("format", (Object)format);
        return mapping.findForward("upload_result");
    }
    
    private Map<String, Object> getUserKey(final HttpServletRequest request, final ActionForm form) {
        final Map<String, Object> rtnMap = new HashMap<String, Object>();
        try {
            SysFileSignature sign = null;
            final SysFileSignatureRequest sysFileSign = new SysFileSignatureRequest(request);
            final String isSupportDirect = request.getParameter("isSupportDirect");
            ISysFileLocationDirectService directService;
            if ("false".equals(isSupportDirect)) {
                directService = SysFileLocationUtil.getDirectService("server");
            }
            else {
                directService = SysFileLocationUtil.getDirectService((String)null);
            }
            sign = directService.getSignature(sysFileSign);
            rtnMap.put("token", sign.toMap());
            rtnMap.put("status", "1");
        }
        catch (final Exception e) {
            rtnMap.put("status", "-1");
            rtnMap.put("msg", "文件生成密钥过程出错：" + e);
            SysAttMainAction.logger.error("文件生成密钥过程出错", e);
        }
        return rtnMap;
    }
    
    private void checkMd5(final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-checkMd5", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        final JSONObject jsonObj = new JSONObject();
        final String md5 = request.getParameter("md5");
        final String filesize = request.getParameter("filesize");
        final SysAttFile file = this.getServiceImp(request).getFileByMd5(md5, (long)Long.valueOf(filesize));
        if (file == null) {
            jsonObj.put((Object)"md5Exists", (Object)false);
        }
        else {
            jsonObj.put((Object)"md5Exists", (Object)true);
            jsonObj.put((Object)"fileId", (Object)file.getFdId());
            jsonObj.put((Object)"path", (Object)file.getFdFilePath());
        }
        KmssReturnPage.getInstance(request).addMessages(messages);
        TimeCounter.logCurrentTime("Action-checkMd5", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(jsonObj.toString());
        response.getWriter().flush();
        response.getWriter().close();
    }
    
    private String getFileLimitType() {
        final String fileLimit = ResourceUtil.getKmssConfigString("sys.att.fileLimitType");
        if (StringUtil.isNotNull(fileLimit)) {
            this.fileLimitType = fileLimit;
        }
        return this.fileLimitType;
    }
    
    private String getDisabledFileType() {
        final String limitType = ResourceUtil.getKmssConfigString("sys.att.fileLimitType");
        final String disabledfile = ResourceUtil.getKmssConfigString("sys.att.disabledFileType");
        if (StringUtil.isNotNull(limitType) && disabledfile != null) {
            this.disabledFileType = disabledfile.toLowerCase();
        }
        return this.disabledFileType;
    }
    
    private Map<String, Object> saveAttInfo(final HttpServletRequest request, final ActionForm form) {
        final Map<String, Object> rtnMap = new HashMap<String, Object>();
        final String fileId = request.getParameter("filekey");
        if (StringUtil.isNotNull(fileId)) {
            try {
                final SysAttMainForm attMainForm = (SysAttMainForm)form;
                final SysAttMain sysAttMain = new SysAttMain();
                final String id = sysAttMain.getFdId();
                BeanUtils.copyProperties((Object)sysAttMain, (Object)attMainForm);
                sysAttMain.setFdId(id);
                final String fileName = request.getParameter("filename");
                if (StringUtil.isNotNull(fileName)) {
                    String _fileType = null;
                    if (fileName.indexOf(".") > -1) {
                        _fileType = fileName.substring(fileName.lastIndexOf("."));
                    }
                    if (!StringUtil.isNotNull(_fileType)) {
                        rtnMap.put("status", "-1");
                        rtnMap.put("msg", "基于安全考虑，不允许上传该附件！");
                        return rtnMap;
                    }
                    _fileType = _fileType.toLowerCase();
                    final String[] files = this.getDisabledFileType().split("[;；]");
                    if ("1".equals(this.getFileLimitType())) {
                        Boolean isPass = true;
                        String[] array;
                        for (int length = (array = files).length, i = 0; i < length; ++i) {
                            final String f = array[i];
                            if (_fileType.equals(f)) {
                                isPass = false;
                                break;
                            }
                        }
                        if (!isPass) {
                            rtnMap.put("status", "-1");
                            rtnMap.put("msg", "基于安全考虑，不允许上传该附件！");
                            return rtnMap;
                        }
                    }
                    else if ("2".equals(this.getFileLimitType())) {
                        Boolean isPass = false;
                        String[] array2;
                        for (int length2 = (array2 = files).length, j = 0; j < length2; ++j) {
                            final String f = array2[j];
                            if (_fileType.equals(f)) {
                                isPass = true;
                                break;
                            }
                        }
                        if (!isPass) {
                            rtnMap.put("status", "-1");
                            rtnMap.put("msg", "基于安全考虑，不允许上传该附件！");
                            return rtnMap;
                        }
                    }
                    final String fileNameSign = request.getParameter("fdSign");
                    String namesign = new String(Base64.encodeBase64(fileName.getBytes("utf-8")), "UTF-8");
                    namesign = namesign.replaceAll("\\+", "");
                    namesign = namesign.replaceAll("\\/", "");
                    namesign = namesign.replaceAll("\\=", "");
                    if (StringUtil.isNull(fileNameSign) || !fileNameSign.equals(namesign)) {
                        rtnMap.put("status", "-1");
                        rtnMap.put("msg", "附件签名不符，基于安全考虑，不允许上传该附件！");
                        return rtnMap;
                    }
                    if ("server".equals(SysFileLocationUtil.getKey((String)null))) {
                        final InputStream in = this.getServiceImp(request).getInputStreamByFile(fileId);
                        if (in != null) {
                            _fileType = FileTypeUtil.getFileType(in);
                            IOUtils.closeQuietly(in);
                        }
                    }
                    if (StringUtil.isNotNull(_fileType) && !_fileType.startsWith(".")) {
                        _fileType = "." + _fileType;
                    }
                    if (StringUtil.isNotNull(_fileType)) {
                        final String[] files2 = this.getDisabledFileType().split("[;；]");
                        if ("1".equals(this.getFileLimitType())) {
                            Boolean isPass2 = true;
                            String[] array3;
                            for (int length3 = (array3 = files2).length, k = 0; k < length3; ++k) {
                                final String f2 = array3[k];
                                if (_fileType.equals(f2)) {
                                    isPass2 = false;
                                    break;
                                }
                            }
                            if (!isPass2) {
                                rtnMap.put("status", "-1");
                                rtnMap.put("msg", "基于安全考虑，不允许上传该附件！");
                                return rtnMap;
                            }
                        }
                        else if ("2".equals(this.getFileLimitType())) {
                            Boolean isPass2 = false;
                            final String[] office = { ".doc", ".xls", ".xlsx", ".docx", ".vsd", ".wps" };
                            String[] array4;
                            for (int length4 = (array4 = files2).length, l = 0; l < length4; ++l) {
                                final String f3 = array4[l];
                                if (".wps".equals(_fileType)) {
                                    if (ArrayUtil.asList((Object[])office).contains(f3)) {
                                        isPass2 = true;
                                        break;
                                    }
                                }
                                else if (_fileType.equals(f3)) {
                                    isPass2 = true;
                                    break;
                                }
                            }
                            if (!isPass2) {
                                rtnMap.put("status", "-1");
                                rtnMap.put("msg", "基于安全考虑，不允许上传该附件！");
                                return rtnMap;
                            }
                        }
                    }
                }
                if (SysAttMainAction.logger.isDebugEnabled()) {
                    SysAttMainAction.logger.debug("生成SysAttMain文档，文件名为:" + fileName);
                }
                sysAttMain.setFdFileName(fileName);
                sysAttMain.setDocCreateTime(new Date());
                final String contentType = FileMimeTypeUtil.getContentType(fileName);
                sysAttMain.setFdContentType(contentType);
                sysAttMain.setFdFileId(fileId);
                this.getServiceImp(request).add((IBaseModel)sysAttMain);
                rtnMap.put("status", "1");
                rtnMap.put("msg", "上传成功");
                rtnMap.put("attid", id);
                rtnMap.put("attname", fileName);
                rtnMap.put("attsize", String.valueOf(sysAttMain.getFdSize()));
                rtnMap.put("atttype", "byte");
                if (SysAttMainAction.logger.isDebugEnabled()) {
                    SysAttMainAction.logger.debug("生成SysAttMain文档结束!");
                }
            }
            catch (final Exception e) {
                rtnMap.put("status", "-1");
                rtnMap.put("msg", "生成SysAttMain文档出错：" + e);
                SysAttMainAction.logger.error("生成SysAttMain文档出错", e);
            }
        }
        else {
            rtnMap.put("status", "-1");
            rtnMap.put("msg", "文件ID信息为空！");
            SysAttMainAction.logger.error("文件ID信息为空！");
        }
        return rtnMap;
    }
    
    public ActionForward print(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdId = request.getParameter("fdId");
        String forward = "viewonline";
        final boolean isJGEnabled = JgWebOffice.isJGEnabled();
        final boolean isJGPDFEnabled = JgWebOffice.isOfficePDFJudge();
        final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
        this.commonLogFind(request, sysAttMain, "print");
        this.getSysPrintLogCoreService().addPrintLog((IBaseModel)sysAttMain, new RequestContext(request));
        final SysAttMainForm sysAttMainForm = new SysAttMainForm();
        BeanUtils.copyProperties((Object)sysAttMainForm, (Object)sysAttMain);
        request.setAttribute("sysAttMainForm", (Object)sysAttMainForm);
        request.setAttribute("isPrint", (Object)true);
        if (SysAttUtil.viewByBrowser(sysAttMain)) {
            SysAttUtil.outputFile(response, sysAttMain);
            return null;
        }
        if (SysAttConfigUtil.pdfReadByFoxitPC() && JgWebOffice.isPDF(sysAttMain.getFdFileName())) {
            this.getSysAttMainFoxitService().createRequestMateData(request, sysAttMain, Boolean.valueOf(false));
            return mapping.findForward("viewonline_foxit");
        }
        Label_0598: {
            final String readOLConfig;
            switch (readOLConfig = SysAttConfigUtil.getReadOLConfig()) {
                case "3": {
                    if (!SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMain.getFdId())) {
                        SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMain.getFdId());
                    }
                    return mapping.findForward("viewonline_wps_cloud");
                }
                case "4": {
                    request.setAttribute("attMain", (Object)sysAttMain);
                    final com.alibaba.fastjson.JSONObject params = new com.alibaba.fastjson.JSONObject();
                    params.put("fdAttMainId", (Object)sysAttMain.getFdId());
                    params.put("waterMarkText", (Object)UserUtil.getKMSSUser().getUserName());
                    final String previewUrl = SysAttThirdProxyUtil.getViewUrl("dianju", params).getData().getString("url");
                    request.setAttribute("previewUrl", (Object)previewUrl);
                    request.setAttribute("moduleSfsMode", (Object)"view");
                    return mapping.findForward("sysAttOnLineThirdSfs");
                }
                case "5": {
                    if (SysAttWpsCenterUtil.isWpsCenterSfs()) {
                        request.setAttribute("moduleSfsMode", (Object)"view");
                        return mapping.findForward("sysAttOnLineThirdSfs");
                    }
                    return mapping.findForward("viewonline_wps_center");
                }
                case "6": {
                    if (!SysAttViewerUtil.isPicAtt(sysAttMain)) {
                        request.setAttribute("attMain", (Object)sysAttMain);
                        request.setAttribute("moduleSfsMode", (Object)"view");
                        return mapping.findForward("sysAttOnLineThirdSfs");
                    }
                    break;
                }
                case "7": {
                    break;
                }
                case "8": {
                    request.setAttribute("moduleSfsMode", (Object)"view");
                    return mapping.findForward("sysAttOnLineThirdSfs");
                }
                default:
                    break Label_0598;
            }
            final boolean isMobile = this.isMobileRequest(request);
            request.setAttribute("isMobile", (Object)isMobile);
            request.setAttribute("attMain", (Object)sysAttMain);
            request.setAttribute("moduleSfsMode", (Object)"view");
            return mapping.findForward("sysAttOnLineThirdSfs");
        }
        if (SysAttWpsCenterUtil.isEnable()) {
            if (SysAttWpsCenterUtil.isWpsCenterSfs()) {
                request.setAttribute("moduleSfsMode", (Object)"view");
                return mapping.findForward("sysAttOnLineThirdSfs");
            }
            return mapping.findForward("viewonline_wps_center");
        }
        else {
            if (!SysAttWpsCloudUtil.isEnable() || (!SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(sysAttMain.getFdFileName())) && !JgWebOffice.isPDF(sysAttMain.getFdFileName()))) {
                final boolean isWpsoaassist = SysAttWpsoaassistUtil.isEnable();
                final boolean isWpsoaassistEmbed = SysAttWpsoaassistUtil.isWPSOAassistEmbed();
                if (isWpsoaassist && isWpsoaassistEmbed && (this.isWord(sysAttMain.getFdFileName()) || this.isExcel(sysAttMain.getFdFileName()) || this.isPpt(sysAttMain.getFdFileName()))) {
                    final String userAgent = request.getHeader("user-agent");
                    final boolean winFlag = userAgent.toLowerCase().contains("win");
                    if (!winFlag) {
                        return mapping.findForward("viewonline_wps_oaassist_linux");
                    }
                }
                if (isJGPDFEnabled && JgWebOffice.isPDF(sysAttMain.getFdFileName())) {
                    forward = "viewonline_pdf";
                }
                else if (isJGEnabled) {
                    forward = "viewonline_jg";
                }
                return mapping.findForward(forward);
            }
            if (!SysAttWpsCloudUtil.isAttHadSyncByAttMainId(sysAttMain.getFdId())) {
                SysAttWpsCloudUtil.syncAttToAddByMainId(sysAttMain.getFdId());
                return mapping.findForward("viewonline_wps_cloud");
            }
            return mapping.findForward("viewonline_wps_cloud");
        }
    }
    
    public ActionForward viewDownload(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        try {
            final String head = request.getHeader("User-Agent");
            if ("LKS Software".equals(head)) {
                return this.download(mapping, form, request, response);
            }
            final boolean isFlash = StringUtil.isNotNull(request.getHeader("x-flash-version"));
            final String flash = request.getHeader("Referer");
            if (isFlash && flash != null && flash.indexOf("vcastr3.swf") > -1) {
                return this.download(mapping, form, request, response);
            }
            messages.addMsg(new KmssMessage("Illegal access error!"));
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            return mapping.findForward("failure");
        }
        final boolean isJGEnabled = JgWebOffice.isJGEnabled();
        if (isJGEnabled) {
            return mapping.findForward("viewonline_jg");
        }
        return mapping.findForward("viewonline");
    }
    
    public ActionForward transferToDisk(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        try {
            if (!"GET".equals(request.getMethod())) {
                throw new UnexpectedRequestException();
            }
            final HQLInfo hqlInfo = new HQLInfo();
            final List attList = this.getServiceImp(request).findList(hqlInfo);
            if (SysAttMainAction.log.isDebugEnabled()) {
                SysAttMainAction.log.debug("附件个数为：" + attList.size());
            }
            String filePath = ResourceUtil.getKmssConfigString("kmss.resource.path");
            final Date date = new Date();
            final SimpleDateFormat format = new SimpleDateFormat("yyyyMMDD");
            final String datePath = format.format(date);
            filePath = String.valueOf(filePath) + "/" + datePath.substring(0, 6) + "/" + datePath.substring(6);
            final File file = new File(filePath);
            if (!file.exists()) {
                file.mkdirs();
            }
            final String fileName = RandomStringUtils.random(20, "abcdefghijklmnopqrstuvwxyz1234567890");
            final boolean allowLog = UserOperHelper.allowLogOper("transferToDisk", this.getServiceImp(request).getModelName());
            for (int i = 0; i < 4; ++i) {
                final SysAttMain sysAttMain = attList.get(i);
                final Blob attdate = sysAttMain.getFdData();
                if (attdate != null) {
                    final InputStream in = attdate.getBinaryStream();
                    if (SysAttMainAction.log.isDebugEnabled()) {
                        SysAttMainAction.log.debug("附件内容:====" + attdate);
                    }
                    final OutputStream stream = new FileOutputStream(String.valueOf(filePath) + "/" + sysAttMain.getFdFileName());
                    IOUtil.write(in, stream);
                    sysAttMain.setFdData((Blob)null);
                    final String fdfilePath = String.valueOf(filePath) + "/" + fileName;
                    sysAttMain.setFdFilePath(fdfilePath);
                    sysAttMain.setFdAttLocation((String)null);
                    if (allowLog) {
                        UserOperContentHelper.putUpdate(sysAttMain.getFdId(), sysAttMain.getFdFileName(), SysAttMain.class.getName()).putSimple("fdFilePath", (Object)sysAttMain.getFdFilePath(), (Object)fdfilePath).putSimple("fdAttLocation", (Object)sysAttMain.getFdAttLocation(), (Object)null);
                    }
                    this.getServiceImp(request).update((IBaseModel)sysAttMain);
                }
            }
        }
        catch (final Exception e) {
            messages.addError(new KmssMessage("common.io.exception", (Object)e.toString()), (Throwable)e);
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
        if (messages.hasError()) {
            return mapping.findForward("failure");
        }
        return mapping.findForward("success");
    }
    
    public ActionForward showThumbs(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        OutputStream out = null;
        Label_0460: {
            try {
                final String fdId = request.getParameter("fdId");
                final String size = request.getParameter("size");
                if (StringUtil.isNotNull(fdId)) {
                    final String l_fdId = fdId;
                    final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(l_fdId);
                    if (sysAttMain != null) {
                        this.commonLogFind(request, sysAttMain, "showThumbs");
                        final String loaction = sysAttMain.getFdAttLocation();
                        response.reset();
                        out = (OutputStream)response.getOutputStream();
                        if (SysAttMain.ATTACHMENT_LOCATION_FILE.equals(loaction)) {
                            final String fileName = sysAttMain.getFdFileName();
                            String filepath = null;
                            if (StringUtil.isNotNull(sysAttMain.getFdFilePath()) && StringUtil.isNotNull(size)) {
                                final File f = new File(String.valueOf(sysAttMain.getFdFilePath()) + "_" + size + "_" + fileName);
                                if (f.exists()) {
                                    filepath = String.valueOf(sysAttMain.getFdFilePath()) + "_" + size + "_" + fileName;
                                }
                            }
                            else if (StringUtil.isNotNull(sysAttMain.getFdFilePath())) {
                                final File f = new File(sysAttMain.getFdFilePath());
                                if (f.exists()) {
                                    filepath = sysAttMain.getFdFilePath();
                                }
                            }
                            if (StringUtil.isNotNull(filepath)) {
                                IOUtil.write((InputStream)new FileInputStream(filepath), out);
                            }
                        }
                        else if ("server".equals(loaction)) {
                            if (sysAttMain.getFdContentType().indexOf("image") > -1 || (sysAttMain.getFdFileName().endsWith(".png") && "application/octet-stream".equals(sysAttMain.getFdContentType()))) {
                                this.getServiceImp(request).findData(sysAttMain.getFdId(), size, out);
                            }
                            else {
                                this.getServiceImp(request).findData(sysAttMain.getFdId(), "s1.jpg", out, request);
                            }
                        }
                        return null;
                    }
                }
            }
            catch (final Exception e) {
                this.streamClose(null, out);
                messages.addError((Throwable)e);
                break Label_0460;
            }
            finally {
                this.streamClose(null, out);
            }
            this.streamClose(null, out);
        }
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        return null;
    }
    
    private String parserToken2Id(final HttpServletRequest request, final String token) throws Exception {
        if (StringUtil.isNull(token)) {
            return null;
        }
        String desc;
        try {
            desc = SysAttCryptUtil.decryptByLicenseId(token);
        }
        catch (final Exception e) {
            SysAttMainAction.logger.error("附件token解析失败：", e);
            return null;
        }
        final String auth = StringUtil.getParameter(desc, "auth");
        if (!"true".equals(auth)) {
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.debug("没有权限访问此附件");
            }
            return null;
        }
        final String timestamp = StringUtil.getParameter(desc, "time");
        final long curTimestamp = this.getServiceImp(request).getCurTimestamp().getTime();
        if (Long.valueOf(timestamp) < curTimestamp - 3600000L) {
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.debug("附件token过期了");
            }
            return null;
        }
        final String fdAttMainId = StringUtil.getParameter(desc, "fdId");
        if (StringUtil.isNull(fdAttMainId)) {
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.debug("token中没有id信息");
            }
            return null;
        }
        return fdAttMainId;
    }
    
    public ActionForward play(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final KMSSUser user = UserUtil.getKMSSUser();
        if (user.isAnonymous()) {
            return null;
        }
        final String token = request.getParameter("token");
        final String fdType = request.getParameter("fdType");
        if (StringUtil.isNull(token)) {
            return null;
        }
        final String fdAttMainId = this.parserToken2Id(request, token);
        if (StringUtil.isNull(fdAttMainId)) {
            return null;
        }
        final boolean canDownload = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=view&fdId=" + fdAttMainId, "GET");
        if (!canDownload) {
            return null;
        }
        SysAttMain sysAttMain = null;
        SysAttRtfData sysAttRtfData = null;
        boolean isRtf = false;
        if (fdType != null && "rtf".equals(fdType)) {
            isRtf = true;
        }
        if (isRtf) {
            sysAttRtfData = this.getServiceImp(request).findRtfDataByPrimaryKey(fdAttMainId);
            sysAttMain = new SysAttMain();
            sysAttMain.setFdId(fdAttMainId);
            sysAttMain.setFdSize(sysAttRtfData.getFdSize());
            sysAttMain.setFdModelId(sysAttRtfData.getFdModelId());
            sysAttMain.setFdModelName(sysAttRtfData.getFdModelName());
            sysAttMain.setFdFileName(sysAttRtfData.getFdFileName());
            sysAttMain.setFdFileId(sysAttRtfData.getFdFileId());
            sysAttMain.setFdContentType(sysAttRtfData.getFdContentType());
        }
        else {
            sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdAttMainId);
        }
        final SysAttFile attFile = this.getAttUploadService().getFileById(sysAttMain.getFdFileId());
        final ISysFileLocationDirectService directService = SysFileLocationUtil.getDirectService(attFile.getFdAttLocation());
        if (directService.isSupportDirect("")) {
            final String fdPath = SysAttViewerUtil.getMediaFilePath(sysAttMain);
            if (isRtf) {
                this.viewDirectByRtf(request, response, fdPath, sysAttMain.getFdFileName(), sysAttMain.getFdId());
            }
            else {
                this.viewDirect(request, response, fdPath, sysAttMain.getFdFileName(), sysAttMain.getFdId());
            }
            return null;
        }
        final String range = request.getHeader("Range");
        if (range == null) {
            String forwardUrl = "/sys/attachment/sys_att_main/sysAttMain.do?method=playByNoRange&token=" + token;
            if (isRtf) {
                forwardUrl = String.valueOf(forwardUrl) + "&fdType=" + fdType;
            }
            return new ActionForward(forwardUrl);
        }
        this.commonLogFind(request, sysAttMain, "play");
        String fileName = sysAttMain.getFdFileName();
        final ISysFileLocationProxyService proxyService = SysFileLocationUtil.getProxyService(attFile.getFdAttLocation());
        final String filePath = attFile.getFdFilePath();
        final String fileViewerKey = SysAttViewerUtil.getFileViewerKey(sysAttMain);
        File file = null;
        String convertFilePath = "";
        if ("videoToFlv-Aspose".equals(fileViewerKey)) {
            convertFilePath = String.valueOf(filePath) + "_convert/videoToFlv-Aspose_flv";
        }
        else {
            convertFilePath = String.valueOf(filePath) + "_convert/videoToMp4-Aspose_flv";
        }
        String relaFilePath = "";
        SysAttFile file2 = this.sysAttMainService.getFile(sysAttMain.getFdId());
        if (isRtf && file2 == null) {
            file2 = this.sysAttMainService.getFileByFileId(sysAttMain.getFdFileId());
        }
        String pathPrefix = null;
        if (file2.getFdCata() != null) {
            pathPrefix = file2.getFdCata().getFdPath();
        }
        if (proxyService.doesFileExist(convertFilePath, pathPrefix)) {
            relaFilePath = convertFilePath;
        }
        else {
            relaFilePath = filePath;
        }
        final String tempFilePath = proxyService.getTempFilePath(relaFilePath, attFile.getFdMd5());
        file = new File(tempFilePath);
        if (!file.exists()) {
            file = proxyService.readFileToTemp(relaFilePath, pathPrefix, attFile.getFdMd5());
        }
        if (file == null || !file.exists()) {
            messages.addError((Throwable)new Exception("file not exists:" + relaFilePath));
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        final long length = file.length();
        final List<Range> ranges = new ArrayList<Range>();
        if (range != null) {
            String[] split;
            for (int length2 = (split = range.substring(6).split(",")).length, i = 0; i < length2; ++i) {
                final String part = split[i];
                long start = sublong(part, 0, part.indexOf("-"));
                long end = sublong(part, part.indexOf("-") + 1, part.length());
                if (start == -1L) {
                    start = length - end;
                    end = length - 1L;
                }
                else if (end == -1L || end > length - 1L) {
                    end = length - 1L;
                }
                ranges.add(new Range(start, end, length));
            }
        }
        fileName = this.encodeFileName(request, fileName);
        response.reset();
        response.setBufferSize(10240);
        response.setHeader("Content-Disposition", "inline;filename=\"" + fileName + "\"");
        response.setHeader("Accept-Ranges", "bytes");
        RandomAccessFile access = null;
        InputStream input = null;
        OutputStream output = null;
        Label_1243: {
            try {
                access = new RandomAccessFile(file, "r");
                output = (OutputStream)response.getOutputStream();
                if (ranges.size() == 1) {
                    final Range r = ranges.get(0);
                    response.setContentType(sysAttMain.getFdContentType());
                    response.setHeader("Content-Range", "bytes " + r.start + "-" + r.end + "/" + r.total);
                    response.setStatus(206);
                    input = (InputStream)new RandomAccessFileInputStream(access, r.start, r.length);
                    IOUtil.write(input, output);
                }
            }
            catch (final Exception localException1) {
                messages.addError((Throwable)localException1);
                break Label_1243;
            }
            finally {
                IOUtils.closeQuietly(input);
                IOUtils.closeQuietly(output);
                if (access != null) {
                    access.close();
                }
            }
            IOUtils.closeQuietly(input);
            IOUtils.closeQuietly(output);
            if (access != null) {
                access.close();
            }
        }
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        return null;
    }
    
    public ActionForward playByNoRange(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        OutputStream out = null;
        InputStream in = null;
        final String fdAttMainId = this.parserToken2Id(request, request.getParameter("token"));
        final String fdType = request.getParameter("fdType");
        if (StringUtil.isNull(fdAttMainId)) {
            return null;
        }
        SysAttMain att = null;
        SysAttRtfData sysAttRtfData = null;
        boolean isRtf = false;
        if (fdType != null && "rtf".equals(fdType)) {
            isRtf = true;
        }
        FileChannel fileChannel = null;
        try {
            if (isRtf) {
                sysAttRtfData = this.getServiceImp(request).findRtfDataByPrimaryKey(fdAttMainId);
                att = new SysAttMain();
                att.setFdId(fdAttMainId);
                att.setFdSize(sysAttRtfData.getFdSize());
                att.setFdModelId(sysAttRtfData.getFdModelId());
                att.setFdModelName(sysAttRtfData.getFdModelName());
                att.setFdFileName(sysAttRtfData.getFdFileName());
                att.setFdFileId(sysAttRtfData.getFdFileId());
                att.setFdContentType(sysAttRtfData.getFdContentType());
            }
            else {
                att = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdAttMainId);
            }
            this.commonLogFind(request, att, "playByNoRange");
            String fileContentType = null;
            final String filename = this.encodeFileName(request, att.getFdFileName());
            fileContentType = FileMimeTypeUtil.getContentType(filename);
            if (StringUtil.isNull(fileContentType)) {
                fileContentType = att.getFdContentType();
            }
            if (StringUtil.isNotNull(fileContentType) && fileContentType.indexOf("video") < 0) {
                return null;
            }
            out = (OutputStream)response.getOutputStream();
            long fileSize = 0L;
            in = SysAttViewerUtil.getMediaFileInputStream(att);
            fileSize = att.getFdSize().longValue();
            long tmpSize = 0L;
            if (in instanceof DecryptionInputStream) {
                final BigFileInfo bigFileInfo = ((DecryptionInputStream)in).getFileInfo();
                fileChannel = bigFileInfo.getFileChannel();
                tmpSize = bigFileInfo.getFileSize();
            }
            else {
                fileChannel = ((FileInputStream)in).getChannel();
                tmpSize = fileChannel.size();
            }
            if (tmpSize != fileSize && tmpSize > 0L) {
                fileSize = tmpSize;
            }
            response.reset();
            if (fileSize > 0L) {
                if (fileSize <= 2147483647L) {
                    response.setContentLength((int)fileSize);
                }
                else {
                    response.setHeader("Content-Length", String.valueOf(fileSize));
                }
            }
            if (!"video/mp4".equals(fileContentType)) {
                fileContentType = "video/x-flv";
            }
            response.setContentType(fileContentType);
            response.setHeader("Content-Disposition", "attachment;filename=\"" + filename + "\"");
            IOUtil.write(in, out);
            return null;
        }
        catch (final Exception e) {
            this.streamClose(in, out);
            IOUtils.closeQuietly((Closeable)fileChannel);
            messages.addError((Throwable)e);
        }
        finally {
            this.streamClose(in, out);
            IOUtils.closeQuietly((Closeable)fileChannel);
        }
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return mapping.findForward("failure");
        }
        return mapping.findForward("view");
    }
    
    public ActionForward handleAttToken(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdId = request.getParameter("fdId");
        final String fdType = request.getParameter("fdType");
        final KmssMessages messages = new KmssMessages();
        final JSONObject jsonObject = new JSONObject();
        try {
            if (StringUtil.isNotNull(fdId)) {
                final long expire = this.getServiceImp(request).getCurTimestamp().getTime();
                String fileInfo = "";
                if (fdType != null && "rtf".equals(fdType)) {
                    fileInfo = "fdId=" + (StringUtil.isNotNull(fdId) ? fdId : "") + "&time=" + expire + "&auth=" + this.playAuthByRtf(request);
                }
                else {
                    fileInfo = "fdId=" + (StringUtil.isNotNull(fdId) ? fdId : "") + "&time=" + expire + "&auth=" + this.playAuth(request);
                }
                fileInfo = SysAttCryptUtil.encryptByLicenseId(fileInfo);
                jsonObject.put((Object)"token", (Object)fileInfo);
            }
        }
        catch (final Exception e) {
            e.printStackTrace();
            messages.addError((Throwable)e);
        }
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(jsonObject.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    private Boolean playAuth(final HttpServletRequest request) throws Exception {
        final String fdId = request.getParameter("fdId");
        if (StringUtil.isNull(fdId)) {
            return false;
        }
        String url = null;
        IBaseModel mainModel = null;
        final SysAttMain attMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId, (Object)SysAttMain.class, true);
        if (attMain != null && StringUtil.isNotNull(attMain.getFdModelId()) && StringUtil.isNotNull(attMain.getFdModelName())) {
            mainModel = this.sysAttMainService.findByPrimaryKey(attMain.getFdModelId(), (Object)attMain.getFdModelName(), true);
        }
        if (mainModel != null) {
            url = ModelUtil.getModelUrl((Object)mainModel);
        }
        return UserUtil.checkAuthentication(url, "GET");
    }
    
    private Boolean playAuthByRtf(final HttpServletRequest request) throws Exception {
        final String fdId = request.getParameter("fdId");
        if (StringUtil.isNull(fdId)) {
            return false;
        }
        final SysAttRtfData attRtfData = this.getServiceImp(request).findRtfDataByPrimaryKey(fdId);
        if (attRtfData != null) {
            return true;
        }
        return false;
    }
    
    private static long sublong(final String value, final int beginIndex, final int endIndex) {
        final String substring = value.substring(beginIndex, endIndex);
        return (substring.length() > 0) ? Long.parseLong(substring) : -1L;
    }
    
    public ActionForward toggleAttchment(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-toggleAttchment", true, (Class)this.getClass());
        final String operate = request.getParameter("operate");
        final String source = request.getParameter("source");
        final String target = request.getParameter("target");
        final String startDate = request.getParameter("beginDate");
        final String endDate = request.getParameter("endDate");
        final String toggleStartTime = request.getParameter("toggleBeginTime");
        final String toggleEndTime = request.getParameter("toggleEndTime");
        JSONObject json = new JSONObject();
        try {
            json = this.getSysAttToggleService().saveToggleAttchment(operate, source, target, startDate, endDate, (int)Integer.valueOf(toggleStartTime), (int)Integer.valueOf(toggleEndTime));
            json.put((Object)"status", (Object)"1");
        }
        catch (final Exception e) {
            e.printStackTrace();
            json.put((Object)"status", (Object)"0");
            json.put((Object)"errorMsg", (Object)e.getMessage());
        }
        TimeCounter.logCurrentTime("Action-toggleAttchment", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward findFilePath(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-findFilePath", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        final String fdDocIds = request.getParameter("fdDocIds");
        JSONArray jsonArr = new JSONArray();
        try {
            if (StringUtil.isNotNull(fdDocIds)) {
                jsonArr = this.getServiceImp(request).findFilePath(fdDocIds);
            }
        }
        catch (final Exception e) {
            e.printStackTrace();
            messages.addError((Throwable)e);
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-findFilePath", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(jsonArr.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward restorefile(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-findFilePath", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        final String[] fdDocIds = request.getParameterValues("List_Selected");
        JSONObject jsonObj = new JSONObject();
        try {
            if (fdDocIds.length > 0) {
                jsonObj = this.getServiceImp(request).restorefile(fdDocIds);
            }
        }
        catch (final Exception e) {
            e.printStackTrace();
            messages.addError((Throwable)e);
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-findFilePath", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(jsonObj.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward findMainDocInfo(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-findMainDocInfo", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        JSONObject jsonObj = new JSONObject();
        try {
            final String fdId = request.getParameter("fdId");
            if (StringUtil.isNotNull(fdId)) {
                jsonObj = this.getServiceImp(request).findMainDocInfo(fdId);
            }
            if (jsonObj != null) {
                request.setAttribute("lui-source", (Object)jsonObj);
            }
        }
        catch (final Exception e) {
            e.printStackTrace();
            messages.addError((Throwable)e);
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
        TimeCounter.logCurrentTime("Action-findMainDocInfo", false, (Class)this.getClass());
        if (messages.hasError()) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        return this.getActionForward("lui-source", mapping, form, request, response);
    }
    
    public ActionForward addFile(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        try {
            final String fdMd5 = request.getParameter("md5");
            final String fdPath = request.getParameter("path");
            final String fdId = request.getParameter("fileId");
            final String fdFileSize = request.getParameter("fileSize");
            this.getServiceImp(request).addFile(fdMd5, fdFileSize, fdId, fdPath);
            final net.sf.json.JSONObject json = new net.sf.json.JSONObject();
            request.setAttribute("lui-source", (Object)json);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        TimeCounter.logCurrentTime("Action-saveFile", false, (Class)this.getClass());
        if (messages.hasError()) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        return this.getActionForward("lui-source", mapping, form, request, response);
    }
    
    public ActionForward updateFileName(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        new KmssMessages();
        try {
            if (!"POST".equals(request.getMethod())) {
                throw new UnexpectedRequestException();
            }
            final String fdId = request.getParameter("id");
            final String fdName = request.getParameter("name");
            SysAttMain sysAttMain = null;
            final JSONObject result = new JSONObject();
            Boolean auth = true;
            String fileType = null;
            if (fdName.indexOf(".") > -1) {
                fileType = fdName.substring(fdName.lastIndexOf("."));
            }
            if (fdId != null && fdId.trim().length() > 0) {
                sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
                final String oriFileName = sysAttMain.getFdFileName();
                String oriFileType = null;
                if (oriFileName.indexOf(".") > -1) {
                    oriFileType = oriFileName.substring(oriFileName.lastIndexOf("."));
                }
                if (oriFileType.equals(fileType)) {
                    if (sysAttMain != null) {
                        auth = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=edit&fdId=" + fdId, "get");
                        if (auth) {
                            sysAttMain.setFdFileName(fdName);
                            if (UserOperHelper.allowLogOper("updateFileName", this.getServiceImp(request).getModelName())) {
                                UserOperContentHelper.putUpdate(sysAttMain.getFdId(), sysAttMain.getFdFileName(), SysAttMain.class.getName()).putSimple("fdFileName", (Object)sysAttMain.getFdFileName(), (Object)fdName);
                            }
                            this.getServiceImp(request).update((IBaseModel)sysAttMain);
                        }
                    }
                }
                else {
                    auth = false;
                }
            }
            if (auth) {
                result.put((Object)"isUpdate", (Object)true);
            }
            else {
                result.put((Object)"isUpdate", (Object)false);
                result.put((Object)"errorInfo", (Object)"Permission denied!");
            }
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().write(result.toString());
        }
        catch (final Exception ex) {}
        return null;
    }
    
    public ActionForward checkEditName(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        try {
            if (!"POST".equals(request.getMethod())) {
                throw new UnexpectedRequestException();
            }
            final String fdId = request.getParameter("id");
            SysAttMain sysAttMain = null;
            final JSONObject result = new JSONObject();
            Boolean auth = true;
            if (fdId != null && fdId.trim().length() > 0) {
                sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
                if (sysAttMain != null) {
                    auth = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=edit&fdId=" + fdId, "get");
                }
            }
            result.put((Object)"auth", (Object)auth);
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().write(result.toString());
        }
        catch (final Exception ex) {}
        return null;
    }
    
    public ActionForward editName(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-add", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        final String fdFileName = request.getParameter("fdFileName");
        if (StringUtil.isNotNull(fdFileName)) {
            request.setAttribute("fdFileName", (Object)URLEncoder.encode(fdFileName, "UTF-8"));
        }
        TimeCounter.logCurrentTime("Action-add", false, (Class)this.getClass());
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return this.getActionForward("failure", mapping, form, request, response);
        }
        return this.getActionForward("editName", mapping, form, request, response);
    }
    
    public ISysAttUploadService getAttUploadService() {
        if (this.sysAttUploadService == null) {
            this.sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        }
        return this.sysAttUploadService;
    }
    
    public ActionForward zipView(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception, Throwable {
        final String fdId = request.getParameter("fdId");
        final JSONArray ja = new JSONArray();
        final SysAttMain att = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId, (Object)SysAttMain.class, true);
        if (att != null) {
            final SysAttFile attFile = this.getAttUploadService().getFileById(att.getFdFileId());
            String filePath = String.valueOf(ResourceUtil.getKmssConfigString("kmss.resource.path")) + attFile.getFdFilePath();
            if (filePath.contains("\\")) {
                filePath = filePath.replaceAll("\\\\", "/");
            }
            final File file = new File(filePath);
            final File zipfile = new File(String.valueOf(filePath) + "_uncompress");
            if (file.exists() && zipfile.exists() && zipfile.isDirectory()) {
                final Map<String, String> map = new HashMap<String, String>();
                this.getFile(zipfile, map);
                if (map.size() > 0) {
                    this.getQueueService().updateAtt((Map)map, att);
                }
                final Map<String, Boolean> hasview = this.getViewer(request, zipfile);
                this.getFile(zipfile, ja, request, hasview);
            }
        }
        response.setContentType("application/json;charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        response.getWriter().print(ja);
        return null;
    }
    
    public ActionForward zipPcViewList(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception, Throwable {
        final String fdId = request.getParameter("fdId");
        final String fdMainAttId = request.getParameter("fdMainAttId");
        String dirPath = request.getParameter("dirPath");
        final JSONArray ja = new JSONArray();
        if (StringUtil.isNull(dirPath)) {
            final SysAttMain att = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId, (Object)SysAttMain.class, true);
            if (att != null) {
                final SysAttFile attFile = this.getAttUploadService().getFileById(att.getFdFileId());
                String filePath = String.valueOf(ResourceUtil.getKmssConfigString("kmss.resource.path")) + attFile.getFdFilePath();
                if (filePath.contains("\\")) {
                    filePath = filePath.replaceAll("\\\\", "/");
                }
                final File file = new File(filePath);
                final File zipfile = new File(String.valueOf(filePath) + "_uncompress");
                if (file.exists() && zipfile.exists() && zipfile.isDirectory()) {
                    final Map<String, String> map = new HashMap<String, String>();
                    this.getFile(zipfile, map);
                    if (map.size() > 0) {
                        this.getQueueService().updateAtt((Map)map, att);
                    }
                    final Map<String, Boolean> hasview = this.getViewer(request, zipfile);
                    this.getFile(zipfile, ja, request, hasview);
                }
            }
        }
        else {
            dirPath = dirPath.replaceAll("%", "+");
            String decodedPath = new String(Base64.decodeBase64(dirPath), "utf-8");
            final SysAttMain att2 = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdMainAttId, (Object)SysAttMain.class, true);
            if (decodedPath.contains("\\")) {
                decodedPath = decodedPath.replaceAll("\\\\", "/");
            }
            final File file2 = new File(decodedPath);
            if (file2.exists() && file2.isDirectory()) {
                final Map<String, String> map2 = new HashMap<String, String>();
                this.getFile(file2, map2);
                if (map2.size() > 0) {
                    this.getQueueService().updateAtt((Map)map2, att2);
                }
                final Map<String, Boolean> hasview2 = this.getViewer(request, file2);
                this.getFile(file2, ja, request, hasview2);
            }
        }
        int pageNo = 0;
        if (StringUtil.isNotNull(request.getParameter("pageno"))) {
            pageNo = Integer.parseInt(request.getParameter("pageno"));
        }
        if (pageNo == 0) {
            this.getPaginatedData(request, ja, 1);
        }
        else {
            this.getPaginatedData(request, ja, pageNo);
        }
        return this.getActionForward("aspose_zipViewList", mapping, form, request, response);
    }
    
    private void getPaginatedData(final HttpServletRequest request, final JSONArray arr, final int pageNo) {
        final int totalItems = arr.size();
        final JSONArray paginatedData = new JSONArray();
        final int startIndex = (pageNo - 1) * 10;
        for (int endIndex = Math.min(startIndex + 10, totalItems), i = startIndex; i < endIndex; ++i) {
            paginatedData.add((Object)arr.getJSONObject(i));
        }
        final Page page = new Page();
        page.setList(Arrays.asList(paginatedData.toArray()));
        page.setPageno(pageNo);
        page.setRowsize(10);
        page.setTotalrows(arr.size());
        request.setAttribute("queryPage", (Object)page);
    }
    
    public ActionForward zipPcView(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception, Throwable {
        final String fdId = request.getParameter("fdId");
        final net.sf.json.JSONObject jsonObject = new net.sf.json.JSONObject();
        final SysAttMain att = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId, (Object)SysAttMain.class, true);
        jsonObject.put((Object)"fileFullName", (Object)att.getFdFileName());
        jsonObject.put((Object)"fileName", (Object)att.getFdFileName().substring(0, att.getFdFileName().lastIndexOf(".")));
        jsonObject.put((Object)"fileSize", (Object)this.formatSize(att.getFdSize().toString()));
        jsonObject.put((Object)"fdId", (Object)fdId);
        final String attIconName = SysAttViewerUtil.getIconNameByAttName(att.getFdFileName());
        jsonObject.put((Object)"attIconName", (Object)attIconName);
        request.setAttribute("fileInfo", (Object)jsonObject);
        return this.getActionForward("aspose_zipViewer", mapping, form, request, response);
    }
    
    private String formatSize(final String filesize) throws Exception {
        String result = "";
        if (filesize != null) {
            final BigDecimal Num = new BigDecimal(filesize);
            double size = Num.doubleValue();
            if (size < 1024.0) {
                result = String.valueOf(size) + "B";
            }
            else {
                size = (double)(Math.round(size * 100.0 / 1024.0) / 100L);
                if (size < 1024.0) {
                    result = String.valueOf(size) + "KB";
                }
                else {
                    size = (double)(Math.round(size * 100.0 / 1024.0) / 100L);
                    if (size < 1024.0) {
                        result = String.valueOf(size) + "M";
                    }
                    else {
                        size = (double)(Math.round(size * 100.0 / 1024.0) / 100L);
                        result = String.valueOf(size) + "G";
                    }
                }
            }
        }
        return result;
    }
    
    public ISysFileConvertQueueService getQueueService() {
        if (this.queueService == null) {
            this.queueService = (ISysFileConvertQueueService)SpringBeanUtil.getBean("sysFileConvertQueueService");
        }
        return this.queueService;
    }
    
    private void getFile(final File file, final Map<String, String> map) throws Exception {
        final File[] files = file.listFiles();
        if (files != null && files.length > 0) {
            File[] array;
            for (int length = (array = files).length, i = 0; i < length; ++i) {
                final File fl = array[i];
                if (fl.isFile() && fl.getName().length() != 32) {
                    map.put(fl.getName(), fl.getCanonicalPath());
                }
                else if (fl.isDirectory() && !fl.getName().endsWith("_convert")) {
                    this.getFile(fl, map);
                }
            }
        }
    }
    
    private void getAttFile(final File file, final Map<String, String> map) throws Exception {
        final File[] files = file.listFiles();
        if (files != null && files.length > 0) {
            File[] array;
            for (int length = (array = files).length, i = 0; i < length; ++i) {
                final File fl = array[i];
                if (fl.isFile() && fl.getName().length() == 32) {
                    map.put(fl.getName(), fl.getCanonicalPath());
                }
                else if (fl.isDirectory() && !fl.getName().endsWith("_convert")) {
                    this.getAttFile(fl, map);
                }
            }
        }
    }
    
    private JSONArray getFile(final File file, final JSONArray ja, final HttpServletRequest request, final Map<String, Boolean> hasview) throws Exception {
        final File[] files = file.listFiles();
        if (files != null && files.length > 0) {
            net.sf.json.JSONObject json = null;
            File[] array;
            for (int length = (array = files).length, i = 0; i < length; ++i) {
                final File fl = array[i];
                if (fl.isFile()) {
                    json = new net.sf.json.JSONObject();
                    json.put((Object)"view", (Object)"1");
                    json.put((Object)"id", (Object)fl.getName());
                    final HQLInfo hql = new HQLInfo();
                    hql.setWhereBlock("fdFileId=:filename");
                    hql.setParameter("filename", (Object)fl.getName());
                    final Object obj = this.getServiceImp(request).findFirstOne(hql);
                    if (obj != null) {
                        final SysAttMain att = (SysAttMain)obj;
                        json.put((Object)"name", (Object)att.getFdFileName());
                        json.put((Object)"attId", (Object)att.getFdId());
                        json.put((Object)"size", (Object)att.getFdSize());
                        json.put((Object)"filesize", (Object)this.formatSize(att.getFdSize().toString()));
                        json.put((Object)"icon", (Object)SysAttViewerUtil.getIconClassByFileName(att.getFdFileName()));
                        if (hasview.containsKey(att.getFdId())) {
                            json.put((Object)"hasViewer", (Object)hasview.get(att.getFdId()));
                        }
                        else {
                            json.put((Object)"hasViewer", (Object)false);
                        }
                    }
                    else {
                        json.put((Object)"hasViewer", (Object)false);
                        json.put((Object)"view", (Object)"0");
                        json.put((Object)"name", (Object)fl.getName());
                    }
                    json.put((Object)"type", (Object)"file");
                    json.put((Object)"hasChild", (Object)Boolean.FALSE);
                    json.put((Object)"path", (Object)fl.getCanonicalPath());
                    ja.add((Object)json);
                }
                else if (fl.isDirectory() && !fl.getName().endsWith("_convert")) {
                    json = new net.sf.json.JSONObject();
                    json.put((Object)"view", (Object)"0");
                    json.put((Object)"type", (Object)"dir");
                    json.put((Object)"name", (Object)fl.getName());
                    json.put((Object)"path", (Object)fl.getCanonicalPath());
                    String securityPath = new String(Base64.encodeBase64(fl.getCanonicalPath().getBytes(StandardCharsets.UTF_8)));
                    securityPath = securityPath.replaceAll("\\+", "%");
                    json.put((Object)"securityPath", (Object)securityPath);
                    json.put((Object)"child", (Object)this.getFile(fl, new JSONArray(), request, hasview));
                    json.put((Object)"hasChild", (Object)Boolean.TRUE);
                    json.put((Object)"dircount", (Object)this.getFile(fl, new JSONArray(), request, hasview).size());
                    ja.add((Object)json);
                }
            }
        }
        return ja;
    }
    
    private Map<String, Boolean> getViewer(final HttpServletRequest request, final File file) throws Exception {
        final Map<String, Boolean> attmap = new HashMap<String, Boolean>();
        final Map<String, String> map = new HashMap<String, String>();
        this.getAttFile(file, map);
        final List<SysAttMain> mains = new ArrayList<SysAttMain>();
        for (final String key : map.keySet()) {
            final HQLInfo hql = new HQLInfo();
            hql.setWhereBlock("fdFileId=:fdFileId");
            hql.setParameter("fdFileId", (Object)key);
            final Object obj = this.getServiceImp(request).findFirstOne(hql);
            if (obj != null) {
                mains.add((SysAttMain)obj);
            }
        }
        final Map<String, Boolean> cr = SysAttViewerUtil.getConvertedResult((List)mains);
        for (final SysAttMain main : mains) {
            final String crKey = StringUtil.isNotNull(main.getFdFileId()) ? main.getFdFileId() : main.getFdId();
            final Boolean attCr = cr.get(crKey);
            if ((attCr != null && attCr.equals(Boolean.TRUE) && main.getFdContentType().indexOf("video") < 0) || main.getFdContentType().indexOf("mp4") >= 0 || main.getFdContentType().indexOf("m4v") >= 0 || main.getFdContentType().indexOf("audio") >= 0) {
                attmap.put(main.getFdId(), true);
            }
            else {
                attmap.put(main.getFdId(), false);
            }
        }
        return attmap;
    }
    
    private void commonLogFind(final HttpServletRequest request, final SysAttMain sysAttMain, final String logPoint) {
        final boolean allowLog = UserOperHelper.allowLogOper(logPoint, this.getServiceImp(request).getModelName());
        if (allowLog) {
            UserOperContentHelper.putFind(sysAttMain.getFdId(), sysAttMain.getFdFileName(), SysAttMain.class.getName());
        }
    }
    
    protected void changeFindPageHQLInfo(final HttpServletRequest request, final HQLInfo hqlInfo) throws Exception {
        hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " and ", "sysAttMain.fdModelId is not null "));
        final String driverClass = ResourceUtil.getKmssConfigString("hibernate.connection.driverClass");
        if (!"oracle.jdbc.driver.OracleDriver".equals(driverClass)) {
            hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " and ", "sysAttMain.fdModelId <> ''"));
        }
        final CriteriaValue cv = new CriteriaValue(request);
        CriteriaUtil.buildHql(cv, hqlInfo, (Class)SysAttMain.class);
        final String myAtt = request.getParameter("q.myAtt");
        if (StringUtil.isNotNull(myAtt)) {
            hqlInfo.setDistinctType(1);
            if ("upload".equals(myAtt)) {
                hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " and ", "sysAttMain.fdCreatorId = :fdCreatorId"));
                hqlInfo.setParameter("fdCreatorId", (Object)UserUtil.getUser().getFdId());
            }
            if ("download".equals(myAtt)) {
                hqlInfo.setJoinBlock(",com.landray.kmss.sys.attachment.model.SysAttDownloadLog sysAttDownloadLog");
                hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " and ", "sysAttMain.fdId = sysAttDownloadLog.fdAttId and sysAttDownloadLog.docCreatorId = :fdCreatorId"));
                hqlInfo.setParameter("fdCreatorId", (Object)UserUtil.getUser().getFdId());
            }
            if ("borrow".equals(myAtt)) {
                hqlInfo.setJoinBlock(",com.landray.kmss.sys.attachment.borrow.model.SysAttBorrow sysAttBorrow");
                hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " and ", "sysAttMain.fdId = sysAttBorrow.fdAttId and sysAttBorrow.fdBorrowers.fdId = :fdCreatorId"));
                hqlInfo.setParameter("fdCreatorId", (Object)UserUtil.getUser().getFdId());
            }
        }
        final String[] fileType = cv.polls("fileType");
        if (ArrayUtils.isEmpty(fileType)) {
            return;
        }
        final List<String> valueList = Arrays.asList((Object[])fileType);
        this.buildFileTypeHql(valueList, hqlInfo);
    }
    
    private void buildFileTypeHql(final List<String> valueList, final HQLInfo hqlInfo) {
        final List<String> others = new ArrayList<String>();
        final List<String> fileTypeList = new ArrayList<String>();
        final List<String> doc = ArrayUtil.convertArrayToList((Object[])new String[] { "application/msword", "application/vnd.openxmlformats-officedocument.wordprocessingml.document" });
        final List<String> ppt = ArrayUtil.convertArrayToList((Object[])new String[] { "application/vnd.ms-powerpoint", "application/vnd.openxmlformats-officedocument.presentationml.presentation" });
        final List<String> pdf = ArrayUtil.convertArrayToList((Object[])new String[] { "application/pdf" });
        final List<String> excel = ArrayUtil.convertArrayToList((Object[])new String[] { "application/vnd.ms-excel", "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet" });
        final List<String> pic = ArrayUtil.convertArrayToList((Object[])new String[] { "image/bmp", "image/jpeg", "image/gif", "image/cis-cod", "image/ief", "image/png", "image/pipeg", "image/x-icon", "image/x-xwindowdump", "image/x-portable-anymap", "image/tiff" });
        final List<String> video = ArrayUtil.convertArrayToList((Object[])new String[] { "audio/x-pn-realaudio", "audio/wrf", "audio/f4v", "video/mp4", "video/3gpp", "video/wmv9", "video/x-ms-wmv", "video/x-flv", "video/x-matroska", "video/mp2t", "video/vob", "video/webm", "video/x-ms-asf", "video/x-msvideo", "video/x-sgi-movie", "video/quicktime", "video/mpeg", "video/x-la-asf" });
        final List<String> audio = ArrayUtil.convertArrayToList((Object[])new String[] { "audio/mpeg", "audio/x-wav", "audio/ogg" });
        if (valueList.contains("doc")) {
            fileTypeList.addAll(doc);
        }
        if (valueList.contains("ppt")) {
            fileTypeList.addAll(ppt);
        }
        if (valueList.contains("pdf")) {
            fileTypeList.addAll(pdf);
        }
        if (valueList.contains("excel")) {
            fileTypeList.addAll(excel);
        }
        if (valueList.contains("pic")) {
            fileTypeList.addAll(pic);
        }
        if (valueList.contains("audio")) {
            fileTypeList.addAll(audio);
        }
        if (valueList.contains("video")) {
            fileTypeList.addAll(video);
        }
        if (valueList.contains("others")) {
            others.addAll(doc);
            others.addAll(ppt);
            others.addAll(pdf);
            others.addAll(excel);
            others.addAll(pic);
            others.addAll(audio);
            others.addAll(video);
            others.removeAll(fileTypeList);
            hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " and ", "sysAttMain.fdContentType not in (:others)"));
            hqlInfo.setParameter("others", (Object)others);
        }
        else {
            hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " and ", "sysAttMain.fdContentType in (:others)"));
            hqlInfo.setParameter("others", (Object)fileTypeList);
        }
    }
    
    public ActionForward statistics(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-statistics", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        try {
            this.loadActionForm(mapping, form, request, response);
            final SysAttMainForm attForm = (SysAttMainForm)form;
            this.getServiceImp(request).statistics(request, attForm);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        TimeCounter.logCurrentTime("Action-statistics", false, (Class)this.getClass());
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            return this.getActionForward("failure", mapping, form, request, response);
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
        return this.getActionForward("statistics", mapping, form, request, response);
    }
    
    public ActionForward getSessionId(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-count", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        try {
            final JSONObject json = new JSONObject();
            json.put((Object)"JSESSIONID", (Object)request.getSession().getId());
            final String cookieHeader = request.getHeader("Cookie");
            if (StringUtil.isNotNull(cookieHeader)) {
                final String[] cookies = cookieHeader.split(";");
                if (cookies != null) {
                    for (int i = 0; i < cookies.length; ++i) {
                        final String cookie = cookies[i].trim();
                        json.put((Object)cookie.substring(0, cookie.indexOf("=")), (Object)cookie.substring(cookie.indexOf("=") + 1, cookie.length()));
                    }
                }
            }
            request.setAttribute("lui-source", (Object)json);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        TimeCounter.logCurrentTime("Action-count", false, (Class)this.getClass());
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            return this.getActionForward("failure", mapping, form, request, response);
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
        return this.getActionForward("lui-source", mapping, form, request, response);
    }
    
    public ActionForward count(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-count", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        try {
            final JSONObject json = new JSONObject();
            final HQLInfo hqlInfo = new HQLInfo();
            hqlInfo.setGettingCount(true);
            final String type = request.getParameter("type");
            hqlInfo.setWhereBlock("sysAttMain.fdModelId is not null and sysAttMain.fdModelId <> ''");
            if ("create".equals(type)) {
                hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " and ", "sysAttMain.fdCreatorId =:fdCreatorId"));
                hqlInfo.setParameter("fdCreatorId", (Object)UserUtil.getUser().getFdId());
            }
            hqlInfo.setSelectBlock("count(distinct sysAttMain.fdId)");
            final List<Long> count = this.getServiceImp(request).findValue(hqlInfo);
            json.put((Object)"count", (Object)count.get(0));
            request.setAttribute("lui-source", (Object)json);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        TimeCounter.logCurrentTime("Action-count", false, (Class)this.getClass());
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            return this.getActionForward("failure", mapping, form, request, response);
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
        return this.getActionForward("lui-source", mapping, form, request, response);
    }
    
    public ActionForward modules(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-modules", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        try {
            final JSONArray array = new JSONArray();
            final HQLInfo hqlInfo = new HQLInfo();
            hqlInfo.setSelectBlock(" sysAttMain.fdModelName");
            this.changeFindPageHQLInfo(request, hqlInfo);
            hqlInfo.setWhereBlock(StringUtil.linkString(hqlInfo.getWhereBlock(), " ", "group by sysAttMain.fdModelName"));
            final List<String> modules = this.getServiceImp(request).findValue(hqlInfo);
            for (int i = 0; i < modules.size(); ++i) {
                final net.sf.json.JSONObject json = new net.sf.json.JSONObject();
                final String modelName = modules.get(i);
                final String text = this.getServiceImp(request).getMainModuleName(modelName);
                if (!StringUtil.isNull(text)) {
                    json.element("text", (Object)text);
                    json.element("value", (Object)modelName);
                    array.add((Object)json);
                }
            }
            request.setAttribute("lui-source", (Object)array);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        TimeCounter.logCurrentTime("Action-modules", false, (Class)this.getClass());
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).save(request);
            return this.getActionForward("failure", mapping, form, request, response);
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
        return this.getActionForward("lui-source", mapping, form, request, response);
    }
    
    public ActionForward addOnlineFile(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-generateFile", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        String mobileEditAttId = "";
        final JSONObject json = new JSONObject();
        try {
            SysAttMain originalAtt = null;
            originalAtt = this.getServiceImp(request).addOnlineFile(request);
            if (originalAtt != null) {
                mobileEditAttId = originalAtt.getFdId();
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        json.put((Object)"editOnlineAttId", (Object)mobileEditAttId);
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward addCloudOnlineFile(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-addCloudOnlineFile", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        String mobileEditAttId = "";
        final JSONObject json = new JSONObject();
        response.setCharacterEncoding("UTF-8");
        response.setContentType("application/json; charset=utf-8");
        try {
            SysAttMain originalAtt = null;
            originalAtt = this.getServiceImp(request).addCloudOnlineFile(request);
            if (originalAtt != null) {
                mobileEditAttId = originalAtt.getFdId();
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
            json.put((Object)"error", (Object)e);
            response.getWriter().append(json.toString());
            response.getWriter().flush();
            response.getWriter().close();
            return null;
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-addCloudOnlineFile", false, (Class)this.getClass());
        json.put((Object)"editOnlineAttId", (Object)mobileEditAttId);
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward addWpsOaassistOnlineFile(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-addWpsOaassistOnlineFile", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        String mobileEditAttId = "";
        final JSONObject json = new JSONObject();
        try {
            SysAttMain originalAtt = null;
            originalAtt = this.getServiceImp(request).addWpsOaassistOnlineFile(request);
            if (originalAtt != null) {
                mobileEditAttId = originalAtt.getFdId();
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
            json.put((Object)"error", (Object)e);
            response.setCharacterEncoding("UTF-8");
            response.getWriter().append(json.toString());
            response.getWriter().flush();
            response.getWriter().close();
            return null;
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-addWpsOaassistOnlineFile", false, (Class)this.getClass());
        json.put((Object)"editOnlineAttId", (Object)mobileEditAttId);
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward updateRelation(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-generateFile", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        boolean result = false;
        final JSONObject json = new JSONObject();
        try {
            result = this.getServiceImp(request).updateRelation(request);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        json.put((Object)"status", (Object)result);
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward updateCloudRelation(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-generateFile", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        boolean result = false;
        final JSONObject json = new JSONObject();
        try {
            result = this.getServiceImp(request).updateCloudRelation(request);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        json.put((Object)"status", (Object)result);
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward getWpsUrlAndToken(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-generateFile", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        JSONObject json = new JSONObject();
        try {
            json = this.getServiceImp(request).getWpsUrlAndToken(request);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward getWpsCloudViewUrl(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final JSONObject json = new JSONObject();
        try {
            boolean canEdit = false;
            final String fdMode = request.getParameter("fdMode");
            String history = request.getParameter("history");
            if (StringUtils.isNotBlank(fdMode) && "write".equals(fdMode)) {
                canEdit = true;
            }
            if (StringUtils.isNotBlank(history)) {
                history = "1";
            }
            else {
                history = "0";
            }
            history = "0";
            final String fdAttMainId = request.getParameter("fdAttMainId");
            if (StringUtil.isNotNull(fdAttMainId)) {
                final String contentFlag = request.getParameter("contentFlag");
                if (StringUtil.isNotNull(contentFlag)) {
                    final net.sf.json.JSONObject result = SysAttWpsCloudUtil.getWpsCloudViewUrl(fdAttMainId, canEdit, history, Boolean.parseBoolean(contentFlag));
                    json.putAll((Map)result);
                }
                else {
                    final net.sf.json.JSONObject result = SysAttWpsCloudUtil.getWpsCloudViewUrl(fdAttMainId, canEdit, history);
                    json.putAll((Map)result);
                }
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        if (messages.hasError()) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward getWpsOAasisstUrl(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final JSONObject json = new JSONObject();
        try {
            final String fileId = request.getParameter("fileId");
            final String modelName = request.getParameter("wpsExtAppModel");
            final String url = this.getServiceImp(request).getRestDownloadUrl(fileId, modelName);
            final String contentFlag = request.getParameter("contentFlag");
            json.put((Object)"downUrl", (Object)(String.valueOf(url) + "&from=wpsOAasisst"));
            json.put((Object)"userId", (Object)UserUtil.getKMSSUser().getUserId());
            json.put((Object)"userName", (Object)UserUtil.getKMSSUser().getUserName());
            final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fileId);
            json.put((Object)"attMainId", (Object)sysAttMain.getFdId());
            json.put((Object)"attFileName", (Object)sysAttMain.getFdFileName());
            json.put((Object)"modelId", (Object)sysAttMain.getFdModelId());
            json.put((Object)"modelName", (Object)sysAttMain.getFdModelName());
            json.put((Object)"fdKey", (Object)sysAttMain.getFdKey());
            final boolean canCopy = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + fileId, "GET");
            json.put((Object)"canCopy", (Object)canCopy);
            boolean canPrint = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + fileId, "GET");
            final boolean download = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=download&fdId=" + fileId, "GET");
            if (StringUtil.isNotNull(contentFlag) && "true".equals(contentFlag)) {
                final boolean canPrintContent = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=printContent&fdModelName=" + sysAttMain.getFdModelName() + "&fdId=" + sysAttMain.getFdId(), "GET");
                canPrint = (canPrint && canPrintContent);
            }
            json.put((Object)"canPrint", (Object)canPrint);
            json.put((Object)"download", (Object)download);
            final net.sf.json.JSONObject watermarkCfg = SysAttViewerUtil.getWaterMarkConfigInDB(Boolean.valueOf(true));
            if (watermarkCfg.get("markWordVar") != null && "true".equals(watermarkCfg.get("showWaterMark"))) {
                String waterText = UserUtil.getKMSSUser().getUserName();
                if (watermarkCfg.get("markWordVar") != null && "true".equals(watermarkCfg.get("showWaterMark")) && "word".equals(watermarkCfg.get("markType"))) {
                    waterText = SysAttViewerUtil.getVarMarkWord(watermarkCfg.getString("markWordVar"), request);
                }
                json.put((Object)"waterText", (Object)waterText);
            }
            json.put((Object)"watermarkCfg", (Object)watermarkCfg);
            String wpsWebDocumentHeart = SysAttConfigUtil.getConfigInfo("wpsWebDocumentHeart");
            if (StringUtil.isNull(wpsWebDocumentHeart)) {
                wpsWebDocumentHeart = "480";
            }
            json.put((Object)"wpsWebDocumentHeart", (Object)Long.valueOf(wpsWebDocumentHeart));
            final String token = this.getSysAttachmentWpsAddinProvider().getToken();
            json.put((Object)"wpsoaassistToken", (Object)token);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        if (messages.hasError()) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward extendWpsOaassitEditMark(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        SysAttMainAction.logger.info("extendWpsOaassitEditMark");
        final String fdId = request.getParameter("fdId");
        final String useId = request.getParameter("useId");
        if (StringUtil.isNotNull(fdId) && StringUtil.isNotNull(useId)) {
            final boolean redis = RedisConfig.ENABLED;
            String wpsDocumentLife = SysAttConfigUtil.getConfigInfo("wpsDocumentLife");
            if (StringUtil.isNull(wpsDocumentLife)) {
                wpsDocumentLife = "600";
            }
            final int documentLife = Integer.valueOf(wpsDocumentLife);
            if (redis) {
                final long expires = DbUtils.getDbTimeMillis() + documentLife * 1000;
                RedisCommands.getInstance().set("wps_oasisst_redis_" + useId + "_" + fdId, SerializeUtils.str2Byte(String.valueOf(expires)), documentLife);
            }
            else {
                final HQLInfo hql = new HQLInfo();
                hql.setWhereBlock("sysAttachmentWps.sysAttMainId=:sysAttMainId and sysAttachmentWps.userId=:userId");
                hql.setParameter("sysAttMainId", (Object)fdId);
                hql.setParameter("userId", (Object)useId);
                final Object obj = this.getSysAttachmentWpsServiceImp(request).findFirstOne(hql);
                if (obj == null) {
                    final SysAttachmentWps sysAttachmentWps = new SysAttachmentWps();
                    sysAttachmentWps.setUserId(useId);
                    sysAttachmentWps.setSysAttMainId(fdId);
                    final long expires2 = DbUtils.getDbTimeMillis() + documentLife * 1000;
                    sysAttachmentWps.setExpirationTime(new Date(expires2));
                    this.getSysAttachmentWpsServiceImp(request).add((IBaseModel)sysAttachmentWps);
                }
                else {
                    final SysAttachmentWps sysAttachmentWps = (SysAttachmentWps)obj;
                    final long expires2 = DbUtils.getDbTimeMillis() + documentLife * 1000;
                    sysAttachmentWps.setExpirationTime(new Date(expires2));
                    sysAttachmentWps.setDocAlterTime(new Date());
                    this.getSysAttachmentWpsServiceImp(request).update((IBaseModel)sysAttachmentWps);
                }
            }
        }
        return null;
    }
    
    public ActionForward checkWpsOaassitEditMark(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        SysAttMainAction.logger.info("checkWpsOaassitEditMark");
        final String fdId = request.getParameter("fdId");
        final String useId = request.getParameter("useId");
        final JSONObject json = new JSONObject();
        if (StringUtil.isNotNull(fdId) && StringUtil.isNotNull(useId)) {
            final boolean redis = RedisConfig.ENABLED;
            if (redis) {
                final boolean ishas = RedisCommands.getInstance().exists("wps_oasisst_redis_" + useId + "_" + fdId);
                if (ishas) {
                    json.put((Object)"status", (Object)"open");
                }
                else {
                    json.put((Object)"status", (Object)"close");
                }
            }
            else {
                final HQLInfo hql = new HQLInfo();
                hql.setWhereBlock("sysAttachmentWps.sysAttMainId=:sysAttMainId and sysAttachmentWps.userId=:userId");
                hql.setParameter("sysAttMainId", (Object)fdId);
                hql.setParameter("userId", (Object)useId);
                final Object obj = this.getSysAttachmentWpsServiceImp(request).findFirstOne(hql);
                if (obj == null) {
                    json.put((Object)"status", (Object)"close");
                }
                else {
                    final SysAttachmentWps sysAttachmentWps = (SysAttachmentWps)obj;
                    final long expires = DbUtils.getDbTimeMillis();
                    if (expires > sysAttachmentWps.getExpirationTime().getTime()) {
                        json.put((Object)"status", (Object)"close");
                    }
                    else {
                        json.put((Object)"status", (Object)"open");
                    }
                }
            }
        }
        else {
            json.put((Object)"status", (Object)"close");
        }
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward expiredWpsOaassitEditMark(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        SysAttMainAction.logger.info("expiredWpsOaassitEditMark");
        final JSONObject json = new JSONObject();
        final String fdId = request.getParameter("fdId");
        request.getParameter("type");
        final String useId = request.getParameter("userId");
        if (StringUtil.isNotNull(fdId) && StringUtil.isNotNull(useId)) {
            final boolean redis = RedisConfig.ENABLED;
            if (redis) {
                RedisCommands.getInstance().del("wps_oasisst_redis_" + useId + "_" + fdId);
            }
            else {
                final HQLInfo hql = new HQLInfo();
                hql.setWhereBlock("sysAttachmentWps.sysAttMainId=:sysAttMainId and sysAttachmentWps.userId=:userId");
                hql.setParameter("sysAttMainId", (Object)fdId);
                hql.setParameter("userId", (Object)useId);
                final Object obj = this.getSysAttachmentWpsServiceImp(request).findFirstOne(hql);
                if (obj != null) {
                    this.getSysAttachmentWpsServiceImp(request).delete((IBaseModel)obj);
                }
            }
            json.put((Object)"status", (Object)true);
        }
        else {
            json.put((Object)"status", (Object)false);
        }
        final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
        final Map<String, String> params = new HashMap<String, String>();
        params.put("fdId", fdId);
        params.put("modelId", sysAttMain.getFdModelId());
        params.put("modelName", sysAttMain.getFdModelName());
        params.put("fdKey", sysAttMain.getFdKey());
        params.put("userId", useId);
        params.put("type", "unlock");
        SysAttachmentWpsAddonsLockUtils.handle((Map)params);
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward handleEditWpsOaassist(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final JSONObject result = new JSONObject();
        try {
            final String fdId = request.getParameter("fdId");
            final String modelId = request.getParameter("modelId");
            final String modelName = request.getParameter("modelName");
            final String fdKey = request.getParameter("fdKey");
            final String userId = request.getParameter("userId");
            final String type = request.getParameter("type");
            final Map<String, String> params = new HashMap<String, String>();
            params.put("fdId", fdId);
            params.put("modelId", modelId);
            params.put("modelName", modelName);
            params.put("fdKey", fdKey);
            params.put("userId", userId);
            params.put("type", type);
            if ("unlock".equals(type)) {
                final String lockQueenStr = request.getParameter("lockQueen");
                params.put("lockQueen", lockQueenStr);
            }
            final boolean lock = SysAttachmentWpsAddonsLockUtils.handle((Map)params);
            result.put((Object)"success", (Object)lock);
            if ("lock".equals(type) && !lock) {
                final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId, (Object)null, true);
                final String operatorName = UserUtil.getUser(sysAttMain.getFdPersonId()).getFdName();
                result.put((Object)"operatorName", (Object)operatorName);
            }
            if ("lock".equals(type) && lock) {
                final HQLInfo hql = new HQLInfo();
                hql.setWhereBlock("sysAttachmentWps.sysAttMainId=:sysAttMainId and sysAttachmentWps.userId=:userId");
                hql.setParameter("sysAttMainId", (Object)fdId);
                hql.setParameter("userId", (Object)UserUtil.getUser().getFdId());
                final Object obj = this.getSysAttachmentWpsServiceImp(request).findFirstOne(hql);
                final Date time = DbUtils.getDbTime();
                if (obj == null) {
                    final SysAttachmentWps sysAttachmentWps = new SysAttachmentWps();
                    sysAttachmentWps.setUserId(UserUtil.getUser().getFdId());
                    sysAttachmentWps.setSysAttMainId(fdId);
                    sysAttachmentWps.setDocAlterTime(time);
                    sysAttachmentWps.setFdHeartTime(time);
                    this.getSysAttachmentWpsServiceImp(request).add((IBaseModel)sysAttachmentWps);
                }
                else {
                    final SysAttachmentWps sysAttachmentWps = (SysAttachmentWps)obj;
                    sysAttachmentWps.setDocAlterTime(time);
                    sysAttachmentWps.setFdHeartTime(time);
                    this.getSysAttachmentWpsServiceImp(request).update((IBaseModel)sysAttachmentWps);
                }
            }
        }
        catch (final Exception e) {
            SysAttMainAction.logger.error("WPS加载项客户端编辑控制异常：", e);
            return null;
        }
        finally {
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().write(result.toString());
        }
        response.setContentType("application/json;charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        response.getWriter().write(result.toString());
        return null;
    }
    
    public ActionForward heartWpsOaassist(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        boolean hearts = false;
        final com.alibaba.fastjson.JSONObject result = new com.alibaba.fastjson.JSONObject();
        try {
            final com.alibaba.fastjson.JSONObject params = new com.alibaba.fastjson.JSONObject();
            params.put("fdId", (Object)request.getParameter("fdId"));
            hearts = SysAttachmentWpsAddonsLockUtils.hearts(params);
        }
        catch (final Exception e) {
            SysAttMainAction.logger.error("WPS加载项心跳异常", e);
        }
        result.put("success", (Object)hearts);
        response.setContentType("application/json;charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        response.getWriter().write(result.toString());
        return null;
    }
    
    public ActionForward uploadWpsOaassist(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdId = request.getParameter("fdId");
        final String useId = request.getParameter("useId");
        boolean ishas = false;
        TimeCounter.logCurrentTime("uploadWpsOaassist", true, (Class)this.getClass());
        final boolean redis = RedisConfig.ENABLED;
        if (redis) {
            ishas = RedisCommands.getInstance().exists("wps_oasisst_redis_" + useId + "_" + fdId);
        }
        else {
            final HQLInfo hql = new HQLInfo();
            hql.setWhereBlock("sysAttachmentWps.sysAttMainId=:sysAttMainId and sysAttachmentWps.userId=:userId");
            hql.setParameter("sysAttMainId", (Object)fdId);
            hql.setParameter("userId", (Object)useId);
            final Object obj = this.getSysAttachmentWpsServiceImp(request).findFirstOne(hql);
            if (obj != null) {
                final SysAttachmentWps sysAttachmentWps = (SysAttachmentWps)obj;
                final long expires = DbUtils.getDbTimeMillis();
                if (expires <= sysAttachmentWps.getExpirationTime().getTime()) {
                    ishas = true;
                }
            }
        }
        final JSONObject json = new JSONObject();
        SysAttMainAction.logger.info("fdId:" + fdId + "\n  useId:" + useId);
        SysAttMainAction.logger.info("redis has value:" + ishas);
        if (!ishas) {
            final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
            final Map<String, String> params = new HashMap<String, String>();
            params.put("fdId", fdId);
            params.put("modelId", sysAttMain.getFdModelId());
            params.put("modelName", sysAttMain.getFdModelName());
            params.put("fdKey", sysAttMain.getFdKey());
            params.put("userId", useId);
            params.put("type", "unlock");
            SysAttachmentWpsAddonsLockUtils.handle((Map)params);
            json.put((Object)"flag", (Object)"error");
            json.put((Object)"message", (Object)"ekp会话已过期");
            response.getWriter().append(json.toString());
            response.getWriter().flush();
            response.getWriter().close();
            return null;
        }
        Label_0873: {
            if (StringUtil.isNotNull(fdId) && StringUtil.isNotNull(useId)) {
                SysAttMainAction.logger.info("startSave");
                final MultipartHttpServletRequest multipartHttpServletRequest = (MultipartHttpServletRequest)request;
                final MultipartFile multipartFile = multipartHttpServletRequest.getFile("file");
                final InputStream is = null;
                try {
                    final InputStream in = multipartFile.getInputStream();
                    final SysAttMain sysAttMain2 = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
                    SysAttMainAction.logger.info("附件FdfileId:" + sysAttMain2.getFdFileId());
                    sysAttMain2.setInputStream(in);
                    this.getServiceImp(request).updateByUser((IBaseModel)sysAttMain2, useId);
                    json.put((Object)"flag", (Object)"ok");
                    SysAttMainAction.logger.info("修改后的附件FdfileId:" + sysAttMain2.getFdFileId());
                    if (SysAttWpsCloudUtil.isEnable()) {
                        SysAttMainAction.logger.info("进入云文档:" + sysAttMain2.getFdFileId());
                        SysAttWpsCloudUtil.syncAttToAddByMainId(fdId);
                    }
                    SysAttMainAction.logger.info("确认修改后的附件FdfileId:" + sysAttMain2.getFdFileId());
                    final HQLInfo hql2 = new HQLInfo();
                    hql2.setWhereBlock("sysAttachmentWps.sysAttMainId=:sysAttMainId and sysAttachmentWps.userId=:userId");
                    hql2.setParameter("sysAttMainId", (Object)fdId);
                    hql2.setParameter("userId", (Object)useId);
                    final Object obj2 = this.getSysAttachmentWpsServiceImp(request).findFirstOne(hql2);
                    if (obj2 != null) {
                        final SysAttachmentWps sysAttachmentWps2 = (SysAttachmentWps)obj2;
                        sysAttachmentWps2.setDocAlterTime(DbUtils.getDbTime());
                        this.getSysAttachmentWpsServiceImp(request).update((IBaseModel)sysAttachmentWps2);
                    }
                }
                catch (final Exception e) {
                    SysAttMainAction.logger.error("WPS加载项保存失败, sysAttMainId={}, useId={}", fdId, useId, e);
                    json.put((Object)"flag", (Object)"error");
                    json.put((Object)"message", (Object)"保存失败");
                    break Label_0873;
                }
                finally {
                    if (is != null) {
                        is.close();
                    }
                }
                if (is != null) {
                    is.close();
                }
            }
            else {
                json.put((Object)"flag", (Object)"error");
                json.put((Object)"message", (Object)"参数错误");
            }
        }
        TimeCounter.logCurrentTime("uploadWpsOaassist", true, (Class)this.getClass());
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward uploadWps(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdId = request.getParameter("fdId");
        TimeCounter.logCurrentTime("uploadWps", true, (Class)this.getClass());
        final JSONObject json = new JSONObject();
        SysAttMainAction.logger.info("fdId:" + fdId);
        Label_0369: {
            if (StringUtil.isNotNull(fdId)) {
                SysAttMainAction.logger.info("startSaveWps");
                final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
                InputStream is = null;
                MultipartFile multipartFile = null;
                if (this.isPpt(sysAttMain.getFdFileName())) {
                    is = (InputStream)request.getInputStream();
                }
                else {
                    final MultipartHttpServletRequest multipartHttpServletRequest = (MultipartHttpServletRequest)request;
                    if (this.isWord(sysAttMain.getFdFileName())) {
                        multipartFile = multipartHttpServletRequest.getFile("file");
                    }
                    if (this.isExcel(sysAttMain.getFdFileName())) {
                        multipartFile = multipartHttpServletRequest.getFile("filedata");
                    }
                }
                try {
                    if (this.isPpt(sysAttMain.getFdFileName())) {
                        sysAttMain.setInputStream(is);
                    }
                    else {
                        is = multipartFile.getInputStream();
                        sysAttMain.setInputStream(is);
                    }
                    this.getServiceImp(request).updateByUser((IBaseModel)sysAttMain, UserUtil.getUser().getFdId());
                    json.put((Object)"flag", (Object)"ok");
                    if (SysAttWpsCloudUtil.isEnable()) {
                        SysAttWpsCloudUtil.syncAttToAddByMainId(fdId);
                    }
                }
                catch (final Exception e) {
                    e.printStackTrace();
                    json.put((Object)"flag", (Object)"error");
                    json.put((Object)"message", (Object)"保存失败");
                    break Label_0369;
                }
                finally {
                    if (is != null) {
                        is.close();
                    }
                }
                if (is != null) {
                    is.close();
                }
            }
            else {
                json.put((Object)"flag", (Object)"error");
                json.put((Object)"message", (Object)"参数错误");
            }
        }
        TimeCounter.logCurrentTime("uploadWps", true, (Class)this.getClass());
        if ("error".equals(json.get((Object)"flag"))) {
            SysAttMainAction.logger.error("uploadWps方法保存失败！");
        }
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward uploadWpsTmp(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdId = request.getParameter("fdId");
        final String uuId = request.getParameter("uuId");
        TimeCounter.logCurrentTime("uploadWpsTmp", true, (Class)this.getClass());
        final JSONObject json = new JSONObject();
        SysAttMainAction.logger.info("fdId:" + fdId);
        SysAttMainAction.logger.info("uuId:" + uuId);
        Label_0457: {
            if (StringUtil.isNotNull(fdId)) {
                SysAttMainAction.logger.info("startSaveWpsTmp");
                final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
                InputStream is = null;
                MultipartFile multipartFile = null;
                final MultipartHttpServletRequest multipartHttpServletRequest = (MultipartHttpServletRequest)request;
                if (this.isWord(sysAttMain.getFdFileName())) {
                    multipartFile = multipartHttpServletRequest.getFile("file");
                }
                try {
                    is = multipartFile.getInputStream();
                    final SysAttMain attMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(uuId);
                    if (attMain == null) {
                        final SysAttMain tmpAtt = new SysAttMain();
                        tmpAtt.setFdId(uuId);
                        tmpAtt.setInputStream(is);
                        tmpAtt.setFdModelId("");
                        tmpAtt.setFdModelName("");
                        tmpAtt.setFdKey("tmpWpsOaassist");
                        final double fileSize = is.available();
                        tmpAtt.setFdSize(Double.valueOf(fileSize));
                        tmpAtt.setFdAttType("office");
                        tmpAtt.setFdFileName(sysAttMain.getFdFileName());
                        tmpAtt.setFdContentType(sysAttMain.getFdContentType());
                        tmpAtt.setFdUploadTime(new Date());
                        this.getServiceImp(request).add((IBaseModel)tmpAtt);
                    }
                    else {
                        attMain.setInputStream(is);
                        this.getServiceImp(request).updateByUser((IBaseModel)attMain, UserUtil.getUser().getFdId());
                    }
                    json.put((Object)"flag", (Object)"ok");
                }
                catch (final Exception e) {
                    e.printStackTrace();
                    json.put((Object)"flag", (Object)"error");
                    json.put((Object)"message", (Object)"保存失败");
                    break Label_0457;
                }
                finally {
                    if (is != null) {
                        is.close();
                    }
                }
                if (is != null) {
                    is.close();
                }
            }
            else {
                json.put((Object)"flag", (Object)"error");
                json.put((Object)"message", (Object)"参数错误");
            }
        }
        TimeCounter.logCurrentTime("uploadWpsTmp", true, (Class)this.getClass());
        if ("error".equals(json.get((Object)"flag"))) {
            SysAttMainAction.logger.error("uploadWpsTmp方法保存失败！");
        }
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward uploadWpsByTmp(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String editonlineFdId = request.getParameter("editonlineFdId");
        final String editonlineTmpFdId = request.getParameter("editonlineTmpFdId");
        TimeCounter.logCurrentTime("uploadWpsByTmp", true, (Class)this.getClass());
        final JSONObject json = new JSONObject();
        SysAttMainAction.logger.info("editonlineFdId:" + editonlineFdId);
        SysAttMainAction.logger.info("editonlineTmpFdId:" + editonlineTmpFdId);
        json.put((Object)"flag", (Object)"error");
        try {
            this.getServiceImp(request).updateByTmpAttmainId(editonlineFdId, editonlineTmpFdId);
            json.put((Object)"flag", (Object)"ok");
        }
        catch (final Exception e) {
            e.printStackTrace();
            json.put((Object)"flag", (Object)"error");
            json.put((Object)"message", (Object)"保存失败");
        }
        TimeCounter.logCurrentTime("uploadWpsByTmp", true, (Class)this.getClass());
        if ("error".equals(json.get((Object)"flag"))) {
            SysAttMainAction.logger.error("uploadWpsByTmp方法保存失败！");
        }
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward checkWpsOaassist(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdId = request.getParameter("fdId");
        final String useId = request.getParameter("useId");
        final JSONObject json = new JSONObject();
        if (StringUtil.isNotNull(fdId) && StringUtil.isNotNull(useId)) {
            final boolean redis = RedisConfig.ENABLED;
            if (redis) {
                final boolean ishas = RedisCommands.getInstance().exists("wps_oasisst_redis_" + useId + "_" + fdId);
                if (ishas) {
                    json.put((Object)"flag", (Object)"ok");
                }
                else {
                    json.put((Object)"flag", (Object)"error");
                    json.put((Object)"message", (Object)"ekp会话已过期");
                }
            }
            else {
                final HQLInfo hql = new HQLInfo();
                hql.setWhereBlock("sysAttachmentWps.sysAttMainId=:sysAttMainId and sysAttachmentWps.userId=:userId");
                hql.setParameter("sysAttMainId", (Object)fdId);
                hql.setParameter("userId", (Object)useId);
                final Object obj = this.getSysAttachmentWpsServiceImp(request).findFirstOne(hql);
                if (obj == null) {
                    json.put((Object)"flag", (Object)"error");
                    json.put((Object)"message", (Object)"ekp会话已过期");
                }
                else {
                    final SysAttachmentWps sysAttachmentWps = (SysAttachmentWps)obj;
                    final long expires = DbUtils.getDbTimeMillis();
                    if (expires > sysAttachmentWps.getExpirationTime().getTime()) {
                        json.put((Object)"flag", (Object)"error");
                        json.put((Object)"message", (Object)"ekp会话已过期");
                    }
                    else {
                        json.put((Object)"flag", (Object)"ok");
                    }
                }
            }
        }
        else {
            json.put((Object)"flag", (Object)"error");
            json.put((Object)"message", (Object)"参数错误");
        }
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward listHistory(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-list", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        try {
            final String fdOriginId = request.getParameter("fdOriginId");
            if (!StringUtil.isNotNull(fdOriginId)) {
                return this.getActionForward("failure", mapping, form, request, response);
            }
            final String s_pageno = request.getParameter("pageno");
            String orderby = request.getParameter("orderby");
            final String ordertype = request.getParameter("ordertype");
            boolean isReserve = false;
            if (ordertype != null && "down".equalsIgnoreCase(ordertype)) {
                isReserve = true;
            }
            int pageno = 0;
            final int rowsize = 8;
            if (s_pageno != null && s_pageno.length() > 0 && Integer.parseInt(s_pageno) > 0) {
                pageno = Integer.parseInt(s_pageno);
            }
            if (StringUtil.isNotNull(orderby) && form instanceof IExtendForm) {
                final Class<?> modelClass = ((IExtendForm)form).getModelClass();
                if (modelClass != null) {
                    final String langFieldName = SysLangUtil.getLangFieldName(modelClass.getName(), orderby);
                    if (StringUtil.isNotNull(langFieldName)) {
                        orderby = langFieldName;
                    }
                }
            }
            if (isReserve) {
                orderby = String.valueOf(orderby) + " desc";
            }
            final HQLInfo hqlInfo = new HQLInfo();
            hqlInfo.setOrderBy(orderby);
            hqlInfo.setPageNo(pageno);
            hqlInfo.setRowSize(rowsize);
            hqlInfo.setWhereBlock("(sysAttMain.fdOriginId = :fdOriginId or sysAttMain.fdId = :fdOriginId) and sysAttMain.fdKey != :fdKey");
            hqlInfo.setParameter("fdOriginId", (Object)fdOriginId);
            hqlInfo.setParameter("fdKey", (Object)"WPSCenterSelfAttachment");
            hqlInfo.setOrderBy(this.getFindPageOrderBy(request, hqlInfo.getOrderBy()));
            final Page page = this.getServiceImp(request).findPage(hqlInfo);
            UserOperHelper.logFindAll(page.getList(), this.getServiceImp(request).getModelName());
            request.setAttribute("queryPage", (Object)page);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
        }
        TimeCounter.logCurrentTime("Action-list", false, (Class)this.getClass());
        if (messages.hasError()) {
            KmssReturnPage.getInstance(request).addMessages(messages).addButton(0).save(request);
            return this.getActionForward("failure", mapping, form, request, response);
        }
        return this.getActionForward("listHistory", mapping, form, request, response);
    }
    
    public ActionForward downloadPluginXml(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("downloadPluginXml", true, (Class)this.getClass());
        final String xml = this.getServiceImp(request).downloadPluginXml(request.getServletContext().getRealPath("/"));
        response.setContentType("text/xml");
        response.getOutputStream().write(xml.getBytes(StandardCharsets.UTF_8));
        TimeCounter.logCurrentTime("downloadPluginXml", false, (Class)this.getClass());
        return null;
    }
    
    public boolean isMobileRequest(final HttpServletRequest request) {
        return MobileUtil.isMobile(request);
    }
    
    public ActionForward getWpsOfficeViewParam(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        SysAttMainAction.logger.info("政务微信请WPS需要的参数");
        final KmssMessages messages = new KmssMessages();
        final String fdAttMainId = request.getParameter("fdAttMainId");
        final JSONObject json = new JSONObject();
        final SysAttMain sysAttMain = (SysAttMain)((ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService")).findByPrimaryKey(fdAttMainId);
        String downLoadUrl = "";
        if (sysAttMain == null) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        downLoadUrl = SysAttViewerUtil.getDownloadUrl(sysAttMain);
        if (SysAttMainAction.logger.isDebugEnabled()) {
            SysAttMainAction.logger.info("下载地址:" + downLoadUrl);
        }
        final String token = this.getSysAttachmentWpsAddinProvider().getToken();
        json.put((Object)"wpsoaassistToken", (Object)token);
        String urlPrefix = ResourceUtil.getKmssConfigString("kmss.urlPrefix");
        if (urlPrefix.endsWith("/")) {
            urlPrefix = urlPrefix.substring(0, urlPrefix.lastIndexOf("/"));
        }
        final String uploadUrl = String.valueOf(urlPrefix) + "/sys/attachment/uploadByWpsCallback.do?" + "useId=" + UserUtil.getUser().getFdId() + "&fdId=" + sysAttMain.getFdId() + "&wpsOasisstToken=" + token.toString();
        SysAttMainAction.logger.info("下载文件地址:" + downLoadUrl);
        SysAttMainAction.logger.info("上传文件地址:" + uploadUrl);
        try {
            final Map<String, String> map = new HashMap<String, String>();
            map.put("download_url", downLoadUrl);
            map.put("upload_url", uploadUrl);
            map.put("file_id", sysAttMain.getFdFileId());
            map.put("open_mode", "Normal");
            map.put("other", "");
            map.put("settings", "");
            final Map<String, String> resultMap = new HashMap<String, String>();
            json.putAll((Map)map);
            final byte[] param = Base64.encodeBase64(json.toString().getBytes());
            resultMap.put("param", new String(param));
            json.clear();
            json.putAll((Map)resultMap);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        if (messages.hasError()) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward uploadByWpsCallback(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdId = request.getParameter("fdId");
        final String useId = request.getParameter("useId");
        final JSONObject json = new JSONObject();
        SysAttMainAction.logger.info("fdId:" + fdId + "\n  useId:" + useId);
        Label_0272: {
            if (StringUtil.isNotNull(fdId) && StringUtil.isNotNull(useId)) {
                SysAttMainAction.logger.info("startSave");
                final MultipartHttpServletRequest multipartHttpServletRequest = (MultipartHttpServletRequest)request;
                final MultipartFile multipartFile = multipartHttpServletRequest.getFile("file");
                final InputStream is = null;
                try {
                    final InputStream in = multipartFile.getInputStream();
                    final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
                    sysAttMain.setInputStream(in);
                    this.getServiceImp(request).update((IBaseModel)sysAttMain);
                    json.put((Object)"flag", (Object)"ok");
                }
                catch (final Exception e) {
                    e.printStackTrace();
                    json.put((Object)"flag", (Object)"error");
                    json.put((Object)"message", (Object)"保存失败");
                    break Label_0272;
                }
                finally {
                    if (is != null) {
                        is.close();
                    }
                }
                if (is != null) {
                    is.close();
                }
            }
            else {
                json.put((Object)"flag", (Object)"error");
                json.put((Object)"message", (Object)"参数错误");
            }
        }
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward getWpsCloudViewParam(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final JSONObject json = new JSONObject();
        try {
            final String fdAttMainId = request.getParameter("fdAttMainId");
            final String fdMode = request.getParameter("mode");
            final net.sf.json.JSONObject result = SysAttWpsCloudUtil.getWpsCloudViewParam(fdAttMainId, fdMode);
            json.putAll((Map)result);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        if (messages.hasError()) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward findAttMains(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        List<SysAttMain> sysAttMains = null;
        final String fdKey = request.getParameter("fdKey");
        final String fdModelName = request.getParameter("fdModelName");
        final String modelId = request.getParameter("fdModelId");
        sysAttMains = this.getServiceImp(request).findByModelKey(fdModelName, modelId, fdKey);
        if (sysAttMains != null && sysAttMains.size() > 0) {
            final SysAttMain sysAttMain = sysAttMains.get(0);
            final JSONObject json = new JSONObject();
            json.put((Object)"attMainId", (Object)sysAttMain.getFdId());
            json.put((Object)"fdFileName", (Object)sysAttMain.getFdFileName());
            response.setCharacterEncoding("UTF-8");
            response.getWriter().append(json.toString());
            response.getWriter().flush();
            response.getWriter().close();
        }
        return null;
    }
    
    public ActionForward findAttMainInfos(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        List<SysAttMain> sysAttMains = null;
        final String fdKey = request.getParameter("fdKey");
        final String fdModelName = request.getParameter("fdModelName");
        final String modelId = request.getParameter("fdModelId");
        final String isEdit = request.getParameter("isEdit");
        sysAttMains = this.getServiceImp(request).findByModelKey(fdModelName, modelId, fdKey);
        if (sysAttMains != null && sysAttMains.size() > 0) {
            final Map<String, Boolean> convertedResult = SysAttViewerUtil.getConvertedResult((List)sysAttMains);
            final JSONArray array = new JSONArray();
            for (int i = 0; i < sysAttMains.size(); ++i) {
                final SysAttMain sysAttMain = sysAttMains.get(i);
                final JSONObject json = new JSONObject();
                json.put((Object)"fdId", (Object)sysAttMain.getFdId());
                json.put((Object)"fileName", (Object)sysAttMain.getFdFileName());
                json.put((Object)"fileType", (Object)sysAttMain.getFdContentType());
                json.put((Object)"fileSize", (Object)sysAttMain.getFdSize());
                json.put((Object)"fileKey", (Object)sysAttMain.getFdFileId());
                json.put((Object)"fileDownloadCount", (Object)sysAttMain.getDownloadSum());
                final boolean canCopy = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + sysAttMain.getFdId(), "GET");
                final boolean canPrint = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + sysAttMain.getFdId(), "GET");
                final boolean canDownload = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=download&fdId=" + sysAttMain.getFdId(), "GET");
                final boolean canRead = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=read&fdId=" + sysAttMain.getFdId(), "GET");
                final boolean canEdit = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=edit&" + ("true".equals(isEdit) ? "e" : "v") + "=true&fdId=" + sysAttMain.getFdId(), "GET");
                json.put((Object)"canCopy", (Object)canCopy);
                json.put((Object)"canPrint", (Object)canPrint);
                json.put((Object)"canDownload", (Object)canDownload);
                json.put((Object)"canRead", (Object)canRead);
                json.put((Object)"canEdit", (Object)canEdit);
                json.put((Object)"fdCreatorId", (Object)sysAttMain.getFdCreatorId());
                String viewPicHref = "/third/pda/attdownload.jsp?open=1";
                final String extensionName = FilenameUtils.getExtension(sysAttMain.getFdFileName());
                if (MobileUtil.getClientType(request) >= 6 && ("pic".equals(sysAttMain.getFdAttType()) || SysAttPicUtils.isImageType(extensionName))) {
                    final long timestamp = DbUtils.getDbTimeMillis();
                    viewPicHref = "/resource/pic/attachment.do?method=view";
                    viewPicHref = String.valueOf(viewPicHref) + "&t=" + String.valueOf(timestamp);
                    viewPicHref = String.valueOf(viewPicHref) + "&k=" + SysAttPicUtils.generate(String.valueOf(String.valueOf(timestamp)) + sysAttMain.getFdId());
                }
                json.put((Object)"viewPicHref", (Object)viewPicHref);
                if ("true".equals(isEdit)) {
                    Boolean hasViewer = Boolean.FALSE;
                    if ((SysAttViewerUtil.isConverted(sysAttMain) && sysAttMain.getFdContentType().indexOf("video") < 0) || sysAttMain.getFdContentType().indexOf("mp4") >= 0 || sysAttMain.getFdContentType().indexOf("m4v") >= 0 || sysAttMain.getFdContentType().indexOf("audio") >= 0) {
                        hasViewer = Boolean.TRUE;
                    }
                    json.put((Object)"hasViewer", (Object)hasViewer);
                }
                else {
                    Boolean hasViewer = Boolean.FALSE;
                    final String crKey = StringUtil.isNotNull(sysAttMain.getFdFileId()) ? sysAttMain.getFdFileId() : sysAttMain.getFdId();
                    final Boolean attCr = convertedResult.get(crKey);
                    String fileName = sysAttMain.getFdFileName();
                    if (StringUtil.isNotNull(fileName)) {
                        fileName = fileName.toLowerCase();
                        if ((attCr != null && attCr.equals(Boolean.TRUE) && sysAttMain.getFdContentType().indexOf("video") < 0) || fileName.indexOf("mp4") >= 0 || fileName.indexOf("m4v") >= 0 || fileName.indexOf("flv") >= 0 || fileName.indexOf("f4v") >= 0 || fileName.indexOf("ogg") >= 0 || fileName.indexOf("3gp") >= 0 || fileName.indexOf("avi") >= 0 || fileName.indexOf("wmv") >= 0 || fileName.indexOf("asx") >= 0 || fileName.indexOf("asf") >= 0 || fileName.indexOf("mpg") >= 0 || fileName.indexOf("mov") >= 0 || fileName.indexOf("rm") >= 0 || fileName.indexOf("rmvb") >= 0 || fileName.indexOf("wmv9") >= 0 || fileName.indexOf("wrf") >= 0 || fileName.indexOf("mkv") >= 0 || fileName.indexOf("ts") >= 0 || fileName.indexOf("vob") >= 0 || fileName.indexOf("webm") >= 0 || sysAttMain.getFdContentType().indexOf("audio") >= 0) {
                            hasViewer = Boolean.TRUE;
                        }
                    }
                    final String pcPreviewType = SysAttConfigUtil.getOnlineToolType();
                    final boolean attConvertEnable = SysFileStoreUtil.isAttConvertEnable();
                    if (attConvertEnable && "0".equals(pcPreviewType) && "3".equals(SysAttConfigUtil.getMobileOnlineToolType())) {
                        hasViewer = Boolean.TRUE;
                    }
                    json.put((Object)"hasViewer", (Object)hasViewer);
                }
                array.add((Object)json);
            }
            response.setCharacterEncoding("UTF-8");
            response.getWriter().append(array.toString());
            response.getWriter().flush();
            response.getWriter().close();
        }
        return null;
    }
    
    public ActionForward getAttMainRights(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        List<SysAttMain> sysAttMains = null;
        final String fdKey = request.getParameter("fdKey");
        final String fdModelName = request.getParameter("fdModelName");
        final String modelId = request.getParameter("fdModelId");
        final String isEdit = request.getParameter("isEdit");
        sysAttMains = this.getServiceImp(request).findByModelKey(fdModelName, modelId, fdKey);
        if (sysAttMains != null && sysAttMains.size() > 0) {
            final SysAttMain sysAttMain = sysAttMains.get(0);
            final JSONObject json = new JSONObject();
            final boolean canCopy = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + sysAttMain.getFdId(), "GET");
            final boolean canPrint = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + sysAttMain.getFdId(), "GET");
            final boolean canDownload = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=download&fdId=" + sysAttMain.getFdId(), "GET");
            final boolean canRead = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=read&fdId=" + sysAttMain.getFdId(), "GET");
            final boolean canEdit = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=edit&" + ("true".equals(isEdit) ? "e" : "v") + "=true&fdId=" + sysAttMain.getFdId(), "GET");
            json.put((Object)"canCopy", (Object)canCopy);
            json.put((Object)"canPrint", (Object)canPrint);
            json.put((Object)"canDownload", (Object)canDownload);
            json.put((Object)"canRead", (Object)canRead);
            json.put((Object)"canEdit", (Object)canEdit);
            final JSONObject downloadCount = new JSONObject();
            for (final SysAttMain attMain : sysAttMains) {
                downloadCount.put((Object)attMain.getFdId(), (Object)attMain.getDownloadSum());
            }
            json.put((Object)"fileDownloadCount", (Object)downloadCount);
            response.setCharacterEncoding("UTF-8");
            response.getWriter().append(json.toString());
            response.getWriter().flush();
            response.getWriter().close();
        }
        return null;
    }
    
    public ActionForward getAttMainOtherInfos(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdAttMainId = request.getParameter("fdId");
        final String isEdit = request.getParameter("isEdit");
        final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdAttMainId);
        if (sysAttMain != null) {
            final JSONObject json = new JSONObject();
            final boolean canCopy = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + sysAttMain.getFdId(), "GET");
            final boolean canPrint = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + sysAttMain.getFdId(), "GET");
            final boolean canDownload = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=download&fdId=" + sysAttMain.getFdId(), "GET");
            final boolean canRead = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=read&fdId=" + sysAttMain.getFdId(), "GET");
            final boolean canEdit = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=edit&" + ("true".equals(isEdit) ? "e" : "v") + "=true&fdId=" + sysAttMain.getFdId(), "GET");
            json.put((Object)"canCopy", (Object)canCopy);
            json.put((Object)"canPrint", (Object)canPrint);
            json.put((Object)"canDownload", (Object)canDownload);
            json.put((Object)"canRead", (Object)canRead);
            json.put((Object)"canEdit", (Object)canEdit);
            json.put((Object)"fdCreatorId", (Object)sysAttMain.getFdCreatorId());
            String viewPicHref = "/third/pda/attdownload.jsp?open=1";
            final String extensionName = FilenameUtils.getExtension(sysAttMain.getFdFileName());
            if (MobileUtil.getClientType(request) >= 6 && ("pic".equals(sysAttMain.getFdAttType()) || SysAttPicUtils.isImageType(extensionName))) {
                final long timestamp = DbUtils.getDbTimeMillis();
                viewPicHref = "/resource/pic/attachment.do?method=view";
                viewPicHref = String.valueOf(viewPicHref) + "&t=" + String.valueOf(timestamp);
                viewPicHref = String.valueOf(viewPicHref) + "&k=" + SysAttPicUtils.generate(String.valueOf(String.valueOf(timestamp)) + sysAttMain.getFdId());
            }
            json.put((Object)"viewPicHref", (Object)viewPicHref);
            if ("true".equals(isEdit)) {
                Boolean hasViewer = Boolean.FALSE;
                if ((SysAttViewerUtil.isConverted(sysAttMain) && sysAttMain.getFdContentType().indexOf("video") < 0) || sysAttMain.getFdContentType().indexOf("mp4") >= 0 || sysAttMain.getFdContentType().indexOf("m4v") >= 0 || sysAttMain.getFdContentType().indexOf("audio") >= 0) {
                    hasViewer = Boolean.TRUE;
                }
                json.put((Object)"hasViewer", (Object)hasViewer);
            }
            else {
                final List sysAttMains = new ArrayList();
                sysAttMains.add(sysAttMain);
                final Map<String, Boolean> convertedResult = SysAttViewerUtil.getConvertedResult(sysAttMains);
                Boolean hasViewer2 = Boolean.FALSE;
                final String crKey = StringUtil.isNotNull(sysAttMain.getFdFileId()) ? sysAttMain.getFdFileId() : sysAttMain.getFdId();
                final Boolean attCr = convertedResult.get(crKey);
                String fileName = sysAttMain.getFdFileName();
                if (StringUtil.isNotNull(fileName)) {
                    fileName = fileName.toLowerCase();
                    if ((attCr != null && attCr.equals(Boolean.TRUE) && sysAttMain.getFdContentType().indexOf("video") < 0) || fileName.indexOf("mp4") >= 0 || fileName.indexOf("m4v") >= 0 || fileName.indexOf("flv") >= 0 || fileName.indexOf("f4v") >= 0 || fileName.indexOf("ogg") >= 0 || fileName.indexOf("3gp") >= 0 || fileName.indexOf("avi") >= 0 || fileName.indexOf("wmv") >= 0 || fileName.indexOf("asx") >= 0 || fileName.indexOf("asf") >= 0 || fileName.indexOf("mpg") >= 0 || fileName.indexOf("mov") >= 0 || fileName.indexOf("rm") >= 0 || fileName.indexOf("rmvb") >= 0 || fileName.indexOf("wmv9") >= 0 || fileName.indexOf("wrf") >= 0 || fileName.indexOf("mkv") >= 0 || fileName.indexOf("ts") >= 0 || fileName.indexOf("vob") >= 0 || fileName.indexOf("webm") >= 0 || sysAttMain.getFdContentType().indexOf("audio") >= 0) {
                        hasViewer2 = Boolean.TRUE;
                    }
                }
                final String pcPreviewType = SysAttConfigUtil.getOnlineToolType();
                final boolean attConvertEnable = SysFileStoreUtil.isAttConvertEnable();
                if (attConvertEnable && "0".equals(pcPreviewType) && "3".equals(SysAttConfigUtil.getMobileOnlineToolType())) {
                    hasViewer2 = Boolean.TRUE;
                }
                json.put((Object)"hasViewer", (Object)hasViewer2);
            }
            response.setCharacterEncoding("UTF-8");
            response.getWriter().append(json.toString());
            response.getWriter().flush();
            response.getWriter().close();
        }
        return null;
    }
    
    public ActionForward getWpsoaassistConfig(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final JSONObject json = new JSONObject();
        try {
            final String onlineToolType = SysAttConfigUtil.getOnlineToolType();
            json.put((Object)"onlineToolType", (Object)onlineToolType);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        if (messages.hasError()) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    private ActionForward viewWpsPreviewLinux(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response, final SysAttMain attMain) throws Exception {
        final String url = "/sys/attachment/sys_att_main/downloadFile.jsp?fdId=" + attMain.getFdId() + "&reqType=rest&filename=" + URLEncoder.encode(attMain.getFdFileName(), "utf-8");
        final String convertId = WpsUtil.upFileToRemote(url, attMain.getFdId(), true);
        final String previewId = WpsUtil.convertFile(convertId, "");
        String wpsUrl = WpsUtil.configInfo("thirdWpsSetRedUrl");
        if (wpsUrl.endsWith("/")) {
            wpsUrl = wpsUrl.substring(0, wpsUrl.lastIndexOf("/"));
        }
        final String attMainId = attMain.getFdId();
        final String inner = request.getParameter("inner");
        final boolean canCopy = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=copy&fdId=" + attMainId, "GET");
        boolean canPrint = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=print&fdId=" + attMainId, "GET");
        boolean download = UserUtil.checkAuthentication("/sys/attachment/sys_att_main/sysAttMain.do?method=download&fdId=" + attMainId, "GET");
        if ("yes".equals(inner)) {
            download = false;
            canPrint = false;
        }
        final String requestUrl = String.valueOf(wpsUrl) + "/web/reader?file=" + URLEncoder.encode(previewId) + "&isPrint=" + canPrint + "&isDownload=" + download + "&isCopy=" + canCopy;
        request.setAttribute("wpsofd", (Object)"true");
        request.setAttribute("requestUrl", (Object)requestUrl);
        return mapping.findForward("viewonline_wps_cloud");
    }
    
    public ActionForward checkUseReadOLConfig(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        try {
            final JSONObject result = new JSONObject();
            Boolean flag = true;
            final String readOLConfig = SysAttConfigUtil.getReadOLConfig();
            if (StringUtils.isEmpty(readOLConfig) || "-1".equals(readOLConfig)) {
                flag = false;
            }
            else if (("3".equals(SysAttConfigUtil.getOnlineToolType()) && !SysAttWpsoaassistUtil.isWPSOAassistEmbed(request) && "1".equals(SysAttConfigUtil.getReadOLConfig())) || ("1".equals(SysAttConfigUtil.getReadOLConfig()) && "0".equals(SysAttConfigUtil.getOnlineToolType()))) {
                final String fdAttMainId = request.getParameter("fdId");
                final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdAttMainId);
                final String fdFileName = sysAttMain.getFdFileName();
                final boolean isJgRead = StringUtil.isNotNull(fdFileName) && (fdFileName.endsWith("txt") || fdFileName.endsWith("html"));
                if (!SysAttViewerUtil.isPicAtt(sysAttMain) && !isJgRead) {
                    request.setAttribute("fdAttMainId", (Object)fdAttMainId);
                    final boolean existViewPath = JgWebOffice.isExistViewPath(request);
                    if (!existViewPath) {
                        flag = false;
                    }
                }
            }
            result.put((Object)"flag", (Object)flag);
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().write(result.toString());
        }
        catch (final Exception ex) {}
        return null;
    }
    
    public ActionForward viewByWpsoAassistEmbed(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdAttMainId = request.getParameter("fdId");
        final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdAttMainId);
        final SysAttMainForm sysAttMainForm = new SysAttMainForm();
        BeanUtils.copyProperties((Object)sysAttMainForm, (Object)sysAttMain);
        request.setAttribute("sysAttMainForm", (Object)sysAttMainForm);
        return mapping.findForward("viewonline_wps_oaassist_linux");
    }
    
    public ActionForward checkOAassistView(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        try {
            if (!"POST".equals(request.getMethod())) {
                throw new UnexpectedRequestException();
            }
            final String fdId = request.getParameter("id");
            SysAttMain sysAttMain = null;
            final JSONObject result = new JSONObject();
            Boolean flag = true;
            if (SysAttWpsoaassistUtil.isEnable()) {
                flag = true;
            }
            else {
                if (fdId != null && fdId.trim().length() > 0) {
                    sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
                    if (sysAttMain != null) {
                        final List<SysFileViewerParam> convertedParamsList = SysAttViewerUtil.getConvertedParams(sysAttMain);
                        if (!ArrayUtil.isEmpty((List)convertedParamsList)) {
                            flag = false;
                        }
                    }
                }
                if (SysAttWpsCloudUtil.checkWpsPreviewIsLinux() || SysAttWpsCloudUtil.checkWpsPreviewIsWindows()) {
                    flag = false;
                }
            }
            result.put((Object)"flag", (Object)flag);
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().write(result.toString());
        }
        catch (final Exception ex) {}
        return null;
    }
    
    public ActionForward getPreViewType(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        try {
            final String fdId = request.getParameter("id");
            final JSONObject result = new JSONObject();
            Boolean flag = false;
            if (fdId != null && fdId.trim().length() > 0) {
                final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
                if (sysAttMain != null) {
                    flag = true;
                    final boolean isMoblie = this.isMobileRequest(request);
                    result.put((Object)"viewType", (Object)SysAttViewerUtil.getPreView(sysAttMain, isMoblie));
                }
            }
            result.put((Object)"flag", (Object)flag);
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().write(result.toString());
        }
        catch (final Exception ex) {}
        return null;
    }
    
    public ActionForward getWpsPreView(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        try {
            final String fdId = request.getParameter("fdId");
            final JSONObject result = new JSONObject();
            Boolean flag = false;
            String requestUrl = "";
            if (fdId != null && fdId.trim().length() > 0) {
                final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdId);
                if (sysAttMain != null) {
                    String viewType = null;
                    final String readOlCOnfig = SysAttConfigUtil.getReadOLConfig();
                    if ("2".equals(readOlCOnfig)) {
                        final Boolean isWindows = SysAttWpsCloudUtil.checkWpsPreviewIsWindows();
                        final Boolean isLinux = SysAttWpsCloudUtil.checkWpsPreviewIsLinux();
                        if (isLinux) {
                            flag = true;
                            requestUrl = SysAttWpsCloudUtil.getWpsLinuxPreviewUrl(fdId);
                            viewType = "linux";
                        }
                        else if (isWindows) {
                            flag = true;
                            requestUrl = SysAttWpsCloudUtil.getWpsWindowPreviewUrl(fdId);
                            viewType = "window";
                        }
                    }
                    else if ("4".equals(readOlCOnfig)) {
                        flag = true;
                        final com.alibaba.fastjson.JSONObject params = new com.alibaba.fastjson.JSONObject();
                        params.put("fdAttMainId", (Object)sysAttMain.getFdId());
                        params.put("waterMarkText", (Object)UserUtil.getKMSSUser().getUserName());
                        requestUrl = SysAttThirdProxyUtil.getViewUrl("dianju", params).getData().getString("url");
                        viewType = "dianju";
                    }
                    result.put((Object)"viewType", (Object)viewType);
                }
            }
            result.put((Object)"flag", (Object)flag);
            result.put((Object)"requestUrl", (Object)requestUrl);
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().write(result.toString());
        }
        catch (final Exception ex) {}
        return null;
    }
    
    public ActionForward addCenterOnlineFile(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-addCenterOnlineFile", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        String mobileEditAttId = "";
        final JSONObject json = new JSONObject();
        response.setCharacterEncoding("UTF-8");
        response.setContentType("application/json; charset=utf-8");
        try {
            SysAttMain originalAtt = null;
            originalAtt = this.getServiceImp(request).addWpsCenterOnlineFile(request);
            if (originalAtt != null) {
                mobileEditAttId = originalAtt.getFdId();
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
            json.put((Object)"error", (Object)e);
            response.getWriter().append(json.toString());
            response.getWriter().flush();
            response.getWriter().close();
            return null;
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-addCenterOnlineFile", false, (Class)this.getClass());
        json.put((Object)"editOnlineAttId", (Object)mobileEditAttId);
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward getWpsCenterViewAndEditUrl(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-getWpsCenterViewAndEditUrl", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        final JSONObject json = new JSONObject();
        try {
            final String fdAttMainId = request.getParameter("fdAttMainId");
            final String fdMode = request.getParameter("fdMode");
            if ("write".equals(fdMode)) {
                final net.sf.json.JSONObject result = SysAttWpsCenterUtil.getWpsCenterEditUrl(request);
                result.put((Object)"wpsCenterToken", (Object)SysAttWpsCenterUtil.getWpsToken());
                json.putAll((Map)result);
            }
            else if ("read".equals(fdMode)) {
                final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp(request).findByPrimaryKey(fdAttMainId);
                net.sf.json.JSONObject result2;
                if (sysAttMain.getFdModelName() != null && sysAttMain.getFdModelName().startsWith("com.landray.kmss.kms.cooperate.model")) {
                    result2 = SysAttWpsCenterUtil.getWpsCenterViewAndEditUrl(fdAttMainId, fdMode);
                }
                else {
                    result2 = SysAttWpsCenterUtil.getWpsCenterPreviewUrl(fdAttMainId, fdMode);
                }
                result2.put((Object)"wpsCenterToken", (Object)SysAttWpsCenterUtil.getWpsToken());
                json.putAll((Map)result2);
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-getWpsCenterViewAndEditUrl", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward getLongToken4WpsCenter(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final JSONObject json = new JSONObject();
        try {
            final String token = SysAttWpsCenterUtil.getLongCallBackToken();
            final Long timeout = SysAttWpsCenterUtil.getLongTokenTimeOut() / 3L;
            json.put((Object)"token", (Object)token);
            json.put((Object)"timeout", (Object)timeout);
            json.put((Object)"success", (Object)true);
        }
        catch (final Exception e) {
            SysAttMainAction.logger.error("刷新WPS中台LongToken失败", e);
            json.put((Object)"success", (Object)false);
        }
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward testAction(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-getWpsCenterPreviewUrl", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        final JSONObject json = new JSONObject();
        try {
            final ISysAttachmentWpsCenterOfficeProvider provider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
            final List<Map<String, Object>> fileInfos = new ArrayList<Map<String, Object>>();
            final Map<String, Object> fileInfo = new HashMap<String, Object>();
            fileInfo.put("templateId", "179ad85bc077a9f0c9ec5e84a0e94f89");
            fileInfo.put("templateName", "template.docx");
            fileInfos.add(fileInfo);
            final List<Map<String, Object>> fillDatas = new ArrayList<Map<String, Object>>();
            final Map<String, Object> fillData = new HashMap<String, Object>();
            fillData.put("type", "1");
            fillData.put("bookmark", "redhead");
            fillData.put("sampleId", "179ad9699164b90f488e36d4d61bae8b");
            fillData.put("sampleName", "content.docx");
            fillDatas.add(fillData);
            final Map<String, Object> fillData2 = new HashMap<String, Object>();
            fillData2.put("type", "0");
            fillData2.put("bookmark", "redhead1");
            fillData2.put("content", "999999999999999955566666666666");
            fillDatas.add(fillData2);
            final Map<String, Object> fillData3 = new HashMap<String, Object>();
            fillData3.put("type", "0");
            fillData3.put("bookmark", "redhead2");
            fillData3.put("content", "中方20rrrr");
            fillDatas.add(fillData3);
            final Map<String, Object> fillData4 = new HashMap<String, Object>();
            fillData4.put("type", "0");
            fillData4.put("bookmark", "bookflag");
            fillData4.put("content", "中文件20ppppppp");
            fillDatas.add(fillData4);
            final String taskId = provider.wpsCenterWrapHeader((List)fileInfos, (List)fillDatas, (String)null, (String)null, (String)null, (String)null, (String)null);
            Thread.sleep(1000L);
            final String downloadId = provider.queryTask(taskId);
            provider.download(downloadId, "D:\\temp\\0525\\wrap0528-1.docx");
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        TimeCounter.logCurrentTime("Action-getWpsCenterPreviewUrl", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public ActionForward uploadToEkp(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        if (!"POST".equals(request.getMethod())) {
            throw new UnexpectedRequestException();
        }
        final String fileName = request.getParameter("fileName");
        final String fileNameSign = request.getParameter("fdSign");
        if (!this.isTypeValid(fileName)) {
            response.getWriter().print("基于安全考虑，不允许上传该附件！");
            return null;
        }
        if (!this.isSignValid(fileName, fileNameSign)) {
            response.getWriter().print("附件签名不符，基于安全考虑，不允许上传该附件！");
            return null;
        }
        if (!this.checkToken(request.getParameter("token"))) {
            response.getWriter().print("附件上传操作超时，基于安全考虑，不允许上传该附件！");
            return null;
        }
        final String key = request.getParameter("key");
        request.getParameter("fileType");
        final String fdKey = request.getParameter("fdKey");
        final String fdModelId = request.getParameter("fdModelId");
        final String fdModelName = request.getParameter("fdModelName");
        final String fdFileName = request.getParameter("fileName");
        final String fdFileSize = request.getParameter("fileSize");
        final String fdFileType = request.getParameter("fileType");
        final String fdAttType = request.getParameter("fdAttType");
        final net.sf.json.JSONObject jsonObject = new net.sf.json.JSONObject();
        jsonObject.put((Object)"key", (Object)key);
        jsonObject.put((Object)"code", (Object)request.getParameter("code"));
        jsonObject.put((Object)"spaceId", (Object)request.getParameter("spaceId"));
        jsonObject.put((Object)"fileId", (Object)request.getParameter("fileId"));
        jsonObject.put((Object)"fileType", (Object)fdFileType);
        if (StringUtil.isNotNull(key) && this.getProviderMap().containsKey(key)) {
            final ISysAttachmentTransmissionProvider provider = this.getProviderMap().get(key);
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            final String contentType = FileMimeTypeUtil.getContentType(fdFileName);
            jsonObject.put((Object)"fdAttId", (Object)IDGenerator.generateID());
            jsonObject.put((Object)"fileName", (Object)fdFileName);
            jsonObject.put((Object)"fileSize", (Object)fdFileSize);
            jsonObject.put((Object)"fdKey", (Object)fdKey);
            jsonObject.put((Object)"fdAttType", (Object)fdAttType);
            jsonObject.put((Object)"fdModelId", (Object)fdModelId);
            jsonObject.put((Object)"fdModelName", (Object)fdModelName);
            jsonObject.put((Object)"contentType", (Object)contentType);
            jsonObject.put((Object)"userId", (Object)UserUtil.getKMSSUser().getUserId());
            provider.uploadToEkp(jsonObject);
            response.getWriter().write(jsonObject.toString());
            return null;
        }
        return null;
    }
    
    private boolean isTypeValid(final String fileName) {
        String _fileType = null;
        if (fileName.indexOf(".") > -1) {
            _fileType = fileName.substring(fileName.lastIndexOf("."));
        }
        if (StringUtil.isNotNull(_fileType)) {
            _fileType = _fileType.toLowerCase();
            final String[] files = this.getDisabledFileType().split("[;；]");
            if ("1".equals(this.getFileLimitType())) {
                Boolean isPass = true;
                String[] array;
                for (int length = (array = files).length, i = 0; i < length; ++i) {
                    final String f = array[i];
                    if (_fileType.equals(f)) {
                        isPass = false;
                        break;
                    }
                }
                if (!isPass) {
                    return false;
                }
            }
            else if ("2".equals(this.getFileLimitType())) {
                Boolean isPass = false;
                String[] array2;
                for (int length2 = (array2 = files).length, j = 0; j < length2; ++j) {
                    final String f = array2[j];
                    if (_fileType.equals(f)) {
                        isPass = true;
                        break;
                    }
                }
                if (!isPass) {
                    return false;
                }
            }
        }
        return true;
    }
    
    private boolean isSignValid(final String fileName, final String fileNameSign) throws UnsupportedEncodingException {
        String namesign = new String(Base64.encodeBase64(fileName.getBytes("utf-8")), "UTF-8");
        namesign = namesign.replaceAll("\\+", "");
        namesign = namesign.replaceAll("\\/", "");
        namesign = namesign.replaceAll("\\=", "");
        return !StringUtil.isNull(fileNameSign) && fileNameSign.equals(namesign);
    }
    
    private boolean checkToken(final String token) throws Exception {
        if (StringUtils.isEmpty(token)) {
            return false;
        }
        final long curTimestamp = this.getAttUploadService().getCurTimestamp().getTime();
        final String fileInfo = SysAttCryptUtil.decrypt(token);
        StringUtil.getParameter(fileInfo, "md5");
        StringUtil.getParameter(fileInfo, "filesize");
        final String timestamp = StringUtil.getParameter(fileInfo, "time");
        return Long.valueOf(timestamp) >= curTimestamp - 60000L;
    }
    
    public ActionForward delFileRelation(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final JSONObject result = new JSONObject();
        Boolean flag = false;
        try {
            final String fdId = request.getParameter("fdId");
            flag = this.getServiceImp(request).updateDelRelation(fdId);
            result.put((Object)"flag", (Object)flag);
        }
        catch (final Exception ex) {
            result.put((Object)"flag", (Object)flag);
        }
        response.setContentType("application/json;charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        response.getWriter().write(result.toString());
        return null;
    }
    
    public ActionForward getUseWpsLinuxView(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        try {
            if (!"POST".equals(request.getMethod())) {
                throw new UnexpectedRequestException();
            }
            final JSONObject result = new JSONObject();
            Boolean flag = false;
            if (SysAttWpsCloudUtil.getUseWpsLinuxView()) {
                flag = true;
            }
            result.put((Object)"flag", (Object)flag);
            response.setContentType("application/json;charset=utf-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().write(result.toString());
        }
        catch (final Exception e) {
            e.printStackTrace();
            SysAttMainAction.logger.error("getUseWpsLinuxView错误信息", e);
        }
        return null;
    }
    
    public void dianjuFormat(final HttpServletRequest request, final SysAttMain sysAttMain) {
        try {
            final String downloadUrl = SysAttViewerUtil.getDownloadUrl(sysAttMain);
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.info("下载地址:" + downloadUrl);
            }
            request.setAttribute("downloadUrl", (Object)downloadUrl);
            request.setAttribute("attMainId", (Object)sysAttMain.getFdId());
            request.setAttribute("attMainFileName", (Object)sysAttMain.getFdFileName());
        }
        catch (final Exception e) {
            SysAttMainAction.logger.error("点聚版式阅读异常：{}", e);
        }
    }
    
    public ActionForward getAttMainViewUrl(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final KmssMessages messages = new KmssMessages();
        final String fdAttMainId = request.getParameter("fdAttMainId");
        final JSONObject json = new JSONObject();
        final SysAttMain sysAttMain = (SysAttMain)((ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService")).findByPrimaryKey(fdAttMainId);
        final String downLoadUrl = "";
        if (sysAttMain == null) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        final String downloadUrl = SysAttViewerUtil.getDownloadUrl(sysAttMain);
        if (SysAttMainAction.logger.isDebugEnabled()) {
            SysAttMainAction.logger.info("下载地址:" + downloadUrl);
        }
        try {
            json.put((Object)"downloadUrl", (Object)downLoadUrl);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        if (messages.hasError()) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        response.setContentType("application/json;charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        response.getWriter().write(json.toString());
        return null;
    }
    
    private Boolean isWord(final String filename) {
        Boolean mark = false;
        final String ext = FilenameUtils.getExtension(filename);
        if ("doc".equals(ext.toLowerCase()) || "docx".equals(ext.toLowerCase()) || "wps".equals(ext.toLowerCase())) {
            mark = true;
        }
        return mark;
    }
    
    private Boolean isExcel(final String filename) {
        Boolean mark = false;
        final String ext = FilenameUtils.getExtension(filename);
        if ("xls".equals(ext.toLowerCase()) || "xlsx".equals(ext.toLowerCase()) || "et".equals(ext.toLowerCase())) {
            mark = true;
        }
        return mark;
    }
    
    private Boolean isPpt(final String filename) {
        Boolean mark = false;
        final String ext = FilenameUtils.getExtension(filename);
        if ("ppt".equals(ext.toLowerCase()) || "pptx".equals(ext.toLowerCase()) || "dps".equals(ext.toLowerCase())) {
            mark = true;
        }
        return mark;
    }
    
    public ActionForward getParamForDing(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        if (SysAttMainAction.logger.isDebugEnabled()) {
            SysAttMainAction.logger.debug("钉钉唤起WPS");
        }
        final KmssMessages messages = new KmssMessages();
        final String fdAttMainId = request.getParameter("fdAttMainId");
        final JSONObject json = new JSONObject();
        final SysAttMain sysAttMain = (SysAttMain)((ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService")).findByPrimaryKey(fdAttMainId);
        if (sysAttMain == null) {
            if (SysAttMainAction.logger.isDebugEnabled()) {
                SysAttMainAction.logger.debug("钉钉唤起WSP失败：附件为空！");
            }
            return this.getActionForward("failure", mapping, form, request, response);
        }
        final String downloadUrl = SysAttViewerUtil.getDownloadUrl(sysAttMain);
        final String uploadUri = SysAttViewerUtil.getUploadUrl(sysAttMain);
        final String wpsSerNum = WpsUtil.configInfo("wpsSerNum");
        if (SysAttMainAction.logger.isDebugEnabled()) {
            SysAttMainAction.logger.debug("钉钉唤起WPS信息：下载地址:{},上传文件地址:{},fileId:{},fileName:{}, wpsSerNum:{}", downloadUrl, uploadUri, sysAttMain.getFdId(), sysAttMain.getFdFileName(), wpsSerNum);
        }
        try {
            json.put((Object)"downloadUri", (Object)downloadUrl);
            json.put((Object)"fileId", (Object)sysAttMain.getFdId());
            json.put((Object)"fileName", (Object)sysAttMain.getFdFileName());
            json.put((Object)"wpsSerNum", (Object)wpsSerNum);
            json.put((Object)"uploadUri", (Object)uploadUri);
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            e.printStackTrace();
        }
        if (SysAttMainAction.logger.isDebugEnabled()) {
            SysAttMainAction.logger.debug("钉钉唤起WPS信息JSON：{}", json.toString());
        }
        KmssReturnPage.getInstance(request).addMessages(messages).addButton(1).save(request);
        if (messages.hasError()) {
            return this.getActionForward("failure", mapping, form, request, response);
        }
        TimeCounter.logCurrentTime("Action-generateFile", false, (Class)this.getClass());
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    public String getSignDownload(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        final String fdAttMainId = request.getParameter("fdAttMainId");
        final String downloadFileType = request.getParameter("downloadFileType");
        final String convertType = request.getParameter("convertType");
        final String fdFileName = request.getParameter("fdFileName");
        final JSONObject json = new JSONObject();
        final SysAttMain sysAttMain = (SysAttMain)((ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService")).findByPrimaryKey(fdAttMainId);
        String downLoadUrl = "";
        String urlPrefix = ResourceUtil.getKmssConfigString("kmss.urlPrefix");
        if (urlPrefix.endsWith("/")) {
            urlPrefix = urlPrefix.substring(0, urlPrefix.lastIndexOf("/"));
        }
        SysAttMainAction.logger.info("系统地址:" + urlPrefix);
        if (sysAttMain != null) {
            final long expires = System.currentTimeMillis() + 60000L;
            final String sign = SysAttUtil.getRestSign(sysAttMain.getFdId(), expires);
            if (StringUtil.isNotNull(sign)) {
                downLoadUrl = String.valueOf(urlPrefix) + "/sys/attachment/sys_att_main/downloadFile.jsp?fdId=" + sysAttMain.getFdId() + "&Expires=" + expires + "&Signature=" + sign + "&reqType=rest&filename=" + URLEncoder.encode(sysAttMain.getFdFileName(), "utf-8");
                if (StringUtil.isNotNull(downloadFileType)) {
                    downLoadUrl = String.valueOf(downLoadUrl) + "&downloadFileType=" + downloadFileType;
                }
                if (StringUtil.isNotNull(convertType)) {
                    downLoadUrl = String.valueOf(downLoadUrl) + "&convertType=" + convertType;
                }
                if (StringUtil.isNotNull(fdFileName)) {
                    downLoadUrl = String.valueOf(downLoadUrl) + "&fdFileName=" + fdFileName;
                }
                json.put((Object)"hasAtt", (Object)true);
                json.put((Object)"hasRest", (Object)true);
                json.put((Object)"downloadUrl", (Object)downLoadUrl);
            }
            else {
                json.put((Object)"hasAtt", (Object)true);
                json.put((Object)"hasRest", (Object)false);
            }
        }
        else {
            json.put((Object)"hasAtt", (Object)false);
        }
        TimeCounter.logCurrentTime("Action-getSignDownload", false, (Class)this.getClass());
        response.setContentType("application/json;charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        response.getWriter().append(json.toString());
        response.getWriter().flush();
        response.getWriter().close();
        return null;
    }
    
    protected class Range
    {
        long start;
        long end;
        long length;
        long total;
        
        public Range(final long start, final long end, final long total) {
            this.start = start;
            this.end = end;
            this.length = end - start + 1L;
            this.total = total;
        }
    }
}
